commit 2ec7636630df1ed405179e66fe7c5dad4b533496
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Fri Aug 7 16:48:18 2015 -0600

    server: HTTP: restrict pipeline request as keepalive requests
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 4723dac02f6d0dc62c5985833b286c2ed3817e3b
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Fri Aug 7 12:14:57 2015 -0600

    server: HTTP parser: make parser_more() check static inline
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 49760cddbc41c5c8147fb3e0201943a296c5df71
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Fri Aug 7 12:14:23 2015 -0600

    server: scheduler: let protocol handlers decide if they want to process more data upon channel_done
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 2e2fdb5117f7a33a2b872fa9805b49e53d54c7e9
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Fri Aug 7 12:13:41 2015 -0600

    server: HTTP: reset errno for connection problems and re-enable pipeline support
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 5a64dff41dd030864e4c2c03b0da43e9e69e1c8a
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Fri Aug 7 11:29:11 2015 -0600

    server: HTTP parser: general improvements
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 04c32ed5753a1c4b43308e7e379d19f26e44500c
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Thu Aug 6 14:32:39 2015 -0600

    server: HTTP: remove unused code
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 697dd3ac80ea56b60c7b3d8d5a8f4566d1878935
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Aug 5 13:27:09 2015 -0600

    HTML: intro update
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 8ff57ef1308cfc07a3babdc8bcb9c57d8e9b1d85
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Aug 5 13:11:59 2015 -0600

    QA: update scripts to new htdocs content
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 08ebcfe0e9fe10cd6165bdde7f16216ab4d806cf
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Aug 5 11:05:44 2015 -0600

    server: scheduler: invalidate scheduler mode when initializing
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 03a79f05027adda286bc4d51cdfc7c560ff07f0b
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Aug 5 10:53:50 2015 -0600

    Doc: remove draft doc
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 90641dd3ab239f0e80d633a1f106955d4aecb3a1
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Aug 5 10:27:24 2015 -0600

    Build: new option to use mbedtls shared lib (installed somewhere)
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 57eb2f6363db95f07b1e5c3179e525bd642d8b76
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Aug 5 09:53:21 2015 -0600

    Build: configure: fix banner
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 125709c0a104fa1c17a31d7f41e63e8f0071afd7
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Aug 5 09:18:32 2015 -0600

    server: scheduler: validate if channel is busy on event_write
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 5517c83c4089eca84b7051fd7f24c391ac7dc584
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Aug 5 09:14:02 2015 -0600

    server: stream: fix trace message when consuming bytes
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 0e5b14e0a20428e7555156e8ef201223ebca410c
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Aug 5 07:22:15 2015 -0600

    server: validate listner list head when exiting
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 71579c4e83488a20d8afc3bb4e529f2f76917127
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Aug 5 06:40:23 2015 -0600

    Build: make sure to generate 'modules' for OSX instead of shared lib
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 2d4fd2d01338f2b933d010f5c12a6bd223b84c9e
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Aug 5 06:14:09 2015 -0600

    Deps: add mbedtls sources as a dependency for TLS plugin
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 012f1abccad3128b000d8c1b150376e1ddff9778
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Aug 4 14:21:53 2015 -0600

    bin: signals: restore uid/guid upon exit
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 338e595c7b9281172fa71c7acba0099a1873b561
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Aug 4 14:06:57 2015 -0600

    server: scheduler: abort on listener problem
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit c0932895310200aa637cd0c6ecbec1a0e4097d64
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Aug 4 14:06:40 2015 -0600

    server: scheduler: if listener fails, return NULL
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit e68ccfd99590d873e95d8c639d964ee3486fee82
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Aug 4 14:06:14 2015 -0600

    server: socket: return error value if cannot bind
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 8100ed24a1b22c2da29ead8d84abdecb71e8773e
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Aug 4 12:36:54 2015 -0600

    Build: restore 'bash' for configure script
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 4b052a302101e81547f5f29d93ab5ee6f57dfd71
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Aug 4 12:03:14 2015 -0600

    server: stream: fix trace message for 32 bits platforms
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit f93cb2d173dbace2c21a5ed888fa903e9094fbe9
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Aug 2 20:57:00 2015 -0600

    HTML: add CMakeLists.txt file for content installation
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 69276b66028e2c31cffa91419846ed4f83dc34d7
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Aug 2 20:33:40 2015 -0600

    HTML: update homepage with new template and branding
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 8bfffd1f511d49083c658203809f33ead6a6763d
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Aug 2 05:53:55 2015 -0600

    Plugins: logger: do not use mk_libc_error from plugins
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 35169f869f46bd30ccc04533f0dd6c702fd17245
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Aug 2 05:50:09 2015 -0600

    server: plugin: remove unused function
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit e9982e355014f21c50a5712b83b841543f6a3d02
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Aug 2 05:48:43 2015 -0600

    mk_core: file: change data type for size field
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 467471fcf80a28d27c78a3c66655bb3443946e09
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Aug 1 18:41:35 2015 -0600

    Plugins: fastcgi: fix reference to channel_write
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 7c0242a3aeed802fdeac6b626b6775700d689fb5
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Aug 1 18:38:41 2015 -0600

    Plugins: cgi: fix reference to TLS
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 55ac31218959d57fc3fdf3906595df6b97bcf26b
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Fri Jul 31 15:27:50 2015 -0600

    Plugins: tls: functional with mbedtls-2.0
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 07b811096b795ff87cc905be0bb113190c2a69ab
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Fri Jul 31 11:14:02 2015 -0600

    server: scheduler: on read error, validate EAGAIN case
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 2f5639ef94cb106fbdd714644448c09b5d9e41ac
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Thu Jul 30 15:37:45 2015 -0600

    server: HTTP: fix LF catch limit
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit d254c61e209aaaf9e1d10a175053e2be3a23cc80
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Jul 27 23:43:21 2015 -0600

    Plugins: auth: mk_passwd: validate when dumping info (CID 1245666)
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 2f0b50123c16885f91f72b1737792fa170e87a43
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Jul 27 23:40:55 2015 -0600

    server: http: fix error page leak with HEAD method (CID 1299283)
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit d258adcbee6011ad9ba13382a6313587c0d85376
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Jul 27 23:30:28 2015 -0600

    server: http: validate return value of resource check (CID 1245652)
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 49b5e03de046e4105932d43be026b81d5cdbbcca
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Jul 27 23:28:31 2015 -0600

    server: vhost: do not leak file descriptor (CID 1245664)
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 97f5f9a5adaae23ce8275028f24cefaec39e2f5d
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Jul 27 23:27:27 2015 -0600

    server: http: on status error, validate content length against method
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 6d81d929643092ece4a53562a1070b503c4f9676
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Jul 27 23:22:40 2015 -0600

    server: config: do not override list of values (CID 1299286)
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 737d3b1b9cd9ccad715b83457694481153797177
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Jul 27 23:09:19 2015 -0600

    server: make sure timeout_fd is valid before close it
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 311db001a3087ac20f2e9df0761a5c71678d7dc6
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Jul 27 23:08:22 2015 -0600

    Plugins: logger: fix unitialized value (CID 1313320)
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 91b4107f6986cec1fa1bf6da60db2556e322c9dd
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Jul 27 23:01:23 2015 -0600

    Plugins: TLS: move API for mbedtls 2.0 (not functional yet)
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 37bb5e1919073b0f44953105cfa2497419e81e9e
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Jul 27 19:47:47 2015 -0600

    Plugins: mandril: adapt callbacks to new API
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 6b77fbd253ee4e76512a9eb1b7623bd0c60a2a4d
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Jul 27 19:47:25 2015 -0600

    server: scheduler: do not print out msg if connection was block by a plugin
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit eb632b4240876a534a35f7e8bfa3465cc4a934c2
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Jul 27 18:46:51 2015 -0600

    server: on exit remove listeners
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 6365f40ff244c4bbce5dac5b6c8e2af46d2df892
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Jul 27 17:51:49 2015 -0600

    Plugins: logger: fix pthread_cache initialization and get rid of the evil _mkp_data
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 55eb5a63ce21a0e9802ab2a91d161426422b140b
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Jul 27 15:59:39 2015 -0600

    Plugins: logger: adapt to new API
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 0a9e696d9882042de07cc4752c9a4533ccf598e2
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Jul 27 15:58:40 2015 -0600

    server: http_parser: fix pointer protocol length
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 264c6f488d8d237e24b8f4bf7e8f2299d184238a
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Jul 27 15:58:14 2015 -0600

    server: HTTP: invoke stage 40 upon request end
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 3570ba2861dd0c13afe6d0bfa95872b1b360ac7b
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Jul 27 14:02:12 2015 -0600

    server: streams: do not release stream with pending bytes
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 85e492d766599b89a0d9a148df9a13fe26d1706f
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Jul 27 11:51:21 2015 -0600

    Plugins: dirlisting: general improvements and cleanup
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 7d31f9764a962c62ddf340fcf8b4d1223fb996e4
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Jul 27 11:51:00 2015 -0600

    server: streams & http: cleanup channel on exit
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 86aa7ee843a3b609bad921ddc5db8be14c21b1ca
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Jul 26 12:43:04 2015 -0600

    mk_server: HTTP: do not walk around all stage30
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 870ff952ef530de5911ea4bf56d1233c6642534b
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Jul 26 12:27:26 2015 -0600

    Plugins: cheetah: fix format parameters
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 268072bd72ab6f7eb888d3b8afc0e381f917df91
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Jul 26 12:15:52 2015 -0600

    server: vhost: fix missing plugin msg
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 801352f0550e7574b3b61d935e86fb68d33ea565
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Jul 26 12:14:34 2015 -0600

    Plugins: cgi: fix unitialized vars and use proper URI address
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 3a10263b7007320df59a10bf001bf6ee7cd69d52
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Jul 26 12:07:48 2015 -0600

    Plugins: auth: fix number of parameters
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 0e293b071cb608a47a8b0d393544a0238ebaa2c5
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Jul 26 12:07:35 2015 -0600

    server: HTTP: remove silly msg
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit eb0dbf936e70d64e4438c64a49ae7486d80aa990
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Jul 26 11:53:47 2015 -0600

    Plugins: fastcgi: fix callback parameters
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit f26f2108e760411b460aee0b277c695db05213cc
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Jul 26 11:49:40 2015 -0600

    Plugins: cgi: handle parameters from handler setup
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit aa986169ebf4ba648fded97fec95626599dee16f
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Jul 26 11:47:22 2015 -0600

    server: plugin: handlers now support parameters
    
    The handlers definitions on virtual host now can specify parameters, e.g:
    
      [HANDLERS]
          Match /.*\.cgi param_1 param_2 param_3
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 98481f6f2755f49e74aa88c30ee1587aa809324b
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Jul 26 06:55:49 2015 -0600

    server: HTTP: do not handle missing files with a handler (temporal)
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit d164a051bf053babe30742277dee8acb0a15f230
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Jul 25 15:04:05 2015 -0600

    mk_server: add handlers support
    
    this patch enable a new Handlers support for plugins, so now is
    possible to define custom handlers for specific URI matches based
    on regular expressions, a virtual host may enable FastCGI through
    the following setup:
    
      [HANDLERS]
          Match /.*\.php fastcgi
    
    The 'Match' rule indicate that it's about a regular expression, the
    second argument is the regexec and the third argument is the plugin
    handler name (known as short name).
    
    Handlers are processed in order, if no handler own the request the
    server will dispatch the file content.
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit dd2e7bee7e990cc3111522e997a20e2459ef41b9
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Jul 25 12:49:14 2015 -0600

    Plugins: fastcgi: make query string conditional
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 0a9a2237ac6e90630c28e650cbdc04aeeef208f7
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Jul 25 11:42:22 2015 -0600

    Plugins: fastcgi: handle unix socket mode
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 097fbc702f70320a8e53f916ac181582904a5469
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Jul 25 11:41:57 2015 -0600

    mk_server: plugin: new api to open unix sockets
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 28c4683c7a667bdec8b47cad49ff567a01cd6d1d
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Jul 25 11:40:56 2015 -0600

    mk_server: HTTP: flush error page on error
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 763d032e4044ae705e84c321cd6694c2bdb218ba
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Jul 25 10:36:29 2015 -0600

    plugins: fastcgi: general improvements and cleanups on broken connections
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit e9cee1f7fa37a5daaff71bb985bf918b1db84c7e
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Jul 25 10:35:48 2015 -0600

    mk_server: server: do not process idle connections
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit dbea72780a8e9880db44bdb9b011e23a32a6a838
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Jul 25 10:35:17 2015 -0600

    mk_server: scheduler: initialize event and defer event free
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 858491d1b074ecbd16504c2a0be0e7c0c569f2e7
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Jul 25 10:34:31 2015 -0600

    mk_server: plugin: on request end, set the connection as incomplete
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit aa0fac20feb1e14f3581d2bf767a0108e5f68100
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Jul 25 10:33:56 2015 -0600

    mk_server: HTTP: set handler data and perform channel cleanup on broken connection
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit d685645426848e5917c2e4f34a73c3740594730a
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Jul 25 10:27:46 2015 -0600

    mk_core: event: add new status field
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 76d557a916a2040eee8bc00d80e11725e2b176c3
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Jul 25 10:26:00 2015 -0600

    mk_core: iov: fix buf_to_free reference
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit af9f867c44bfed3fea54d57488247aba2d13a1d2
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Jul 25 10:24:58 2015 -0600

    mk_server: stream: new clean interface to remove channel data
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 8c53246ee66249d054a87a80da9fa9818fffe7ac
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Jul 25 10:23:36 2015 -0600

    mk_server: HTTP: session request now have a new handler_data reference (used by plugins)
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 5a2eca4e4b3b411b1da49efce9da56ed713c044f
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Jul 25 10:22:55 2015 -0600

    mk_server: HTTP: do not mk_bug() when status is already completed
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 6cd33fc88cd8596d7540e7187b80aa0401f5804f
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Jul 25 10:21:24 2015 -0600

    API: fix MK_TRACE position declaration
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 5051e1a7117020cbb96f36341ba0f24b53fab409
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Fri Jul 24 09:35:39 2015 -0600

    Trace: shrink component name
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 4d1e398b1acb747227734af9166e820713849e08
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Fri Jul 24 09:13:45 2015 -0600

    Trace: shrink file path, do not include absolute path
    
    This patch makes CMAKE to define a new macro called __FILENAME__ which
    allows to set the relative path of the target file instead of the absolute
    path, e.g:
    
      before: /home/edsiper/coding/monkey/mk_server/mk_server.c
      after : mk_server/mk_server.c
    
    Now the trace mode use this new __FILENAME__ macro making the output
    a bit friendly.
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit a680478232959070ae4cfe7e02216badd1ff2070
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Jul 22 22:32:14 2015 -0600

    Plugins: FastCGI: fix unitialized variable on on_read callback (CID 1312111)
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit f05a8c4d0b833c8239026ee4a7cd5d1827bc7ead
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Jul 22 22:28:47 2015 -0600

    Plugins: FastCGI: do not assume 'buf' can be null (CID 1312110)
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 856858980ca0a6d0dcf0f0ba237a31b2033fca3a
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Jul 22 22:19:45 2015 -0600

    mk_server: streams: fix dereference after null check (CID 1312109)
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit df43e8bd93980c6977d07eb3a1af3164623dd28d
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Jul 22 21:59:28 2015 -0600

    Plugins: CGI: devnull cannot be negative (CID 1124125)
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 232b036cc2d7a95abef27681cb9d47f7fc20bf7c
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Jul 22 17:58:06 2015 -0600

    Plugins: FastCGI: add missing return value
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 72b3b52ee9daf1d1444613c97550d6f5968c2262
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Jul 22 17:57:28 2015 -0600

    mk_server: plugin: re-map socket inteface
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit d9bf3ffaabddbee11a3709d6c20d1ef837e95a26
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Jul 22 17:55:49 2015 -0600

    mk_server: socket: improved connect interface
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 1f9eb5c84426e036c5baf7611e82f2c27a646dd1
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Jul 22 17:55:17 2015 -0600

    mk_server: http: add header counters
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit ad043900b9bf8d4e0536b24198d3967869510cf4
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Jul 22 17:54:18 2015 -0600

    mk_core: event: new initializator
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit ace406df30d6e627345916f857e458314c3360f6
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Jul 22 17:51:50 2015 -0600

    Build: enable fastcgi plugin by default
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 989bae1d501f9c010283f24698294e4111f4aa7a
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Jul 22 17:49:59 2015 -0600

    Plugins: FastCGI: new FastCGI plugin
    
    This new implementation of the fastcgi interface use the new Monkey
    architecture and reduce the code complexity due to the new features
    available on the server core.
    
    It drops some neat features from the old version as KeepAlive and
    the ability of multiple connections, all that will be restored in the
    new version of Monkey which will support server pools natively.
    
    Note: old plugin required like 3000 lines of code, the new one only
    around 650.
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit d380488a14f9b914a49b8de5d75b90f9c0b4e19b
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Jul 22 17:45:57 2015 -0600

    Plugins: FastCGI: deprecate old FastCGI plugin
    
    This patch removes the old fastcgi plugins due to the following reasons:
    
     - New Monkey architecture requires plugins to hook and work in a different way.
     - New Monkey features abstract many interfaces that were required by the old plugin
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit ceafd30127c7c22a6612534521b72c2576f9239f
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Jul 19 19:17:52 2015 -0600

    mk_server: http_parser: map body content
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit e34a971e17b737b099e3c130cc1a27741d88a76e
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Jul 19 18:23:06 2015 -0600

    Build: use absolute path on --local mode when setting up the document root
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 42caa74b228a77c21470385eec1a190fe1e92937
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Jul 19 17:05:01 2015 -0600

    mk_server: scheduler: new macro to get connection layer capabilities
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 89781b5963af38289d9f42c4f6502637ddc51b1e
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Jul 19 14:47:07 2015 -0600

    mk_core: iov: fix iov reference pointer
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 2c459b61fc69c85eed10d6a853ecd625d713b207
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Jul 7 17:53:53 2015 -0600

    mk_core: iov: new implementation for mk_iov re-alloc
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 79630e6945e4e106f87480b2c67514e214143fcc
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Jul 7 17:39:12 2015 -0600

    mk_server: header: now each response context have it own iov buffer
    
    This patch get rid of the cached (TLS) iov buffer for the response headers. It
    now implements a struct mk_iov inside the struct response_header.
    
    No extra memory allocations are required, we keep the pattern of one memory
    allocation per request for HTTP/1.1.
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 5eb89be5bd4980030f8581c03432374045054fa4
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Jul 7 17:37:21 2015 -0600

    mk_core: iov: improve implementation, use just one memory buffer
    
    This patch makes the iov handler to use just one memory buffer instead
    of multiple allocations. It also defines a new allocator and initializator
    function.
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 6e749e93bc78a43e03b18a7ced442345a9dfb5f7
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Jul 7 07:52:57 2015 -0600

    Plugins: cgi: defer event free when a hangup is faced
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 0773a305c299e73a5d51b7fa3d48d88ac9989a61
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Jul 7 07:52:30 2015 -0600

    mk_core: event: add new field for generic purpose of a linked list
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit bb079fe1197e005e1d311af7950025d48d8ff1b7
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Jul 7 07:37:17 2015 -0600

    mk_server: scheduler: new interface to enqueue defer events object free
    
    This patch implements a new scheduler interface that allows the plugins to
    defer the release of some object, the context and requirement of implementation
    is based on the following behavior:
    
     1. A connection is being handled by a plugin (e.g: CGI), the CGI plugin also
        registered it own 'event' into the Event Loop to read incoming data from the
        child process.
    
     2. Before to receive the response, the client for some reason closes
        the TCP connection.
    
     3. The Scheduler will trap the 'close event' on the connection and start
        notifying the protocol handler and the plugin associated about this.
    
     4. The plugin will catch the notification on it stage30_hangup() callback so it
        will release it resources (CGI context, child process,
        close file desriptors, etc).
    
     5. At this point in the same Event Loop round, it may contain many events notified
        in the array, e.g:
    
        [0]   TCP connection closed
        [N]   others...
        [16]  Read data from CGI child
    
        So when we reach the the 'TCP connection closed'[0], we perform a release procedure as
        stated on #3 and #4, but then we reach 'Read data from CGI child'[16] but our event
        context was already released due to 'TCP connection closed'[0]. For hence we face a
        memory corruption.
    
    In order to avoid this kind of situations, the Scheduler and the plugins interface now
    provides a new interface to request the Server to perform a 'memory release' of a linked
    list of 'struct mk_event' after processing all the events in the round returned by mk_event_wait().
    
    A plugin only requires to be aware of the broken connection stage30_hangup() and register it
    event object mk_api->sched_event_free(struct mk_event *x).
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit c9c44785e354efd6c776509c48cb600464b56589
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Jul 5 21:45:47 2015 -0600

    Doc: update draft announcement
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 9b3e6f055972d774876d3af6ba337955f8f09ca5
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Jul 5 21:17:01 2015 -0600

    Plugins: cgi: better handling for exceptions
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit ced05634e7b79fb03c5d44f01a851d6ca6da6f02
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Jul 5 21:15:25 2015 -0600

    mk_server: stream: more debug message when TRACE is enabled
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 1e1c5082221e4f52cdbf3fbf8dbf1dff78e3687c
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Jul 5 21:13:44 2015 -0600

    mk_server: scheduler: improve drop connection routine with new socket flags
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 22b565337b7f3270abbefb7d993222a6fb628c00
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Jul 5 21:13:01 2015 -0600

    mk_server: plugin: on http request end, handle event close with a DONE_SOCKET flag
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit d88cf83f0179f940e6704c49a40a655db15b3246
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Jul 5 21:10:57 2015 -0600

    mk_core: event: new SOCKET_DONE status
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit a20fd2be48461ac20f73a191faefeafb79037b65
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Fri Jul 3 09:32:53 2015 -0600

    Plugins: cgi: remove breakline
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 57b448421c258b3ad777ffe1beca5e04afd71b34
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Fri Jul 3 09:32:35 2015 -0600

    mk_server: plugin: fix validation of list of http requests
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit b9c27a55fdf5f59ac173bc0380a5278dea0d8e72
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Fri Jul 3 07:16:20 2015 -0600

    mk_core: utils: rename backend of mk_libc_warn()
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit d3fc419519a6c3d32f5f4b5065d1cf7bd7f1a263
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Thu Jul 2 12:59:53 2015 -0600

    mk_core: implement a static buffer for libc error messages (fix #195)
    
    Monkey utils implements a buffer per thread to format libc errors, but
    when the mk_utils_libc_error() is invoked from the parent process, it
    may crash as the pthread key do not exists.
    
    This patch implements a static buffer for those cases when the call is
    invoked from a parent process.
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit e5407e2c547c60a44b76db1c7215ce730a4c69e0
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Jun 30 17:08:46 2015 -0600

    mk_server: plugin, http: session handling improvements
    
    This patch add some improvements over the Plugin interface to provide
    more reliable handling of connection at the plugins levels (e.g: CGI),
    it also adds a new callback to the stage30 based plugins to be triggered
    when a hangup is faced (very common).
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 9f46b81ab442b90befe7880f4e251fd58d31660f
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Jun 30 17:04:01 2015 -0600

    Plugins: cgi: improved session hangup and cleanup
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit fa5adce7128fcd91d62da968f21c7aa108b23ac6
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Jun 29 11:34:24 2015 -0600

    Plugins: cgi: keepalive only allowed for HTTP/1.1 connections
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 12428e6658ae846762af08f9fa5c8b34ca32a3dc
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Jun 29 10:50:05 2015 -0600

    Plugins: cgi: restore session hangup
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 0ef0dee8d8155eb116ae035836be411540e204ba
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Jun 29 10:48:25 2015 -0600

    mk_server: http: fix api to handle request_ends
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 8c73d44c269c822e5b9bc2320260a3b0bb179094
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Jun 27 06:56:57 2015 -0600

    Plugins: cgi: close CGI pipe read end
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 87a188c212beb9d453845297217ab0205f198467
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Fri Jun 26 23:28:53 2015 -0600

    mk_server: http: add support for ETag header (fix #139)
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 239af215c7ed9b529ad24687aff5382d8805fad8
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Fri Jun 26 17:08:05 2015 -0600

    Plugin: fix trace message (fix #181)
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 3e5025e51865979fc6fff73b6ebcbc2ccd7a596c
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Fri Jun 26 17:04:04 2015 -0600

    Doc: update man page (fix #196)
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 0319ce1ef112ded31f6eef854f2e2867aee7a21c
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Fri Jun 26 15:39:03 2015 -0600

    Plugins: cgi: workaround for separate breaklines (#202)
    
    This patch makes to read the whole data in the buffer until the
    breaklines are found, if the buffer becomes full it will abort
    the CGI program.
    
    This implementation needs more testing.
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 94cfa12080d3a4be979e8d5da27992d862d3855c
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Thu Jun 25 16:46:25 2015 -0600

    mk_server: http: fix trace messages (socket number)
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 9b11ec43623a703ad05e67678f45f8d446906054
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Thu Jun 25 16:28:53 2015 -0600

    Plugins: cgi: use Monkey streams to dispatch data to the client
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 3f9b90ce3d9052ec218ee280c51c8e2bd1327c8b
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Thu Jun 25 16:27:12 2015 -0600

    mk_server: streams: new interfaces to 'intent' to flush data
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit f294a7d4480c992e3a1d17d4574c55755e3f523f
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Jun 24 23:08:45 2015 -0600

    mk_server: stream: add copybuf handling to stream_set
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 027706c4adc4e11be013732fd70a14c112264a71
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Jun 24 18:01:26 2015 -0600

    mk_server: stream: handle MK_STREAM_COPYBUF
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 5e4ae0f504555a91373f34ea6a67c02b839426f9
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Jun 24 14:24:20 2015 -0600

    mk_server: scheduler: initialize variable
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 4de656146e10fa775f6ae3b1c1e53de6c15fb7fd
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Jun 24 12:22:44 2015 -0600

    Plugins: cgi: little API changes and add CMake rules for configuration (#184)
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 1be4f4500f2b845fc972a0ab4a7f157fd7f34f2f
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Jun 23 22:50:00 2015 -0600

    mk_server: re-implement timeout handler
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 4583d128d283f4a851f60b049a1053dc683f2863
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Fri Jun 19 20:39:44 2015 -0600

    Plugins: build plugins with position independent code (PIC)
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit a0e5c7334d7dfc74e312059f2a8ca5291844285a
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Thu Jun 18 11:23:50 2015 -0600

    mk_core: event: workaround for old Linux Kernels without EPOLL_CLOEXEC
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit ac8be28bc69c2e024d969df91f35493b92fd542f
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Jun 17 09:48:57 2015 -0600

    mk_core: event: fix leak if loop events mem creation fails
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 7186e87f8fb80a1a34228710dde0cb5cfcf49e4e
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Jun 17 09:48:22 2015 -0600

    mk_core: event: fix leak if loop creation fails
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 32e69eecbe7e483267012c110ad9bb1379485eb7
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Jun 17 09:45:00 2015 -0600

    mk_core: utils: fix leak on PID file after locking
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 62e73837abf39ab1cd7b7aab9253fa763631fcb9
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Jun 17 09:37:20 2015 -0600

    mk_core: utils: improve validation check when registering PID
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 4f6d84cf616e68d8fb1ac293a89f14c44c7b56f5
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Jun 17 09:33:07 2015 -0600

    mk_core: iov: make iov_print work again
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 7bac859c623c112b565862e00e1be2333bf4bc2f
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Jun 15 16:46:10 2015 -0600

    mk_server: server: fix unitialized variable reuse port
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit ab7bbf5307177830621639e22c6e0cd15b46b090
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Jun 15 16:45:09 2015 -0600

    mk_core: config: fix leak on split list
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit e219aeca6840a114e71d3128e81bbd196666d92a
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Jun 15 16:40:14 2015 -0600

    mk_server: http_parser: fix method table index
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 172ef76e626b68c678b745bdf6d243cc7b736218
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Jun 15 16:34:13 2015 -0600

    mk_server: http_parser: remove unnecessary continue() after parse_next()
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 2be215b216172a0295ff44edc7f64c23bc942faf
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Jun 15 16:32:56 2015 -0600

    mk_core: rconf: do not over validate configuration context
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 4521934825c1ecc58df82b34a8ae5542c7189c45
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Jun 15 16:31:41 2015 -0600

    mk_server: plugin: validate plugin instance
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 4bd3a9bb903740031f5af2a58b45bfd6810e7539
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Jun 15 16:30:47 2015 -0600

    mk_server: plugin: close handler on exception
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit f0c80f93024347d7030644fdeb646ddb5436b00f
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Jun 15 16:26:16 2015 -0600

    mk_server: plugin: fix stage40 call assignation
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 41f890e01f5a595c79a2c2918f50c42e16802dab
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Jun 15 16:25:19 2015 -0600

    plugins: logger: validate return value of fcntl() calls
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 3fb870f276ba6b75bd75370941d288ced34fb6ac
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Jun 15 16:20:47 2015 -0600

    mk_server: socket: validate tcp_nodelay return value
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 4445249a91db4b2057730685e55a330a7646fd1e
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Jun 15 16:19:50 2015 -0600

    mk_server: http: validate return value of cork_flag func
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 1771d759e3d7c16f03c2bb43cc125017d0fe78ba
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Jun 15 16:03:27 2015 -0600

    mk_server: rework connections timeout handling
    
    This patch re-enable the timeout handling into the scheduler, it now works
    as follows:
    
     - Scheduler implements a new timeout_queue linked list (similar than before)
     - Scheduler register all new connections into the timeout_queue
     - Connections that have not send any data upon a timeout check, will be
       dropped.
     - If a connection sent some data, the protocol handler is in charge to
       unregister the connection from the timeout_queue.
     - For HTTP KeepAlive case, the session is registered on the timeout_queue
       everytime a response was sent.
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 79294d2bda10c31c35a7f86690cc295579edc992
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Jun 14 21:03:38 2015 -0600

    mk_server: move server_info func
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit daf22a2a13ac7eddfd1645c1f5b7eb649f46ef4c
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Fri Jun 12 16:38:37 2015 -0600

    mk_core: rconf: validate NULL path before create configuration context
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 2e4d82a3558b79f2836991cdfdf78f7ca6a2c11f
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Fri Jun 12 16:37:07 2015 -0600

    mk_server: do not abort when no mimetypes are registered
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit afcdf28455b5755136d527e861fe6562819481f0
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Fri Jun 12 12:16:36 2015 -0600

    Build: new WITHOUT_CONF CMake option to skip configuration files
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 889cd613bc8b19c20c56009adee3478af1a557ba
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Fri Jun 12 12:05:38 2015 -0600

    mk_server: plugin: check if a plugins config file was set
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 71e79106e550afab974ca03d52380e115764a92b
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Fri Jun 12 11:33:56 2015 -0600

    mk_server: plugin: do not abort if there is no dynamic plugins
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit af1ffbb13e2838a8b23ed7daf6b2bb3d4352bddf
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Thu Jun 11 11:23:11 2015 -0600

    mk_server: set -fPIC to C_FLAGS
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit f2ca8ab23d47c0ebe01a8664b8018202a488d5c4
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Thu Jun 11 11:03:06 2015 -0600

    mk_server: build: link to -dl using CMAKE_DL_LIBS variable
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit d024fdee05a6379138f818ecf5ccffb67d517d5a
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Jun 10 19:44:15 2015 -0600

    CI: add OSX as build system
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit aa04d958ed18472b9eed2fae78f2baf8a43e8ae4
Author: Chris Johns <chrisj@rtems.org>
Date:   Thu Jun 11 11:14:52 2015 +1000

    mk_server: build: fix library lists rules for FreeBSD.

commit 87f3012d3bcd70ee696bba554f5312facbbaa2ab
Author: Chris Johns <chrisj@rtems.org>
Date:   Thu Jun 11 11:14:24 2015 +1000

    mk_server: socket: platform neutral sockopt setting

commit 3593904c35c0f102d919ee5d83b0f41f9f893b60
Author: Chris Johns <chrisj@rtems.org>
Date:   Thu Jun 11 10:55:57 2015 +1000

    mk_server: Liana: add FreeBSD support for sending a file.

commit 8e88d356c86afd8d6be02bc845b000dd4a24344f
Author: Chris Johns <chrisj@rtems.org>
Date:   Thu Jun 11 10:43:15 2015 +1000

    Configure: add support for FreeBSD
    
    Switch the shell to /bin/sh as this should work on all systems.
    
    Make the colour support specific to Linux.
    
    Show Monkey is more than just Linux these days.

commit ffe2625d75639d0a48daa26f8651b8a7f23ec53f
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Jun 10 15:39:13 2015 -0600

    mk_bin: mk_server: move signals interfaces and cleanup executable calls
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit d7b4f703bb4295888c6dbd37e69c930813580bd7
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Jun 9 11:21:45 2015 -0600

    mk_server: scheduler: fix variables on trace mode
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 090462eb5302654394e87fad74c77079998f4101
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Jun 9 11:13:56 2015 -0600

    mk_core: event: epoll: fix parameter when trace is enabled
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit eed81571a50a58c997c1458147ed8253b414783a
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Jun 9 11:12:29 2015 -0600

    mk_core: adopt mk_file interface
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 42225b674517d89eb87b9ffa0230e6c987118b92
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Jun 9 11:02:57 2015 -0600

    mk_core: event: epoll: align API change for event_del()
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 5a2d722e08f7783ff7d6200871a6a529495a485a
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Jun 9 10:58:39 2015 -0600

    mk_core: event (mk_server): use event context when deleting a connection
    
    this patch makes the event handler to use the connection context mk_event as
    a reference to obtain the connection file descriptor and event bitmask.
    
    The main reason for this change is the requirement to get the existent bitmask for
    the kqueue interface, when deleting an event it needs the 'filter' associated and this
    is translated to the event mask: EVFILT_READ ; EVFILT_WRITE.
    
    For epoll(2) backend is not required but there is no performance penalty associated,
    epoll backend patch already coming.
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 8ba5c4fbc56f76a6a97da21a1ce6c22258af90e7
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Jun 9 08:51:54 2015 -0600

    mk_core: kqueue: fix mask when adding a new fd
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 2cdeec3cd1e0fbf02afd8d7818e3a98de948414b
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Jun 9 08:47:18 2015 -0600

    mk_core: add missing declaration of memrchr for OSX
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit c80b114349b70a19657e332adc404cf05ecc4c9d
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Jun 9 08:39:49 2015 -0600

    mk_core: kqueue: remove unused variable
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 4b92fe6cb528ec6bdfcb8edf61fd70641e7f56c4
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Jun 9 08:35:23 2015 -0600

    File: add time header
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit bc286b7995ca518c186e3c64c2aa4dbd2f729388
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Jun 8 22:43:59 2015 -0600

    Build: fix linking to jemalloc when is enabled
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 303cb4c56695c4ce7609ab2150eb389de9ec6e26
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Jun 8 16:31:46 2015 -0600

    mk_server: fix compiler warnings
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit fffffe67cc64517e6a3c8e45f38647d5f19af8d2
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Jun 8 16:22:29 2015 -0600

    mk_server: add initializator
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit da39c4e9ad7c67545bdecb59288965fe9cda4827
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Jun 8 16:17:10 2015 -0600

    mk_core: mk_server: general fixes for building
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 5aad2c798b80bc47516cc4e372fe518c8784e1d2
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Jun 7 09:57:42 2015 -0600

    mk_core: adopt some mk_server utilities
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit b135a82caa17ea3324590d2037714ae74345b260
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Jun 7 09:43:47 2015 -0600

    mk_bin: add build system
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 2d09462fc4891988b846d1edb7cb481112f7dce7
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Jun 7 09:43:12 2015 -0600

    Source: split code into new directories: mk_bin, mk_server & mk_core
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 67278ace622986ad7d12ff903e90c4406b0b0fff
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Jun 7 08:51:10 2015 -0600

    Core: fix some compiler warnings
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit aef09631c107649a1b32afe924e487120718dba0
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Jun 7 08:25:26 2015 -0600

    Build: add rules to build static lib
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 69f8762ab3707d61aa2870b25c867e5b13f29fe5
Author: pandax381 <pandax381@gmail.com>
Date:   Sat Jun 6 16:59:57 2015 -0600

    Build: porting Mac OS X (and other BSD systems)
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 542a9dfd66069eebbd0b2619bed51f81e96a42cb
Author: nkaneko <nkaneko@iij.ad.jp>
Date:   Thu Jun 4 17:25:58 2015 +0900

    mk_core: fix timeout given to EVFILT_TIMER in some BSD
    
    This patch fix timeout parameter given to EV_SET(EVFILT_TIMER) in BSD system
    other than FreeBSD.  Only FreeBSD(or LINUX_SECOND) has NOTE_SECONDS defined and
    specify seconds in EV_SET(EVFILT_TIMER). Other BSD expects milliseconds.
    
    Tested in NetBSD environment.
    
    Signed-off-by: enukane <enukane@glenda9.org>

commit dfc6fd602b2ca06849967cbed711202d119787fb
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Jun 3 17:29:52 2015 -0600

    Stream: remove mk_bug() check on copybuf
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 16cd3c6dc41fc985548da7b54e2641355d6db975
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Jun 3 17:25:55 2015 -0600

    Mimetype: fix header inclusion (core)
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit e5d7a1f235927ed1b48a62ecd74255baaab446ec
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Jun 3 17:23:14 2015 -0600

    mk_core: move getenv routine inside TRACE conditional
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 3640f6ff14bdac110c8192bd92585c809b6f7f7f
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Jun 3 17:18:59 2015 -0600

    HTTP: fix header inclusion (core)
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit f7c46f7548e7371fb05c363904570fdb3a781255
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Jun 3 17:13:04 2015 -0600

    Dirlisting: do not try to flush the channel, just enqueue data
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 5a5a4f262a75a4720db47790c8e3014540ad8b32
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Jun 3 17:12:08 2015 -0600

    Auth: fix headers and API calls
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit cc8258f9d296185845259ec0261a8b69f43c5373
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Jun 3 03:01:28 2015 -0600

    mk_core: add missing mk_rbtree.c
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 4fd1504c3bb7ef00c2be9f882ca4bf35ce3f19d6
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Jun 3 02:51:35 2015 -0600

    mk_core: add missing mk_memory.c
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 9cf7ec5c43fa6f99b5767df1c1e3c9daf3cb5008
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Jun 3 02:47:54 2015 -0600

    mk_core: add missing mk_limits
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 520d8c7f1401f345046a50f136b71c90e91b7916
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Jun 3 01:46:20 2015 -0600

    mk_core: adopt some mk_utils functions
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 99aeba18807637dbcc2a91d434ab71467622f7b9
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Jun 2 23:53:04 2015 -0600

    mk_core: move core files of generic features to a kind of 'lib'
    
    this patch moves several Monkey source code files to a mk_core
    sub-directory:
    
     - moved only generic interfaces for memory, string handling, configuration,
       polling, etc.
     - useful for other projects that use some Monkey core files (e.g: fluent/fluent-bit)
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 69ba3fd02a2442544ee50e732504e14882632f9b
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Jun 2 20:52:36 2015 -0600

    Scheduler: write buffering and I/O abstraction.
    
    this patch makes the Monkey scheduler aware about buffering and
    protocol handling. From now Monkey core protocol handlers are plugins
    requires to enqueue outgoing data and the Scheduler take care of dispatch
    the information out.
    
    Note: It still need to be tweak for high performance.
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 7e2a4075719ca8b06be406edfaa7a0d1e27f56a4
Merge: 890c16f 47baec9
Author: Eduardo Silva <edsiper@gmail.com>
Date:   Sun May 31 18:45:51 2015 -0600

    Merge pull request #209 from neeraj9/dev-use-sigsuspend
    
    Server: Use sigsuspend instead of sleep

commit 47baec966af07fd919c6e7fe36f1f42748a6df9e
Author: Neeraj Sharma <neeraj.sharma@alumni.iitg.ernet.in>
Date:   Fri May 29 14:45:43 2015 +0530

    Use sigsuspend instead of sleep
    
    The usage of sigsuspend is both portable and cleaner than sleep to
    indefinitely do nothing. This approach is useful in the master
    loop (mk_server).
    
    This commit closes #203
    
    Signed-off-by: Neeraj Sharma <neeraj.sharma@alumni.iitg.ernet.in>

commit 890c16f1cc73609ffd203c0dc2b74f3d08104748
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon May 18 21:42:15 2015 -0600

    Plugin: deprecate old 'events' interface
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 240c2ab4accb5550ae06dd071a83462f640b3106
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon May 18 11:51:20 2015 -0600

    Plugin: remove dead events code
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 7e900b99dfae6934b51d7f6e5757f0d8ef2d88ea
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon May 18 11:43:53 2015 -0600

    Server: banner now print the list of loaded plugins (Fix #185)
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit e426544df9513c29dbd48fee8f480883b84513a4
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon May 18 11:36:11 2015 -0600

    Server: -b option now lists the built-in plugins (ref #185)
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit b4d7ea69bb6d8baa8b1dcbe349408929e18cff86
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat May 16 21:41:26 2015 -0600

    Core: buffer: use network layer buffer size
    
    this patch makes the protocol handlers to respect the buffer sizes
    suggested by the network plugin.
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 22a4435fdf21c2cc2ad95e2f293f148fcdab6f05
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat May 16 20:24:33 2015 -0600

    Scheduler: remove 'capacity' feature
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 6b419d1fd22030b4f71e20d59884872ed618a9ae
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat May 16 20:11:34 2015 -0600

    Headers: some header inclusion cleanups
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit def1f351d2e8344ac73c35df3125c4a69c66bf2b
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat May 16 18:31:09 2015 -0600

    Socket: fix variable name
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 0b82d7f7e6632a1e785850ea08a1bd705de0365c
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat May 16 18:25:58 2015 -0600

    Build: CMake: rename mbedtls option to tls
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 04290bc6fd5580ebb9190df711b575531ab55508
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat May 16 18:23:04 2015 -0600

    TLS: polarssl plugin fixes and rebranded as 'tls'.
    
    This patch makes some changes on the old polarssl plugin and is rebranded as
    'tls'. It now depends on mbedtls library.
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 5267220b44b65a5a8e41aafb280ae173e3d0ea13
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Fri May 15 17:06:24 2015 -0600

    Core: new network layer abstraction
    
    This patch implement the following changes/features:
    
     - Listeners configuration allows extra parameters or flags, the options are:
       - http
       - http2 (not implemented yet)
       - ssl
       these options are handled as 'capabilities' by the plugins and the core
       interfaces.
     - Each scheduler connection is linked to a protocol handler and a network layer
       plugin.
     - Due to previous changes, now multiple TCP ports can have different capabilities
       and use multiple transports layer.
     - Global configuration is not longer aware about networking stuff.
     - Socket interface cleanup: moved network features like server, bind & connect
       to it.
     - Channels are now linked to the network layer interface.
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 3da7a940212e7e3fe70af8de0d63f74a1fe3ceea
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Thu May 14 14:10:52 2015 -0600

    Config: Listen key now support flags: http, http2 & ssl (not yet functional)
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit dc9f68cb24eaa116edcc9b566ca95709f621c672
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon May 11 14:47:52 2015 -0600

    Server: remove silly printf msg
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 40e72221a9e6ff12adcba32fad75b601f17b8d9a
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun May 10 21:24:28 2015 -0600

    Build: CMake: when using jemalloc, link pthreads explicity
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 3c4770c2aae04c927d2a5faeed387c0b983f5409
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun May 10 21:05:32 2015 -0600

    Build: CMake: do not repeat parameters when adding libraries to the monkey target
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 45da3b13301c152f5f4a6e644e27a5a5763f6aa0
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun May 10 20:57:49 2015 -0600

    Event: Kqueue: fix backend to align to new Event core interface
    
    This patch modify the kqueue backend to align to the new Events mechanism,
    at the moment it 'compiles', but it's not 100% functional.
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 43290a4dee0220beed77069271c8394392d89d5b
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun May 10 20:30:22 2015 -0600

    Event: remove old references to event file descriptor table (EFDT)
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit f46e84626162684db700d7ffa10130e46acb57b4
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon May 4 11:11:42 2015 -0600

    Event: epoll: do not zero events struct
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 44348ebe228511892371b3b15da9c49a214743a2
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon May 4 09:36:08 2015 -0600

    HTTP: improve how to check keepalive and session closing
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit c45dfe03289336520108e35e1c89167e246a1924
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun May 3 21:03:56 2015 -0600

    HTTP: deprecate support of old Keep-Alive response header
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 05cc0e704fc9eabc3abeb14f1e39dc2b537a0e31
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun May 3 13:45:16 2015 -0600

    IOV: do not print out an error if array is outside of size
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 8bc7294801f1e0bdf8b92c45b327a2b362cc6032
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun May 3 13:37:37 2015 -0600

    IOV: on consume, check best of case where all bytes where consume (avoid walk around the array)
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit f1d284238bf8212ee3765cc3310cf7b088739324
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun May 3 13:29:30 2015 -0600

    HTTP: store session in extended Scheduler connection memory area
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 4c8d6d9b2cec996c2589b37e24924919bb9b17e5
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat May 2 15:46:40 2015 -0600

    Doc: draft of v1.6 Announcement
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit aaa8977a5cdc45e9b53e7e005371b75001a697c0
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat May 2 15:42:56 2015 -0600

    Scheduler: support protocols handler.
    
    This first patch makes the Scheduler aware about protocol handlers
    per connection.
    
    One the next set of patches the following will be implemented:
    
     - Configure Listeners handlers per configuration
     - Let CMake define protocols/handlers available and auto register
     - Improve Scheduler memory allocation for protocol/handlers that
       will own the session (e.g: HTTP).
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 94cb66c178c2b69f30080b1c0fce348f59ca7d07
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat May 2 14:47:05 2015 -0600

    Mandril: use new rconf api
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit e7326959203b248281f9338852f8f9019121b8e7
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat May 2 14:45:06 2015 -0600

    Logger: use new rconf api
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 6a917c5928140642314d8ffc260711c3f19a144d
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat May 2 14:43:49 2015 -0600

    Dirlisting: use new rconf api
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit a1a6461f91c90a54a6c25adbe0586e5ebc3cf4a1
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat May 2 14:43:08 2015 -0600

    Cheetah: use new rconf api
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit fa9c420a7c4bd3c1c1472341cb7577c82ab5384d
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat May 2 14:42:02 2015 -0600

    Auth: use new rconf api
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit dd534ad6a2ebc7282b44646521b55ccf7053247d
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat May 2 14:39:01 2015 -0600

    RConf: new interface to handle configuration files.
    
    This patch creates rconf which is a new interface to read configuration
    files, it basically take the routines to read configuration files from
    the mk_config.c and place it in a new mk_rconf.c, functions got renamed
    and some macros changed.
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 1ebbb35d3f78af749c3451a6468a12ca51233fee
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat May 2 10:44:37 2015 -0600

    Scheduler: rename sched_list_node to mk_sched_worker
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit cf8a4f4dc56e5b92b45ef09bb3b1841a304080a6
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat May 2 09:23:39 2015 -0600

    Connection: deprecate interface and move routines into the Scheduler
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 2e95030a0435147c54ef6b979329ffaa72c23160
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Thu Apr 30 23:51:53 2015 -0600

    HTTP: on error handling, set content-length=0 when no body exists
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 21c27fcbf1d372dc91d8cc660db9e273bdd1fa68
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Thu Apr 30 23:45:22 2015 -0600

    Core: fix GMT_DATEFORMAT macro for clock and HTTP
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 9d40873869dceb2da17177dbf886426a254bc82e
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Apr 29 22:30:07 2015 -0600

    Scheduler: free mk_sched_conn on closing connection
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 86a3550cd06714cbb3b5116be2fb56cef0b8c3e1
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Apr 29 15:15:02 2015 -0600

    HTTP: on '400 Bad Request' do not compose error page
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 73a8f9cd4abfbed86f5087e1bc7bca6638042e91
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Apr 29 14:14:38 2015 -0600

    HTTP: compose error page stream with stream API directly
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 355b208cdc3204ff0caade7fe293df91efcb7db9
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Apr 28 18:37:23 2015 -0600

    Scheduler: remove unused field
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 8ee889bf5b59c9af0a6865cca4d9f3d18c22dab5
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Apr 28 17:06:33 2015 -0600

    HTTP Parser: pack http_parser structure
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit e781b99328fcda31e56a45731aff65c6a2cd318b
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Apr 28 15:58:17 2015 -0600

    Virtual Host FDT: do not try to close(2) a non-open file descriptor
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 807b7de732a5215996cd57d7dece569169ce6a51
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Apr 28 15:24:32 2015 -0600

    Virtual Host FDT: fix uninitialized values and context flags
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 6a2a0f13fc0d8224d7ea9a1cd33181d86237e8ae
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Apr 28 11:01:29 2015 -0600

    Connection: Server: pass sched context across callbacks
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 24eebd4342a016384f03f7d30dd540a9af595ec0
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Apr 27 10:55:36 2015 -0600

    Connection: fix handling for keep-alive connection
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit e92f46764d959c2e014e1d43ab06d593ae2d078c
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Apr 27 10:47:01 2015 -0600

    Server: fix trace mode on loop_balancer()
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 996a877e2a63439b553d507d0352430befc6e112
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Apr 27 10:44:04 2015 -0600

    Server: make old-balancer mode work again
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 271ce08ed7361e70db88fcbccfa256d087aff044
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Apr 26 20:43:42 2015 -0600

    Server: fix worker_loop() declaration
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit a2af71bf8e2f8660ed1e0c7928f2ecbf1f06f52a
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Apr 26 20:40:30 2015 -0600

    Plugin: remove deprecated reference of mk_stats.h
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 6021603736bb3952967a20362e538a917f37015a
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Apr 26 20:37:25 2015 -0600

    Mandril: adapt to new stage10 declaration
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit abc4cfdd6231b45ad69e918ecd572c940a9c66f6
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Apr 26 20:36:32 2015 -0600

    Logger: adapt to new polling API
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit e4de5346782d85b3dea5598917e6124020045516
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Apr 26 20:18:04 2015 -0600

    Core: Scheduler: Polling: new architecture (work in process)
    
    This patch is a major change on Monkey architecture. This is the
    summary of the changes:
    
    - Polling: the polling mechanism do not longer works with a file
      descriptor, instead, it store a 'struct mk_event' as void * that
      can be used by the callers to set their own data and retrieve it
      once an event is triggered on the monitored fd.
    
      The way to use it by the callers is that callers create their own
      structure but the first field of that structure is a static
      reference of 'struct mk_event', e.g:
    
      struct mk_sched_conn {
          struct mk_event event;
          ...
      };
    
      On that way we allow callers to set their own data and also let the
      polling core to handle what they need.
    
    - Scheduler: major cleanup and reduced code, some functionalities are
      still pending waiting for migration of code. For each accepted connection
      a 'struct mk_sched_conn' exists.
    
      The scheduler do not longer holds a static array with the maximum number of
      allowed connection. They are allocated on fly now. We reduced memory usage
      and speed up the handling.
    
    - Event File Descriptor Table (EFDT): droped. Initially conceived to maintain
      a global status of each file descriptor, this now is deprecated and handled
      by the 'struct mk_event' and the structure in use by the caller. We reduced
      memory usage and speed up the handling.
    
    This is still work in process, more updates on the next series of commits.
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 22d336ef7798e476822df637d0aa61bd37cbf8f4
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Apr 14 23:33:59 2015 -0600

    Liana: do not print broken pipe errors to stdout on sendfile()
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit b9f86ede3f8924359fe2faccc1ed981a71f11d95
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Apr 14 23:30:21 2015 -0600

    Stream: fix data type to handle streams operations results (fix #200)
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit a93a37553c920732f4708ba4f04f8a3e5255fe8b
Merge: 5e4c4d2 6faee5f
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Apr 14 23:15:33 2015 -0600

    Merge branch 'master' of github.com:monkey/monkey

commit 5e4c4d2899d5b7efd8fcf82e2973f0ac9774adef
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Apr 14 23:13:53 2015 -0600

    Core: rename common return values and do not perform channel writes from protocol handling routines
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 6faee5ffd3c25892ee6d073bb8e067048c1eedad
Merge: 23b1dfe 04899a1
Author: Eduardo Silva <edsiper@gmail.com>
Date:   Tue Apr 14 22:58:07 2015 -0600

    Merge pull request #199 from leowzukw/patch-1
    
    Configuration: typo in template (/~user)

commit 23b1dfe526b04abead092f18e36545d0761894ca
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Apr 12 20:13:01 2015 -0600

    HTTP: on http_prepare, return right return proper channel value
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 4de62255d716c21c5178f908ef31618dc785ee1f
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Apr 12 18:51:56 2015 -0600

    Request: initialize file stream 'preserve' field
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit fb621bd8ffbdeece94cd97b756d76af799e9268e
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Apr 12 18:45:22 2015 -0600

    HTTP Parser: send 413 HTTP error when cannot store extra headers
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit cda7a3d35865880240f536655c59867a57d3fe79
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Apr 12 17:37:55 2015 -0600

    Stream: fix unitialized 'preserve' stream field
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 0560ee853a6e1f2fd3441753f69201fcdac40217
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Apr 12 17:33:22 2015 -0600

    Connection: on premature close, check if the channel have some data to send
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit cf5d2eeed9f97314ab1bc62a8e526656d41950d7
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Apr 11 19:53:26 2015 -0600

    HTTP: on error, do not append stream after stream_set
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 04899a1ccb03a97c49b4a7ec89fc89821c97b5d2
Author: leowzukw <leowzukw@users.noreply.github.com>
Date:   Sat Apr 11 09:15:55 2015 +0200

    Typo?

commit 58aa859de248e74e2bb196c02bbeeed172c9fabb
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Fri Apr 10 21:14:36 2015 -0600

    Build: CMake: fix variable scope when linking static plugins
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 4e70b74e6202196534df3fcdf70c5c713901560d
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Fri Apr 10 09:31:04 2015 -0600

    Server: remove unnecessary remove_client call
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 27a7a4302a415f545ecb72727e429ed396b802e7
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Fri Apr 10 09:10:18 2015 -0600

    Core: remove old/unused stats interface
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit eec21cd5e47f6a2f6167d74324a25f8590a5fd4e
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Fri Apr 10 09:07:25 2015 -0600

    HTTP: Fix memory corruption when handling a protocol error (Fix #194)
    
    When the HTTP parser catch an error, the HTTP core will try to close(2) an
    unitialized file descriptor from the session, generating a memory corruption.
    
    This patch make sure to initialize the value and only try to close it if
    it have some valid number.
    
    note: this problem is only faced on v1.6.
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit c77183d9d11e2a1378ac27508a745f805c51448b
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Apr 8 15:16:45 2015 -0600

    Files: remove unused text documents
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 2438d67233b5849cfb537b01f16b9ca65c09e833
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Apr 7 11:43:46 2015 -0600

    Build: CMake: auto-turn off Linux options on non-Linux systems
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 87e3f0ac229dd718297ce1919284946377bc20cc
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Apr 7 10:27:38 2015 -0600

    Doc: update README
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 04bded2cf38615821adfda51706834284b65636d
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Apr 7 10:25:38 2015 -0600

    Configure: remove old references to systemd init scripts
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 10be8467f510b2e357ea6f6473407e90a83dabb4
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Apr 7 10:24:01 2015 -0600

    Mandril: CMake: support configuration files
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit be90b12f4c6e45569c5bdf54703c56f9540b09db
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Apr 7 10:18:05 2015 -0600

    Build: CMake: create log path for local mode
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit c29ffbf5bb96b97e979b8c9da4b8e2c495dea57f
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Apr 7 10:14:33 2015 -0600

    Logger: CMake: support configuration files
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit e2e156ba0494f00c6035eb35aed4092186d47495
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Apr 7 10:04:03 2015 -0600

    Cheetah: CMake: support configuration files
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 362921535e04ec2c552f4948a8e86c019e841579
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Apr 7 10:01:56 2015 -0600

    Dirlisting: CMake: fix conf path
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit fdf1f1948cdad3f7b2af55318363faa52e2cc41e
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Apr 7 09:57:12 2015 -0600

    Dirlisting: CMake: support configuration files
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 927b1a8c502c3d9d670ffa540fb00439275a6c44
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Apr 7 08:52:47 2015 -0600

    Auth: avoid jemalloc stuff on mk_passwd
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit efaaf4bc5b7fcf626739890975f1a665b5e8acc8
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Apr 6 22:47:18 2015 -0600

    Build: CMake: do not load all plugins by default on plugins.load
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit f1931b869a763cd02dba3abb303a4ee895e93a86
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Apr 6 22:46:18 2015 -0600

    Build: CMake: fix webroot for local mode
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 3a515c3c56ccddce4b367755549676924efc7d63
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Apr 6 22:44:06 2015 -0600

    Build: CMake: add missing path for PIDFILE on local mode
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 3691c6e7aa0d29722dec85b7d611964c3dc1d689
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Apr 6 22:40:15 2015 -0600

    Logger: do not double print-error on configuration problem
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit e7ecaff35172a3a51b3455e7a6c832917197dd70
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Apr 6 22:39:12 2015 -0600

    Mandril: validate configuration file
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 5cbdb271cd13856abc40f4640c38a83b32ffabe2
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Apr 6 22:37:50 2015 -0600

    Logger: validate configuration file
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit c61be3be4f83a605c568e5c9560823f248a775e2
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Apr 6 22:36:56 2015 -0600

    Dirlisting: validate configuration path, unload plugin if it fails
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 1368045797ce61df56f9f1c640343d243d03fbe5
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Apr 6 22:35:47 2015 -0600

    Cheetah: unload plugin if configuration fails
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit e32bb45a3f0e9a189b50804c6e3b1b77c1ebfd95
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Apr 6 17:16:24 2015 -0600

    Auth: remove unused configuration example
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 77a61dbdd5b2db3e7356e129aa9bc4d7a578f47f
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Apr 6 17:14:48 2015 -0600

    Auth: build mk_passwd in tools (add CMake rules)
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit f5988a4d8a81fcdd5cb66c4b729066c8a31c1979
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Apr 6 17:09:33 2015 -0600

    Build: CMake: add support for --includedir/-DINSTALL_INCLUDEDIR
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit b6ffe187675f028a1d6d0b6688155e247855fb55
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Apr 6 16:52:10 2015 -0600

    Build: CMake: fix mimetypes installation
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 31c7db4f327773fec8ee76c5ad81187c31e3097c
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Apr 6 16:48:46 2015 -0600

    Build: CMake: add support for --webroot/-DINSTALL_WEBROOTDIR
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 29599e4beb508996bbb889ba1151f90440988f39
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Apr 6 16:27:41 2015 -0600

    Build: CMake: add support for --pidfile/-DPID_FILE
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit f9d7c6e2e8d5a090c26c86dc737682f87967fa3f
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Apr 6 16:17:23 2015 -0600

    Build: CMake: add support for --logdir/-DINSTALL_LOGDIR
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 690e68ad3589c6d34e0c98f417481d8599ffad15
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Apr 6 16:06:12 2015 -0600

    Man: drop unused man pages
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit cfb1cbb847dfa692f7a0bbd75290a614006954f5
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Apr 6 16:03:56 2015 -0600

    Build: CMake: extend support for install libs and others
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 3d17830ca7a18d4dda34be183e7d7e897730a347
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Apr 6 10:27:44 2015 -0600

    Build: CMake: generate plugins.load on plugins/CMakeLists.txt rules
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 4ccab82c3d38c27b995ab031768d428e3142f17c
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Apr 5 22:55:49 2015 -0600

    Build: CMake: improve config files decls and fix static linking
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit fbdf82de06459fe8b6d3bc6fc464a278ee3614c9
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Apr 4 19:29:56 2015 -0600

    CI: fix script line
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 733acfe88a05b23851a920738b497410396ce44b
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Apr 4 19:26:35 2015 -0600

    Build: Memory: fixes on CMake for Jemalloc
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit fe4a2d48c564b0066036ae6d00730cf5b90f6c66
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Apr 4 18:47:42 2015 -0600

    Liana: add missing CMakeLists.txt file
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 2bf4ab6a26dd402d8a9f60aa013d083683f8dcba
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Apr 4 18:45:51 2015 -0600

    Build: add root Makefile helper
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 09c6b2ab6fc31ed1d8c2f476e7a735cdb90a5ce0
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Apr 4 18:43:35 2015 -0600

    Cheetah: add missing CMakeLists.txt file
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 2d2d0a9c27e8fdfe8ef9fe8f350eed886c986891
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Apr 4 18:40:07 2015 -0600

    Build: CMake: fixes on MK_BUILD_PLUGIN macro
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 6f994da1c8d0712d3518df3e2d07bd89d22e7da0
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Apr 4 18:18:29 2015 -0600

    Build: CMake: fixes on data to stdout
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 206e1d0a6ba148abeb1c1e40f061ee40e078208a
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Fri Apr 3 22:40:10 2015 -0600

    Build: CMake: support enable,disable and static plugins. Configure script stripped!
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 1e4d9432fae2e9b6b0d5dae44846985c4d0ed353
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Fri Apr 3 16:04:23 2015 -0600

    Build: CMake: add definitions and support for Jemalloc as external dependency
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 775c187e07750a91831fb9c646a1f04120b2990e
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Fri Apr 3 14:28:48 2015 -0600

    Plugin: remove old proxy_reverse plugin
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 79c046f854c96fd030a344c5a137d867a8231fc0
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Fri Apr 3 14:28:22 2015 -0600

    CMake: remove old reference to unused plugin
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 52b8ca8f6a77c9f7f1b589fbdfe749290cebf48d
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Fri Apr 3 14:23:56 2015 -0600

    Mandril: add build/cmake support
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit a3e21879c97f0b8f4d1b91ab25a7b7c45110dc7a
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Fri Apr 3 14:22:15 2015 -0600

    Log Writer: add build/cmake support
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 5b23faef2dfa9a463f328e79eed5451043e3eab2
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Fri Apr 3 14:18:13 2015 -0600

    Directory Listing: add build/cmake support
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit a6dcfe002a15b6cb434d9c5ea608d5c6636f1861
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Fri Apr 3 14:15:33 2015 -0600

    Cheetah: add build/cmake support
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 17c41f42e548c3233c9b577ff66bf64dab4d7b29
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Fri Apr 3 14:10:41 2015 -0600

    CGI: add build/cmake support
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 0610a5355103e1bb1d70bf321fd36cbc15b428e1
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Fri Apr 3 14:04:32 2015 -0600

    Build: CMake: Plugins: drop library prefix 'lib' from shared targets
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 70228379c2bee857bc12a6d576e7ee0b83b42d31
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Fri Apr 3 13:00:43 2015 -0600

    Liana: add build/cmake support
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit ad2d252fcf1efd1412fe40ad480e91564152d6d6
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Fri Apr 3 12:58:22 2015 -0600

    Build: CMake: support to build plugins
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 93bc2b199b2e8e1c06e09ae0dc224e6f0fbb9e38
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Fri Apr 3 11:10:30 2015 -0600

    Build: CMake: generate mk_env.h using a template
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit a6534a25d0f0907ebdeea5b55efb97d3f5248632
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Thu Apr 2 14:25:22 2015 -0600

    Core: use new definitions from CMake
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 33349e41c421dcf8cc8886f9fd0cd509855f77e7
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Thu Apr 2 13:50:44 2015 -0600

    Build: CMake: generate conf/sites/default using a template
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 4abab291cd9fb6b2ad734e170d15dbb792a1bfd6
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Thu Apr 2 13:40:36 2015 -0600

    Build: CMake: generate monkey.conf using a template
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 0b8d21efee1ff13b9e4e09cf284503e76b3f415c
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Thu Apr 2 13:22:43 2015 -0600

    Build: CMake: generate mk_info.h
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit eb7a77215a866e8ea7b12260938397cb4ac102b2
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Thu Apr 2 12:56:03 2015 -0600

    Build: start migration to CMake (yes, I changed my mind)
    
    This patch adds the first changes of the migration from the old
    bash build system to a compatible CMake.
    
    This is still work in process and it aims to keep a generic 'configure'
    script with the same options than before but it uses CMake in the
    backend to validate dependencies and generate the Makefiles.
    
    I will explain later why I changed my mind about this in blog post, for
    now there is a lot of work to do. :)
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 251e33194263ab22b9cf67c632007f484a9e1ae5
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Mar 25 17:46:58 2015 -0700

    File: new 'mode' flag for file_get_info()
    
    this patch adds a new flag to the file_get_info() function to determinate
    which kind of permission the caller want to check.
    
    It also modify all callers in the core and plugins.
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 007f681c1d6b87e3221afb1a51297087f0d6bc5d
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Mar 9 09:30:26 2015 -0600

    Stream: fix debug function for OSX
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 405ca7483bf6ba436c93c86b8d99533bcb54c39b
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Mar 9 09:15:11 2015 -0600

    Header: fix CORK usage on OSX
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 7e08773fe192ab083e23b15b78e86fed3669b641
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Mar 9 09:13:04 2015 -0600

    Socket: move socket_accept at the end to avoid func declaration problems
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit e0d713a4679b8b78b948f8090e1d547889dec3be
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Mar 9 08:53:30 2015 -0600

    Build: move -rdynamic to linker LDFLAGS variable
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 3f7d9be01d8941d5aa8dae34d2c46664c1e43950
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Mar 8 22:13:01 2015 -0600

    Stream: set fmt default for trace mode
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit bfaddc73e70e11b9e5a0142bc86377d669aa1cb1
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Mar 8 22:07:32 2015 -0600

    CI: disable CGI and FastCGI on Travis
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 72babe73941ca87d4eb6678842d710f8dbfc3442
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Mar 8 21:38:00 2015 -0600

    Socket: remove unused tcp_autocorking() function
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 05538a448de1c1a17f97f07576b9882d3e04ebda
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Mar 2 14:49:22 2015 -0600

    Scheduler: fix wrong handling of incoming queue.
    
    Under high load with many invalid (not finished) connections, the
    scheduler incoming queue may generate invalid references.
    
    This patch solves the problem validating the sched node status.
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 0db2a4be943a04b0f1a238af9c5a79bfce9b7d79
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Mar 8 19:51:58 2015 -0600

    Debian: remove old references of libmonkey
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit f2d96fbd630817606a66f895894fc560d8acd49c
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Mar 8 19:49:41 2015 -0600

    Lib: more cleanup from headers
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 2b5d00774b539fb87123359f85658677d263c6f1
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Mar 8 19:44:42 2015 -0600

    Lib: remove old SHAREDLIB macros and perform some headers cleanup
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 66949bc6f43cb0c79cf9ff66b44c4bcefd45d2e8
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Mar 8 19:26:51 2015 -0600

    Plugin: silence some compiler warnings
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit f60bc7302539b17670c82712795244ee7777dbd1
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Mar 8 19:19:03 2015 -0600

    Mandril: fix headers
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 3fa454adb8ecd9c42945545f27b2f52ef93c446e
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Mar 8 19:17:52 2015 -0600

    Logger: fix headers
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 2dda685cecd01674f431eedd30d23bfd7e5bffe2
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Mar 8 19:16:48 2015 -0600

    FastCGI: fix headers and disable until check it works with new API
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit f5317ee11ecf79840e6cbb6e1276b50fc5ea08dc
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Mar 8 19:09:17 2015 -0600

    Cheetah: fix headers
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 115039f61b2fd584b0bf11c283eacc1cabbf2a48
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Mar 8 19:07:38 2015 -0600

    CGI: fix headers and disable plugin until new API takes place
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 271811e7c3ec0ae6618c52fe2cc5d6561f2b019d
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Mar 8 19:05:34 2015 -0600

    Auth: fix headers
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 69511b932f1120e867dea14b519681d06ded99d1
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Mar 8 19:00:44 2015 -0600

    Lib: deprecate library implementation.
    
    This patch removes the library mode as in the next changes Monkey
    will become a library it self.
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 8fc94330ed321b8d5c503e7e714a78907674672d
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Mar 8 18:57:00 2015 -0600

    Headers: fix server name
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 86b3e938f55f1d012aa913bfa3f07fa886b91b66
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Mar 8 18:51:19 2015 -0600

    Core: Network: move accept callback to the core.
    
    This patch deprecate the accept() callback from networking plugins
    and place the functionality directly on the mk_server.c code through
    an inclusion of mk_socket.h (static inline).
    
    It also perform some headers declaration fixes to align to the change
    described.
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit ffd5f5eae81723b7015b2c3ff3157592ff8ae148
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Mar 8 17:39:26 2015 -0600

    Directory Listing: align streams structs declarations
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit b480ec3e32bb9fb24297fbc25cda5e261504660b
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Mar 8 17:38:02 2015 -0600

    Core: Stream: use structs instead of typedef
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit f8b8d5781a07cc322e1b9a2e3e9c8410dba90967
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Mar 8 17:34:37 2015 -0600

    Directory Listing: enable chunked encoding (not functional yet)
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit f38c68f8c9c8ada20bb29508d849caa8f810bce5
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Mar 8 16:02:53 2015 -0600

    Directory Listing: update API to use new Monkey streams.
    
    this patch modify the directory listing plugin to use the new streams
    mechanism, it works in async mode but it still requires the following
    improvements:
    
     - Enable Chunked-Transfer encoding once the core start supporting it.
     - Improve entries handling and enqueue N instead of 1 per write event.
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 00482feeee753e396ae7664675e2b3a93be87110
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Mar 7 14:19:02 2015 -0600

    Stream: fix initialization and streams linking
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 4ac4bcc60010f96893cedff3327b03bc9e119854
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Jan 26 20:59:27 2015 -0600

    Stream: accept custom 'data' by reference in functions
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 0c5d113bce0cb3b4396e6dfc4f5734a8a691bd66
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Jan 26 20:54:00 2015 -0600

    Stream: new 'data' field for custom references
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 0e37bc34d825acf9a9265d90f7e83331d4027f8b
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Jan 26 20:52:43 2015 -0600

    Stream: rename data field as 'buffer'
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 4f330264ba340a8d3ffc8c0241624cca1a3d5ddb
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Jan 26 18:09:35 2015 -0600

    Plugin: fix exit_all handler
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit b252648ddd1e7382fa55ababa33abdf21839e641
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Jan 26 08:53:44 2015 -0600

    HTTP: fix redirection for missing ending slash on directory request
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 0ce6955f31e354a384d0ec3fc852ed1f713ec874
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Jan 26 08:14:57 2015 -0600

    IOV: deprecate MK_IOV_ macros, use Monkey MK_TRUE/MK_FALSE
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 00f15d2950bfd95bf9668dccb2d461efb0d4d738
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Jan 26 03:49:08 2015 -0600

    Stream: on HTTP static file, set the Stream Channel.
    
    This patch fixes a problem when disabling the TCP_CORK. The Stream
    did not contain the channel reference.
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit bb0719c67fe76a3d93df866314002e90a3c6df73
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Fri Jan 23 12:50:36 2015 -0600

    Auth: use new Streams API to send headers response
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit edc0d1a7825ee91924aa35182ee08f43810e6374
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Fri Jan 23 12:48:03 2015 -0600

    Plugin/API: export Channel/Stream API
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 1f5a90489c51e7a2cfd48bbea80c3e5e290c3fbd
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Fri Jan 23 12:18:40 2015 -0600

    Auth: fix server signature usage
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 512fd58c9c0435d7433a4649286ae11acf0e1aec
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Fri Jan 23 12:14:42 2015 -0600

    Plugin: disable shortname plugin on trace
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit dfdc4d5f323c6485c5009f0c317560ef579078a5
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Fri Jan 23 12:07:21 2015 -0600

    HTTP: mark two variables as unused
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 6e4e916851d61630ed72c7cbd8aa435f94fb3df3
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Fri Jan 23 10:56:34 2015 -0600

    Core: on server exit, fix some minor leaks.
    
     - Mimetype headers
     - MK Event loops (epoll/kqueue)
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 00a64181f4987139ac2e5df23ce6abfa6c5cb0cb
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Fri Jan 23 08:50:01 2015 -0600

    Core: new option -I, --pid-file to override PID file path set by configuration (Ref #173)
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 2ba417f2ee344f4981b819b6a2cfde05b65597f3
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Fri Jan 23 08:31:25 2015 -0600

    Core: Check Listeners at start (Fix #173).
    
    This patch implements a new mechanism to test if a Listener interface and
    TCP port are already in use through a basic TCP connection. This check
    is required as the sockets can be in shared mode (SO_REUSEPORT) we need
    to be aware if other Monkey instance is already running.
    
    If the test claims there is an interface busy, it will abort. But we give
    the user a new option '-T' to override this failure and proceed anyways.
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit f4b57a5016a19a1cdc8bcff65599bea69cfda4c5
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Thu Jan 22 18:09:01 2015 -0600

    Server: scheduler mode is now optional and other improvements.
    
     - scheduler mode is optional using new -B argument.
     - balancer use monkey event API to handle connections.
     - code cleanup.
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit d308add756c75bf9b081f81d5af4cbd8b95a1c66
Merge: 7549514 1fa31d3
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Fri Jan 16 23:28:32 2015 -0600

    Merge branch 'streams2'

commit 1fa31d3b97714923cb63f9a8abfb4279acbf9664
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Fri Jan 16 23:18:10 2015 -0600

    Core: improve stream handling and Cork options (KeepAlive slow)
    
    this patch makes improvements when using the streams to dispatch responses. As
    well it take care of the right usage pf TCP_CORK (Linux) and TCP_NOPUSH (OSX).
    
    KeepAlive mode is running with a delay between each request, still work in
    process.
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 754951414210e3496ebcb725637c2bb56ebc12bd
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Jan 10 09:28:29 2015 -0600

    HTTP: Parser: optimize performance, try to catch protocol version by chars check
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit cfd4bcf1d5d040f9d4a4eebe32a54ec74d5f1f1e
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Fri Jan 9 10:00:14 2015 -0600

    Clock: Header: pre-set Server and Date headers, reduce one mk_iov
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit bc653cadc2ffaf8dd657b6c6960e23e6f4bc6cfc
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Fri Jan 9 09:22:49 2015 -0600

    Core: move server signature to global config struct
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 1ba2aa963d906d71bf44952f611a98aeb836a90c
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Thu Jan 8 16:06:53 2015 -0600

    HTTP: Parser: pack structure and remove alignment
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 481cd277a6a46c974e3412121b0cf5e038095520
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Thu Jan 8 15:52:21 2015 -0600

    HTTP: Parser: do pre-rolling check on header comparisson, performance improvement
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit ae6711912995c0f2fe0d4991ecc4f109b674830f
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Thu Jan 8 13:23:47 2015 -0600

    API: remove old plugin (MK_EXPORT) declarations
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 3397d97cfddcfc829511416e7095e295ebe192b0
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Jan 6 23:04:21 2015 -0600

    Core: dispatch headers and static files using Streams
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 5cfaf8967d535cea95d3d4f540e9ee2cd1003816
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Jan 5 21:21:52 2015 -0600

    Streams: initial implementation of Streams and Channels.
    
    This patch implement the Streams concept which will be the interface
    to enqueue and dispatch data.
    
    Taken from a conversation with Sonny over email, here is the description:
    
     "I think this is the point where the Channel concept joins, a socket is
      represented at high level by a Channel, which contains the references
      to the callbacks for each event and also the transport layer to be used,
      and who handle Channel events is the Scheduler.
    
      A Channel have two directions IN/OUT and each one managed by a list of
      Streams: socket, iov, raw buffer, etc."
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 8a8abb2f36a62381f7f55147e174178bf809c715
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Jan 4 20:55:42 2015 -0600

    Plugin: deprecate old stage_run routines
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit f615e9625e7976c1ba20b4bfa5edeb1b7f07cc66
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Jan 4 17:17:03 2015 -0600

    Core: support new PTHREAD_TLS mode
    
    Monkey support threads, and when sharing global data on each worker it does
    it by using the Compiler TLS (Thread Local Storage) feature.
    
    TLS is a compiler specific feature, it works on GCC and CLANG. As it can be
    considered a *new* feature on compilers, some legacy compiler versions or
    custom toolchains for Embedded do not come with that feature.
    
    This patch adds a new option called PTHREAD_TLS that can be enabled on the
    configure script through the --pthread-tls option. When enabled, instead
    of TLS, Monkey will use Pthread Keys for the same purpose.
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 0ecc932cb877831c539a01e3a57c3673b3333d62
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Jan 4 20:33:48 2015 -0600

    Liana: remove unused header reference
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 4db8df50271207b06dedb6f1a09a3e4e57d654c5
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Jan 4 17:26:07 2015 -0600

    Build: use environment variable to set AR
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit d59d7db6ae8d1f89e120464938ad61415bd58722
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Jan 4 13:40:56 2015 -0600

    Logger: use new mk_iov API
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 03989f4bdb91cca890cf42098907de1b2dda1790
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Jan 4 12:32:25 2015 -0600

    Configure: detect STATIC Plugins by default
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit e99756f3253542566ddc3e9219c978852576cbfe
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Jan 3 10:45:15 2015 -0600

    HTTP: Parser: improve method lookup for known methods
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 3c463a34eee1223fb7b3b8d0d220cdbefb82b998
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Jan 3 09:30:46 2015 -0600

    IOV: remove separators implementation
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit d262dace63e389ddeb468ca1540cb1abf0849b57
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Jan 3 08:53:04 2015 -0600

    Core: Plugin: separate stage_run routines
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 348f972ba4117c0213c78ccc8a2cea52dfafe470
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Jan 3 00:25:58 2015 -0600

    HTTP: restore performance on Linux for small static files.
    
    Later on 2014 Monkey performance got decreased when serving few bytes
    of data on Linux. A fix for OSX generated a performance issue on Linux
    that is only faced when mixing sendfile(2) and TCP_CORK.
    
    This patch implements the fix for Linux, now it increased performance
    up to ~24% when serving small static files. Monkey is rocking again :)
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit d796c9ca2081368bdd2bb9c4a83c74098402175d
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Fri Jan 2 23:32:26 2015 -0600

    Headers: optimize composer of response headers
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 66bff035168d835ff87ee8bb6fe771effd3d11ec
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Fri Jan 2 22:58:32 2015 -0600

    HTTP: Parser: after first header key character check, do a continue
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit bced74cb1b81bdd4823825ccc9e4e53dd207da6a
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Fri Jan 2 22:42:57 2015 -0600

    HTTP: Parser: on CR, try to catch LF if there are some remaining bytes to check
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit ecf23216d71005e930aa980de738961bb4dbb267
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Fri Jan 2 22:20:34 2015 -0600

    Configure: fix static plugins code generator
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit c71d9fcf03a35de5d4e0acc7a3c7bc0b0e64c625
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Fri Jan 2 21:22:47 2015 -0600

    Core: global confix context rename from 'config' to 'mk_config'
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 9fa29382bb73e4c5bec2e8bdf7b46ee1cdd9c255
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Thu Jan 1 10:18:49 2015 -0600

    Copyright: welcome 2015!
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit d5ba99de550c7385d65afe23e16b412ede2d2cea
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Dec 31 17:22:45 2014 -0600

    Logger: fix callbacks for local worker
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit da599328f589ad681da90a2f84b7d1c73ddf3db8
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Dec 31 17:18:38 2014 -0600

    FastCGI: fix declarations
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 5a16b1882821032d8f2622eed8c8f243235fe6f6
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Dec 31 17:16:02 2014 -0600

    Plugin: allow plugins without direct hook type
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 21bd9a16408ca21ea92e5353819dee7c8d0eaab8
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Dec 31 17:05:15 2014 -0600

    Logger: fix pointer initialization
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit ef95e85a72beeac780fb66795e62d9f53a411cba
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Dec 31 17:02:01 2014 -0600

    Mandril: migrate plugin schema to new model (support static linking)
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit dfd9994cc60e5ff498b0cbf7198749d9499fe2d3
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Dec 31 16:54:25 2014 -0600

    Logger: migrate plugin schema to new model (support static linking)
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit d658b432cfaa70c8991f04915b42a2244bedb405
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Dec 31 16:42:33 2014 -0600

    FastCGI: migrate plugin schema to new model (support static linking)
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit d5553e62da6c634b6e5ff505f3f087bddc8b1471
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Dec 31 15:05:47 2014 -0600

    CI: Disable library mode on Travis
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 1aefdc9430e46ef573c2f0a34e1f658442059f5e
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Dec 31 15:05:00 2014 -0600

    Dirlisting: migrate plugin schema to new model (support static linking)
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 2abfc62e7d24f67b191d1d893a98daaf04def470
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Dec 31 14:56:45 2014 -0600

    Plugin: restore stage macros
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 701cefe16c89490b961c003d0636751b48fb81de
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Dec 31 14:55:39 2014 -0600

    Cheetah: migrate plugin schema to new model (support static linking)
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 6dd04787f72fe1ec3830813e4b9acc65240afd71
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Dec 31 13:46:59 2014 -0600

    CGI: migrate plugin schema to new model (support static linking)
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 4523f0b3a3486095797af51984ada700ac64ebd1
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Dec 31 13:34:10 2014 -0600

    Core: Plugin: re-implement stages setup and callbacks
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit d1ee9d2836336cfbe13aa4f9ac6bf8765bb1e3c3
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Dec 30 14:47:04 2014 -0600

    Core: Plugin: remove old structures for plugins
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit de6102471a27ab5cff5ceb583aa562c05e89d79a
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Dec 30 11:43:53 2014 -0600

    Auth: migrate plugin schema to new model (support static linking)
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit f345bd2b48846a962da66d4a6448d5c995b1cefe
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Dec 30 11:19:03 2014 -0600

    Plugins: remove old API.txt doc file
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 59fbe838e53b68673a9fbbf5de66dad6e445c144
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Dec 30 11:14:49 2014 -0600

    PolarSSL: migrate plugin schema to new model (support static linking)
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 79a8a90137e316152a3ad312a56bfcdab046a04d
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Dec 29 23:43:55 2014 -0600

    Config: do not warn on Sections without keys
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 9e64323f73c9785e51c509187eaf68fb8a21dc7b
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Dec 29 23:39:43 2014 -0600

    Core: Plugin: load dynamic and static plugins
    
    This patch makes able to load plugins in static or dynamic mode
    for those who provides a NETWORK_LAYER (Liana on this case).
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 0c37330d7bc03d9910c1295f1945346be18fc72c
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Dec 28 20:25:33 2014 -0600

    Core: Plugin: Let build system hook static plugins
    
    This patch implements a new option on the configure script called 'static_plugins='
    where is possible to define which plugins will be build in static mode. Also the
    core is able to detect the statics and link them in the global configuration.
    
    More work is required, but this is a good progress. Just tested on Liana plugin.
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 241964ca3180606fe6f1ca3762c115841020ba97
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Dec 28 09:41:10 2014 -0600

    Liana: Build: add static build support
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit ea4e2c1d51438aaab839fe943c3c668734dfb74a
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Dec 27 16:37:20 2014 -0600

    Core: Plugin: Network layer functional in workaround mode
    
    This patch makes Liana work with the new plugin mechanism. More
    work is required to re-enable stages and hooks for other plugins.
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 36efede314d2d66c6876bdb76070e943be63108b
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Thu Dec 25 22:53:28 2014 -0600

    Core: Plugin: new draft of plugin mechanism (wip)
    
    This patch adds a new mechanism to load plugins, at the moment it only
    do some partial replacements over the Liana plugin adding a new structure
    to define callbacks for certain I/O network operations.
    
    note: work in process.
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit e8100255efb586abe26978e41be69950b99859d9
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Thu Dec 25 17:18:01 2014 -0600

    Mandril: use new Monkey structures to handle sessions and requests
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit f085ed3e75f815366385f53f81e901d56047dc89
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Dec 24 15:20:18 2014 -0600

    Logger: use new Monkey structures to handle sessions and requests
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 2f66a51dcc3ad6b5d1dfde440f5266583f480f9c
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Dec 24 15:19:11 2014 -0600

    FastCGI: iterate headers using new Parser Headers list
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit cbb361e6af331ea169106beae80162eb67617355
Merge: 16be561 307a10f
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Dec 24 14:59:11 2014 -0600

    Merge branch 'fastcgi_upgrade'

commit 16be561926ce5b1406c228b1c76b8c87533a8b4e
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Dec 24 14:56:32 2014 -0600

    HTTP: Parser: register headers in a parser linked list
    
    This patch implements a linked list in the parser so when a known header
    or extra headers are found, they are linked to the list so any plugin
    can iterate them without problems.
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 307a10f31f8425fd6a0c00de6145f0d0c328ee56
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Dec 24 14:47:32 2014 -0600

    FastCGI: use new Monkey structures to handle sessions and requests
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit ca3273b5ca3617f378f4c71f66eb4f6a4108b22b
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Dec 24 13:36:22 2014 -0600

    Dirlisting: use new Monkey structures to handle sessions and requests
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit f10d6eaeb91fff4b854dcab133829516cd2262a0
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Dec 24 13:33:51 2014 -0600

    CGI: use new Monkey structures to handle sessions and requests
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit b4b0202dfc9a022b99f33ae9dbd26eee42fb8e1f
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Dec 24 13:30:49 2014 -0600

    Auth: use new HTTP Parser API to manage Authorization header
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit e3c59ac5b8702e74286ce17f8efa2c87e233046a
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Dec 24 11:59:37 2014 -0600

    HTTP: Fix Content-Length array index
    
    This patch fix a static workaround implemented to by pass a double
    definitions of headers strings, it basically did two things:
    
     1. Use the MK_HEADER_CONTENT_LENGTH macro
     2. On header.h move some definitions to the .c file
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit ee783ad26b9bb97602e66d4c5ac4c78cc7210861
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Dec 22 00:23:35 2014 -0600

    HTTP: Parser: add lookup support for 'Cache-Control' header
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit b0ed0172fc6b1cc27b7cae387b53e388fd182d29
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Dec 21 23:52:38 2014 -0600

    Core: make header_get() usable with new parser internals
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 4aba21b6db2213150c945e5af467a000e5980d10
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Dec 20 23:06:35 2014 -0600

    HTTP: Parser: initialize headers_extra_count field with zero
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 0d3575fa7bf63c5777c30e4270fcc77c4b883447
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Dec 20 23:05:10 2014 -0600

    HTTP: Parser: parser now supports 'Upgrade' value on Connection header
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit b93946c1638587e79029670ed0d2a407207da4e1
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Dec 20 23:02:50 2014 -0600

    HTTP: Parser: add support for 'Upgrade' Header
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 6c075d7acfd4a55aa3a4bbbadd2a6f015268def9
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Dec 20 22:58:43 2014 -0600

    HTTP: Parser: new parser->headers_extra array
    
    The purpose of the new array, is to register unknown/custom headers
    set by the client.
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 2f21ff44819a943239257cf31b7c153a7a6e5933
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Dec 15 13:58:42 2014 -0600

    QA: improved Keep-Alive tests
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 737895140d541b71f9276364a9ad7563f1eefd45
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Dec 15 13:48:47 2014 -0600

    HTTP: Parser: don't validate EOF on Content-Length header
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit c396ee073bf6d616d9003881230f3fdef2c17510
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Dec 15 13:37:27 2014 -0600

    HTTP: Parser: fix host string length in mk_ptr
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 0ae9da888eb9b87bb25d80e6910f94bfa1be8985
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Dec 15 13:31:35 2014 -0600

    HTTP: Parser: handle Host header TCP port
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit f0e49c171eb08f9c5959787287e5dc38c3ca7df7
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Dec 15 10:25:35 2014 -0600

    HTTP: Parser: validate protocol when query string is set (add QA script)
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 3b0454cee3a68ceca09d763faed1243f58da9956
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Dec 15 10:20:00 2014 -0600

    HTTP: Initialize request->port field
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 7d2f51fff68439962d0a53537235fbb1e07a72eb
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Dec 15 10:18:19 2014 -0600

    QA: Fix error_413_02 test, send a very long request
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit bdfbcd8c437101430de8cc28393077c63be086d6
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Dec 15 09:45:26 2014 -0600

    HTTP: Parser: support insensitive headers RFC2616 s4.2
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 2551ee37f8a3793e1ca423e862d6961a6f05dbde
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Dec 15 09:03:26 2014 -0600

    HTTP: fix code indentation
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit d5f2d97aa8a05b0c4aa656ffdc099961c5ee2094
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Dec 15 09:02:27 2014 -0600

    HTTP: Parser: extra checks on protocol and error page fixes
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 94a8ab5934276c84040f0831efd623f7d82eb0b4
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Dec 14 23:11:16 2014 -0600

    HTTP: Parser: return BAD_REQUEST error on bad-formed protocol
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit c3207c9bf502c23970ceb1704dbe063e01241b27
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Dec 14 22:58:36 2014 -0600

    HTTP: Parser: validate protocol version
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 9c3cf34a773c226058bf6a277921ff6f8fe1af46
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Dec 14 22:44:11 2014 -0600

    HTTP: Core: initialize request and headers flags
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 72be121d33d45e8baa939dd0f4624b03d880e949
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Dec 14 22:39:28 2014 -0600

    HTTP: Parser: handle MK_CLIENT_REQUEST_ENTITY_TOO_LARGE
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit d25172c6d2805bfe7e94e86f3e51f1d693c49589
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Dec 14 20:56:52 2014 -0600

    HTTP: Parser: validate Content-Length is set on POST/PUT requests
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit f8a173e7047b682c5c8b862c953860c6a88974ab
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Dec 14 02:20:04 2014 -0600

    HTTP: Parser: fix iterator limit
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 7ae62fc1d5ceb25c71f1c830af0f621782dc0755
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Dec 10 17:58:30 2014 -0600

    HTTP: Parser: fix handling of KA connections
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 4ca7fff7acc7834e0907c80c3c8f7710a364b625
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Dec 10 13:28:09 2014 -0600

    Connection: fix body length passed to HTTP parser
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit ef515294a28c6b5c06663c9c9d589f3b7b58fb46
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Dec 10 13:08:36 2014 -0600

    Server: improve behavior when accepting a new connection
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 7bc851668797f2f06c594f392353f1609444cd9e
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Dec 9 14:44:50 2014 -0600

    HTTP: re-enable support for Keep-Alive check.
    
    This patch re-introduce the detection of the Connection header value
    and do some logic steps to determinate if the connection should be
    keep open as in a keep-alive state or be closed.
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit d1c7cc8005fd58ce78489440f9b178ead838f3b5
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Dec 8 21:33:37 2014 -0600

    HTTP: little improvement when initializing parser.
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit b99037eccba56c008481d4442593d66faacaa81b
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Thu Nov 20 17:28:56 2014 -0600

    Connection: link fixed http_request from http_session
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 9f1595d0cf9d3d4957a8b7741e9b5d07a1a9bafd
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Fri Nov 7 22:34:30 2014 -0600

    HTTP: more code cleanup (wip)
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 27a6e9e359adf76519c46c0bc2b5230f13f091d7
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Fri Nov 7 13:34:19 2014 -0600

    HTTP: merge parser results on http_request
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 7fbca6e347c4bef7b1c31620b59259b2cb9cf4b5
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Fri Nov 7 10:38:11 2014 -0600

    Core: refactoring structures and HTTP parser
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 5dde82f851c1e13ef14360c8b92f0dae05378e2c
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Nov 4 21:58:51 2014 -0600

    Core: small fixes when building in TRACE mode
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 690eb05d57d9c8f1c1941285926fb3ea0192ad54
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Nov 4 21:57:23 2014 -0600

    HTTP: do not include old mk_method header file
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 6dfb5b744a52401c2c117b9011be35216d4c17e7
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Nov 4 21:40:35 2014 -0600

    HTTP: new parser and main structures refactoring
    
    This is the first patch of a big change that is coming, it does:
    
      - deprecate mk_request.[ch]
      - deprecate mk_method.[ch]
      - replace struct client_session by struct mk_http_session
      - replace struct session_request by struct mk_http_request
      - new HTTP parser mk_http_parser.c
    
    At this moment the server 'compiles'. It now needs to be aware about
    the new parser and also needs some cleanup on headers interfaces.
    
    the fun begins..
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit d3b498a11a8b535eae5be8d17bf290e110aa09f1
Merge: a79c038 7815bb3
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Nov 4 11:11:01 2014 -0600

    Merge branch 'master' of https://github.com/monkey/monkey

commit a79c038f5e8bbe94a2f4fbbe442aeb677488334a
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Nov 4 11:10:45 2014 -0600

    Kernel: disable TCP_AUTOCORKING (#175)
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 7815bb3932a38fb4746663eb4f66479a33426a04
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Oct 27 09:45:36 2014 -0600

    Auth: if no global config exists, just skip stage 30
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit c61969059ee58ef73492bf3fb3abb4dea87ea509
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Oct 27 09:41:48 2014 -0600

    Auth: validate that config have been loaded
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit fe65020113a4411dcf3a0446aacff8460f761e86
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Oct 27 02:04:55 2014 -0600

    Configure: enable -rdynamic
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit fb297b42b0ce66901425b5d08644432ee3155ae9
Merge: f1a5e96 b6ddb6d
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Fri Oct 24 00:03:10 2014 -0600

    Merge branch 'master' of github.com:monkey/monkey

commit f1a5e96ae40d79530b2e9eb4339642ac4784c4c4
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Thu Oct 23 14:44:07 2014 -0600

    Scheduler: proper handling when dropping connections
    
    This patch implements a new function at scheduler level that is
    used to cleanup a complete connection.
    
    It helps to fix an issue when connections are dropped from different
    sources such as: timeouts, I/O errors, incomplete requests, etc.
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>
    
    Conflicts:
    	src/mk_http.c
    	src/mk_request.c
    	src/mk_scheduler.c

commit b6ddb6d2324a4106b7c1548ef73f015c242af865
Author: Sonny Karlsson <ksonny@lotrax.org>
Date:   Wed Oct 22 13:07:51 2014 -0700

    utils: Fixes Mac Os X macro in mk_utils_worker_rename().
    
    Signed-off-by: Sonny Karlsson <ksonny@lotrax.org>

commit 7bb177644652667021c3c89dc64a2f5a961bf5b3
Merge: 1c76aaa 01bf1af
Author: Eduardo Silva <edsiper@gmail.com>
Date:   Tue Oct 21 20:17:03 2014 -0600

    Merge pull request #172 from ksonny/master
    
    OSX fixes

commit 01bf1af68a817a7b3fd7d4828b8b3d1fa6bf6f3d
Author: Sonny Karlsson <ksonny@lotrax.org>
Date:   Tue Oct 21 17:04:45 2014 -0700

    liana: Fixes for *bsd sendfile().
    
    Always update file_offset variable.
    Return -1 if errno == EAGAIN and no bytes sent.
    Use error log instead of trace for Linux sendfile().
    
    Signed-off-by: Sonny Karlsson <ksonny@lotrax.org>

commit 81e8b869d70f9da93ddfbfb17ec7f12ce3c28fc6
Author: Sonny Karlsson <ksonny@lotrax.org>
Date:   Sat Oct 18 12:11:49 2014 +0200

    http: Remove cork before first call to sendfile().
    
    This removes a large delay on Mac OS X when headers and file content
    does not fill a single frame.
    Deactivating TCP_NOPUSH does not cause pending frames to be sent until
    the next write operation.
    
    Signed-off-by: Sonny Karlsson <ksonny@lotrax.org>

commit 389e84766bece353fdb681e618691aceca38e41d
Author: Sonny Karlsson <ksonny@lotrax.org>
Date:   Sat Oct 18 11:41:17 2014 +0200

    logger: Uses stack buffer in splice() fallback.
    
    Signed-off-by: Sonny Karlsson <ksonny@lotrax.org>

commit 774859a98271668f4a51b33e7b8c017d8864a7d5
Author: Sonny Karlsson <ksonny@lotrax.org>
Date:   Tue Oct 21 18:09:27 2014 -0700

    socket: Set SOL_TCP to IPPROTO_TCP for Mac Os X.
    
    Signed-off-by: Sonny Karlsson <ksonny@lotrax.org>

commit af513bbac2d4ac56e356edb11ebe5e6be52afd4e
Author: Sonny Karlsson <ksonny@lotrax.org>
Date:   Sat Oct 18 11:36:11 2014 +0200

    util: Set thread name on Mac OS X.
    
    Signed-off-by: Sonny Karlsson <ksonny@lotrax.org>

commit 1c76aaaaf510101c07376d3c9b05f0ed01fd61f7
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Oct 19 13:45:02 2014 -0600

    Configure: improve src/Makefile output
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 9ead720f52f12d60fa0e87c6c6d091fed9919b48
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Oct 19 11:21:14 2014 -0600

    Utils: on worker_rename, fix warning on OSX
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 67973ab53e0c2a5dd44d758dc297615471c68dbe
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Oct 18 22:59:07 2014 -0600

    Cheetah: fix address length for unix socket
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 71ecbdcc2e4872ec0283ab6fd8398e6d21d3e889
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Oct 18 22:32:00 2014 -0600

    HTML: update Monkey to 'Black Macaque'
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 5176e48f879c873c9da0cb5d04ea660818a3ada2
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Oct 18 22:30:17 2014 -0600

    HTML: update info for v1.6
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 424c7d40aa0f1dba383427687ecbf19449fb9b2c
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Oct 18 21:49:39 2014 -0600

    Socket: fix warnings on OSX
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 835fb4630e93ca4a84e01caa9ea59947eefb327e
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Oct 18 21:48:58 2014 -0600

    Liana: fix sendfile() call for OSX
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 731d41ae12727090ca0a3d7903f96f74ad2c487c
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Oct 18 21:28:35 2014 -0600

    Server: do not warn TCP_DEFER_ACCEPT problem on OSX
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit b89953faf7034cf42a10b103f069498011568268
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Oct 18 21:26:13 2014 -0600

    Socket: fixes for OSX
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 92725ce811204282815a493631425fac1380c0b0
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Oct 18 21:23:44 2014 -0600

    Configure: drop -rdynamic from Makefiles
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 27992a0daabea32f0b2a149b6689505175852576
Merge: ad133f8 b841ec2
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Oct 18 20:47:39 2014 -0600

    Merge branch 'logger-event'

commit b841ec20299b33930b213ebbc25a98800c7d2a4f
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Oct 18 20:47:03 2014 -0600

    Logger: add support for Linux and OSX, use Events translator to iterate events
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit b6492096df03dd702cd977168d18a4c9e2ef400b
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Oct 18 20:46:13 2014 -0600

    Events: export fdt() api and add extra validation on backend iterators
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit ad133f85851c33e9680cb5df8965f13460591b99
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Thu Oct 16 10:45:06 2014 -0600

    Scheduler: trigger exception when registering a client that already exists
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit e0d86fd358946e35bab5f916b8580684c5c67a9a
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Thu Oct 16 10:37:42 2014 -0600

    Request: trigger an exception when an entry already exists on the rbtree
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 80815f28b0ee26fef2332cd7635aea3450c5ff64
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Thu Oct 16 10:32:31 2014 -0600

    Macros: new mk_exception(), similar to mk_bug() but without conditional
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit c997b057edaeb8512f264a58e365c338482c4952
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Oct 12 17:35:22 2014 -0600

    Liana: add support for OSX sendfile()
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 31b767bbe75c034d0d2918a8ebb853720fd05741
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Oct 12 17:23:09 2014 -0600

    Utils: support worker rename just on Linux
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 03dbbf8ea4ab9ceaf6d38611939723098a2b4ff0
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Oct 12 17:18:05 2014 -0600

    String: add memrchr() function as OSX lacks of it
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit cc1919843389b39a4a961ad574b3ef125afdfe76
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Oct 12 17:15:19 2014 -0600

    Socket: fixes to support Linux and OSX
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 62b266905f4e7025f3a135b0bd8a226333a7d856
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Oct 12 17:04:57 2014 -0600

    Signal: remove dependency of features.h
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 30ac42fd066d5a5dbf2cf854268ed0004070f0c1
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Oct 12 17:04:19 2014 -0600

    Scheduler: support thread id for OSX
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 7f4d2aefc0ec9cdd1c5ad43957d4afb6d27ce4e8
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Oct 12 17:01:51 2014 -0600

    Scheduler: remove old direct dependency of epoll and eventfd
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit ef016abe806b97998fab59bd251f69dc66c410d2
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Oct 12 17:01:10 2014 -0600

    File: use O_NOATIME just on Linux
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 669c9330122d3687f3965bd0c4447f611b56db26
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Oct 12 16:56:03 2014 -0600

    Configure: check_generic() now accepts new parameter for defines
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 55e2a683383c246c3d3d09359e86eaf37ba65d8d
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Oct 12 16:46:20 2014 -0600

    Configure: find: use -type instead of -xtype (OSX friendly)
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 4af9151e1521c4cdc2fd224aede9e8a1c2ddab23
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Oct 12 16:45:03 2014 -0600

    Configure: support 'sed' options for Linux and OSX
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 5d8e70421b6074edc5f6ddf16b7d0e24c491adb2
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Oct 11 23:46:51 2014 -0600

    Config: reset address of listener on setup
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 64e032b66d5f840f58d24e04875df8ddd9ef7c9b
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Oct 11 23:09:01 2014 -0600

    Config: on listener read, do not continue on loop
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 98be899bb28214486c35fa6ab52419515131f4bd
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Oct 11 22:33:52 2014 -0600

    Event: on initialization error, release memory
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 94676f37dfdc002007b6e3683236ed79c6816489
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Oct 11 22:32:51 2014 -0600

    Config: fix mem leak on 'address' when using multiple listeners
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 0e741727b13e6c83daa3a32592d101a65ce628d2
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Oct 11 22:26:22 2014 -0600

    Vhost: when find a docerror exception (config), do not leak host
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit fa0ea796f4c069b605234fcadc5aa81c3b78f908
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Oct 11 22:23:52 2014 -0600

    Config: on config create, do not leak indent var
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 23bf3f2c6f20b8a0958ddea03a0ff4816cc1decb
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Oct 11 22:22:51 2014 -0600

    Config: on config create, do not leak file handler
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit f95d28ea02d34ce83e5f3e6f02550d807cbff839
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Oct 11 22:21:44 2014 -0600

    Config: abort if SECTION config is not found
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 91f58ae6c4b5f1134d972515f5ccb9d15e74d362
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Oct 11 22:20:08 2014 -0600

    Request: check status of cork_flag set
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 08b7a135b673deb02150e401bc04c116bd7d55a7
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Oct 11 22:17:35 2014 -0600

    HTTP: validate return when sending headers on redirection
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 3095600949656fe76d102251be6bb64d89612152
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Oct 11 22:15:28 2014 -0600

    Mimetype: fix leak if initialization fails
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit f330be3527e9cfe04049f4e4147a7847865eadd7
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Fri Oct 3 11:35:40 2014 -0600

    HTTP: do not allow GET with body data
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 96a82376061935ccc06d7610998e0b49f4bf47af
Merge: 92fcaa1 1f840f0
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Sep 24 23:28:35 2014 -0600

    Merge branch 'master' of github.com:monkey/monkey

commit 92fcaa1963b2ac7c0e021ec80f8ce7dbea8966ee
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Sep 24 23:28:24 2014 -0600

    Conf: validate sections
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 1f840f0674b3e94c2db1303b759973b2fc7fd1fa
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Sep 24 16:04:03 2014 -0600

    User: use memcpy() instead of strncpy()
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit f29a133cb92fac74e6642c41d45eeb78c9d6e580
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Sep 24 16:02:04 2014 -0600

    Utils: use memcpy() on URL decode
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 322b011c4f6c0e80167f80955c43f513f196dc74
Merge: 24f03ef ff95472
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Sep 23 21:52:28 2014 -0600

    Merge branch 'master' of github.com:monkey/monkey

commit ff954726382476e5f7766c53860d64a5dc4bd03b
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Sep 23 10:40:35 2014 -0600

    Configure: fix override of DEFS environment variable
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 0091d4dcb91d1f00de27dc80fa0d20cad7a2da1e
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Sep 22 10:58:26 2014 -0600

    Configure: new get_realpath() to resolve script path
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 24f03ef309e9592a478701568b68cdab25f622d6
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Fri Sep 19 19:08:51 2014 -0600

    Banner: print Linux Features just if __linux__ is defined
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit d2c4058a685a2a93d54a08ff7e03caea0ea23ab5
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Thu Sep 18 09:00:59 2014 -0600

    Cheetah: print error if bind fails
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit cc764b459736ccca11f8f9a36c9393ff23857590
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Sep 17 22:25:50 2014 -0600

    Scheduler: on Fair Balancing, adapt worker capacity
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 5834427d031e726c92b6caf83c7582a94dfe18b2
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Sep 17 11:44:32 2014 -0600

    Cheetah: on server info expose events backend
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 0cf60e6b8d9895742c2f6033a8bc4047ac7beca0
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Sep 17 11:42:48 2014 -0600

    Plugin: export event_backend()
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit af4ae08fc118bf55f7952619dd6ca887596d5ab7
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Sep 17 11:26:59 2014 -0600

    User: on switch user, do not alter NOFILE limits
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit bf106fefab74448de22f60d0978b16c389870fa9
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Sep 17 10:34:04 2014 -0600

    Events: new event_backend() to identify polling mechanism
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 2c61531b8aa36477e84c8f03c8d3c3039fc4c925
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Sep 16 22:23:00 2014 -0600

    HTTP: Disable TCP_CORK on send_file on first round of data
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 0b283275cf691e120fd4a4471676569c69e7aaff
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Sep 16 22:11:16 2014 -0600

    Header: improve performance on buffers cache
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit fc577af77858db10403d8913067edb339eda4907
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Sep 16 21:45:27 2014 -0600

    Plugin: improve performance when accessing thread global event list
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 496770a6291246e39f7d45e036acd8ed3a0cf8df
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Sep 16 19:18:22 2014 -0600

    Cache: remove unused pthread keys
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 93d2f5730cb380c3dd85762a333013b25c8a8e71
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Sep 16 19:16:17 2014 -0600

    Utils: improve performance when accessing thread global gmt caches
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 1c2d028cedba355753cb67cd978f1e012ef09fcc
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Sep 16 17:10:31 2014 -0600

    Scheduler: improve performance when accessing thread sched node
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 5e2d95b2f8075f6db72d2731a9f205e1e2d217f4
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Sep 16 16:01:01 2014 -0600

    Plugin: expose ev_translate() on API
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 7c36db6f6f500b8d29304abc4398b5c2e884a3ca
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Sep 16 15:57:21 2014 -0600

    Events: kqueue: new mk_event_translate() and mk_event_foreach() interfaces
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 3ae46a119e5f80b3099a5053d8672768e686df8c
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Sep 16 15:35:43 2014 -0600

    Events: new mk_event_translate() and mk_event_foreach() interfaces
    
    Previous mechanism required to perform two walks through the events
    result array, the first one for the native backend and the second
    to export the results to a new interface.
    
    This patch implements two new interface to improve performance over
    the past scenario plus a minor change:
    
    1. mk_event_wait(): just invoke the backend poll interface, nothing else.
    2. mk_event_foreach() macros that allows to walk arround over the backend
       interface results avoiding double copy.
    3. mk_event_translate(): do a explicit copy from backend resutls to the
       public interface.
    
    This patch only apply the interfaces to the epoll backend.
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 1c8ba8561adca6d099faea1a1cb2f33d9f9826c4
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Sep 16 14:44:56 2014 -0600

    Events: remove old events data structure approach
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit e6e518457528ce5f58f17f7e531090c00f7cc01d
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Sep 16 14:38:38 2014 -0600

    Scheduler: remove unused events mask on sched_connection
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit e0ea056c00f575019554b0dbca1cb510f473dfb7
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Sep 16 11:51:03 2014 -0600

    CI: disable proxy_reverse plugin
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 009ef9ee06f59e8294bc44c61f8aceeccd250704
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Sep 16 11:47:30 2014 -0600

    Logger: replace old epoll calls by new Events mechanism
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 28bbd325d410f2bb2e86d5e4adce627625684123
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Sep 16 11:42:00 2014 -0600

    CGI: use new Events mechanism
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit b8c18ae15a052ae43a055be187b4875da44c3ad9
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Sep 16 11:39:52 2014 -0600

    Lib: adjust to new Server capacity logic
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit dcf3020ec45a6d403946130417b9354c8ca93a9a
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Sep 16 11:26:47 2014 -0600

    CI: re-enable Travis
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit dd40abe3f1fe7b58ac1b5c5fdadefe94bd5f3858
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Sep 16 11:19:48 2014 -0600

    Events: kqueue: implement timeout_create
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 8145451314e626fcb599dbe26993897cb839ebe4
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Sep 16 10:58:54 2014 -0600

    Events: epoll: on timeout_create, use event_add() call
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit b8c632c5457b869d17bfb828414c41ba0b9451d0
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Sep 16 10:46:50 2014 -0600

    Events: kqueue: implement channels_create() handler
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 73baa60d613a335784dc45dceb53556b082afd3b
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Sep 16 10:37:50 2014 -0600

    Events: Scheduler / Epoll: set read and write file descriptors
    
    This patchs makes the Events channel creation to use two file descriptors
    for read and write operations. Mostly because kqueue based interface
    will use old-fashion pipe(2) as eventfd() is not available.
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 6ccbfc050058e78a9223a52b2c8f19b78e4b5687
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Sep 16 10:05:36 2014 -0600

    Events: kqueue: disable debug messages
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 0dde3beb69e595cc8e6a4c2b9dbcf47a2915db1a
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Sep 15 22:55:41 2014 -0600

    Events: change flags value and found a libkqueue bug
    
    I found a bug running libkqueue (GIT version), not sure if it
    can be replicated on older versions. It only happens when the
    following sequence of kqueue calls are done:
    
     1. Register FD as EVFILT_READ
     2. Delete EVFILT_READ for FD
     3. Register FD as EVFILT_WRITE
     4. Register FD as EVFILT_READ
    
    On step #4 kevent() fails with EFAULT (Bad Address). I was able
    to reproduce the problem with a standalone test case, I contacted
    the library author about this problem. I need this to get resolved
    to continue.
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 281183ca6fafb2790c7ed554efd6bb2dafda0546
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Sep 15 14:53:39 2014 -0600

    Events: kqueue: on delete, do not validate errors
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit b9a081ea766d1485827463b141a5bc3b7c1f4b7c
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Sep 15 14:15:52 2014 -0600

    Events: kqueue: fix event deletion
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 271a33c390af5b7f1934e1fdc4c06396ba82f028
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Sep 15 12:37:10 2014 -0600

    Events: add kqueue poll events handler
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 4fc2cd53dde74ef170fb33f5562d7f3465245bde
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Sep 15 12:25:29 2014 -0600

    Events: add kevent 'event delete' handler
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 39ed833f715a9bcd1231f0f8a04cae4fdf865f54
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Sep 15 12:22:56 2014 -0600

    Events: kqueue event add callback
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 3df8d431789a75e702f492f92693692d1a3e8363
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Sep 15 11:41:25 2014 -0600

    Events: kqueue loop create plus configure script fixes for libkqemu
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit a0abb6fc2d56e2f9a4799cd16a47664dcc465796
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Sep 15 11:31:03 2014 -0600

    Events: add kqueue handler Skeleton
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 10b58cec2301df36bf4001bb8afc8e472b2c08da
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Sep 15 11:25:48 2014 -0600

    Events: use epoll only on Linux and when linux-kqueue not defined
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit d1f303d2f855224f5c2322ad00e6a94032474cd3
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Sep 15 10:50:48 2014 -0600

    Config: move port override to global conf
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit dbabdc09b16a1cee49222255eb40615b4fbce943
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Fri Sep 12 11:15:53 2014 -0600

    Events: set custom 'data' field on results array
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit a6d101e3db41e9cbcf1f9a98370f37200fde8163
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Fri Sep 12 10:43:18 2014 -0600

    Plugin: make events behavior param void
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit ce18be91117be85132289e0357075afc2aaf3151
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Fri Sep 12 10:40:09 2014 -0600

    Server: remove deprecated reference to mk_epoll.h
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit f1a8928ab405cfd793d678ad79893556edbd8900
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Thu Sep 11 16:46:17 2014 -0600

    Events: set array size using getrlimit
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 7da674a44ce21dbedc9534681f0b26d56c9b1108
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Thu Sep 11 16:13:51 2014 -0600

    Events: align EFDT size with server capacity
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 7a75941f318464d35093e5fc11b1027b7f0172a4
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Thu Sep 11 16:07:57 2014 -0600

    Config: update FDLimit description
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 8dc36979a08e2b6c56f8dae6cb81d36d97d62fbf
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Thu Sep 11 11:26:06 2014 -0600

    Config: support new FDLimit (fix #143)
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit c1b2228db588c21724fb3c838990b4d20c09e242
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Thu Sep 11 10:02:27 2014 -0600

    Doc: new Branch TODO for this new architecture
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 2c9bbe7c73a7d67811f42256727d3f3110f5fc6b
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Thu Sep 11 09:19:31 2014 -0600

    FastCGI: fix API flags
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit a5b40f0584f7f0f96fcb7f3f5ff2ba53f9f8fa97
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Sep 10 22:17:01 2014 -0600

    Scheduler: change server capacity
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit c3358d8785f5f0e45cad53480c3e3f8b2d874dbf
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Sep 10 21:42:23 2014 -0600

    Event: separate logic between main loop and backend
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit bd6866c7cdad267d2cc067ce1689bf43fe8dc969
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Sep 10 21:29:28 2014 -0600

    Event: small fixes, partially working (serving requests)
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 0944212c0a4c76940797abc294ad18dac7418ebb
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Sep 10 19:56:43 2014 -0600

    Scheduler: mark thread loop as initialized
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 1d05d26c43e92c2004f900d7ecdd559699bc3d38
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Sep 10 19:42:11 2014 -0600

    Plugin: export new Event core API to plugins
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 66b21a904631a839e4f4b20b8a8cd07eda7c8030
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Sep 10 16:40:57 2014 -0600

    Core: remove deprecated calls based on old epoll_ API
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit c876a79f547c8cd0c95ea2d9f432f8b9c98a5078
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Sep 10 13:38:37 2014 -0600

    Scheduler: use new Event interface
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit cd0366cffcf98bac1d123cc559dbf42c3a80e62a
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Sep 10 13:26:18 2014 -0600

    CI: disable Travis CI for this branch
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit d6566f741b3e6ed29e5130105667d6d85f8f343b
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Sep 10 13:17:36 2014 -0600

    Epoll: it was a pleasure, but you have been deprecated.
    
    This patch removes mk_epoll.[ch] from sources as the new mk_event.c
    handler with mk_event_epoll.c backend is in place.
    
    Now the core is totally broken as all other interfaces needs to be
    adjusted to the new Events mechanism.
    
    Now the fun begins :)
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit fc6c4231a069425f953938f343f6b90ef6fc33d3
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Sep 10 13:13:00 2014 -0600

    Scheduler: use new event loop interface
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 8107a13f3899c30d8d27d950829576f4c2d79b48
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Sep 10 12:44:10 2014 -0600

    Event: add signal channel support
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit adc206c604717e32787f866a3e2fbce0dae7d568
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Sep 9 22:34:48 2014 -0600

    Server: worker loop handle events
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 8f6a135dec17f111129bf8b66e0d2b0e9a1e6cd0
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Sep 9 12:09:34 2014 -0600

    Server: prepare worker loop
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit e9a4ab97be444a47595bb1c0d3fd47eac485279b
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Sep 9 12:05:17 2014 -0600

    Event: wrap backend context on a 'loop_t' data type
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit ffb68fede1c5d96ea2a297c4fbe5c82ed008c827
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Sep 9 11:17:08 2014 -0600

    Config: remove unused param when calling listeners free
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit d4788c69da0f65c51cb1d76bd6183e33c9b9a1f9
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Sep 9 11:10:47 2014 -0600

    Event: fix compiler warnings
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 8074056d5a4ac0d22bd553f060d5991b410e658b
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Sep 9 11:03:26 2014 -0600

    Event: fix builder
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 5243abd1073deecdec279904b179824808808256
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Sep 8 23:14:01 2014 -0600

    Event: header fixes
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 034a53a9746b0917f9fbdc955da9915d41bb5ffe
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Sep 8 22:29:59 2014 -0600

    Event: workaround for events abstraction
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit ab9ac8be1e85fe09f62133fa91a2c5aafa096386
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Sep 8 20:10:25 2014 -0600

    Event: rename calls and add timeout handler
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit d7c980c31eaa9a8b05347c5cea22a91c720e4f62
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Sep 8 17:32:00 2014 -0600

    Event: wrappers for event_add and event_dell
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 8060d44ca35eb4224754f6b4dc2cf969515659bf
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Sep 8 12:31:11 2014 -0600

    Event: initialize global event states table
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit a972d061e8761e78edf83a591cf09415ebb16d78
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Sep 7 23:11:04 2014 -0600

    Event: preparing event handlers & basic epoll
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 4171e4dda9057bbcba17fdf027699180e75df818
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Sep 7 12:10:41 2014 -0600

    Configure: enable check for libkqueue (linux emulation)
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 8f20986ec316fd560a53bf7ec0b3feab1f69691a
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Thu Sep 4 16:55:38 2014 -0600

    API: export str_char_search()
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 987c2e2455fbed7fa9d07325778589e8dd1efd94
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Aug 30 23:07:02 2014 -0600

    Config: export listener_add so the lib can use it
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 8e41fe656e925c49bde9f58e846689b2d7f21370
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Aug 30 21:05:07 2014 -0600

    Cheetah: print mem allocator and little tweaks
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 5e39bd80c78e5253d25646059cd2d27f0912c1d9
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Aug 30 20:44:49 2014 -0600

    Config: duplicate Listener value buffers for safe free
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit abcea6e6c42179ecb4bdaf1eaef9a98c94a19208
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Aug 30 20:42:53 2014 -0600

    Epoll: make listener set EPOLLRDHUP
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 9bd6b9edfef8e271f7989c10b9be0ec8e6fc5c8f
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Aug 30 20:41:59 2014 -0600

    Epoll: initialize event struct for listener
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 77e7f3a7c4e255082a89f1f9b2b50ccfdd84a97a
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Aug 30 20:40:54 2014 -0600

    Config: skip duplicated listeners
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 11f4b1cb307ca08f366ffff51445b4dedf36d3eb
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Aug 30 20:26:09 2014 -0600

    Config: do not free resources after load a Listener
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 1c1a173ac7462ca20ec9f211364fbe24e23aa35c
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Aug 30 17:53:19 2014 -0600

    Logger: fix API usage for new Listeners
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 6e78b9daf89964f50090c84e42e2b8e5df20c858
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Aug 30 17:50:13 2014 -0600

    PolarSSL: fix data type
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit b0c7f25886fa2138f103eb6ce7dab00973d3968a
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Aug 30 17:48:06 2014 -0600

    Cheetah: fix API usage on Listeners
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit d2bf008233de3f25811b15943022881afab0365b
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Aug 30 17:42:34 2014 -0600

    Lib: fix API for new Listener stuff
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit d1af5833ef6eda83e8942c362afa7c99c0cce3bd
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Aug 30 17:27:30 2014 -0600

    Core: fix API usage on new Listeners mode and small changes
    
    A new feature for multiple listeners was added but it did not follow
    the Monkey pattern internals, this patch perform the following changes:
    
     - Listeners are not longer a linked list, instead a mk_list.
     - Memory allocations/deallocations now use mk_mem_*() family.
     - Renamed concepts of 'listen' to 'listener' and 'listeners'.
     - Small function to register a new listener.
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit f07ec2d17088922bcfd47cb8f0500d5d12d5f25d
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Aug 26 11:05:14 2014 -0600

    README: updates
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 506a7a18564be6bea8d61952384970088a20c7ac
Merge: 6dd20b3 ae3bffe
Author: Eduardo Silva <edsiper@gmail.com>
Date:   Tue Aug 26 10:35:50 2014 -0600

    Merge pull request #168 from ksonny/master
    
    Multiple listen sockets support

commit 6dd20b3da0d5d120a60d7c751d7ecfbb068e1a66
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Aug 23 11:28:36 2014 -0600

    Header: when using Chunked encoding, do not set Content-Length
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 51aed72efb590622de33071a555ebed94eb10ac3
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Aug 19 22:51:24 2014 -0600

    API: export je_mallctl when JEMALLOC_STATS is set
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>
    
    Conflicts:
    	include/monkey/mk_plugin.h

commit df7aca1ae80d6ed5e856f944d4318b0ef8848711
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Aug 18 19:38:46 2014 -0600

    Kernel: support Debian version format
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit ae3bffeb93bfd75380b88ff32ab8c2f6f00f0a36
Author: Sonny Karlsson <ksonny@lotrax.org>
Date:   Mon Aug 18 18:13:56 2014 +0200

    mk_lib: Adds multi listening socket support.

commit f364dbc90f81570ec289d1171e52c22fdbe51e65
Merge: 491f7e8 7ad943c
Author: Eduardo Silva <edsiper@gmail.com>
Date:   Mon Aug 18 09:51:20 2014 -0600

    Merge pull request #167 from kaspersky/ldpreload
    
    Libmonkey: Stats and python bindings

commit 491f7e8026da1f1f9dcaf82a3f27e8f459e726a9
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Aug 18 09:48:38 2014 -0600

    CI: Make Travis to build the shared library version
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 9e764c5dd509bfeda929437eb450e1aabdd0a0ea
Author: Sonny Karlsson <ksonny@lotrax.org>
Date:   Mon Aug 18 17:45:04 2014 +0200

    mk_lib: Fixes errors from changes made to server_config.
    
    Use config->listen.address and config->listen.port instead of
    config->listen_addr and config->serverport.
    
    Signed-off-by: Sonny Karlsson <ksonny@lotrax.org>

commit 7ad943cf04aeb8cc15f0dc3f9e9b23e283fda441
Merge: 3c8cddc 6125f57
Author: kaspersky <gg.kaspersky@gmail.com>
Date:   Mon Aug 18 17:59:53 2014 +0300

    Merge branch 'master' of https://github.com/monkey/monkey into ldpreload

commit 6125f57da0fca4c8be93ec745ab4243577733ccc
Merge: 7cf0dab e260a6c
Author: Eduardo Silva <edsiper@gmail.com>
Date:   Mon Aug 18 08:47:52 2014 -0600

    Merge pull request #166 from Denisss025/plugin_buff_size_export
    
    Plugin: add export to buffer_size function.

commit a22d33668aeb3ab5f0006fe2f9f38df5476580d9
Author: Sonny Karlsson <ksonny@lotrax.org>
Date:   Mon Aug 18 15:47:44 2014 +0200

    plugins/logger: Fixes printing of listen addresses.
    
    Signed-off-by: Sonny Karlsson <ksonny@lotrax.org>

commit 4e8f93630bc4a9bc52f1fbf53f001559c998689e
Author: Sonny Karlsson <ksonny@lotrax.org>
Date:   Mon Aug 18 15:46:09 2014 +0200

    plugins/cheetah: Fixes printing of listen addresses.
    
    Signed-off-by: Sonny Karlsson <ksonny@lotrax.org>

commit ce470b9ab428e60ad2f62f3c9777f32e023781d4
Author: Sonny Karlsson <ksonny@lotrax.org>
Date:   Mon Aug 18 15:44:08 2014 +0200

    mk_scheduler: Initialize mk_server_listen struct.
    
    Binds listening sockets when thread is launched.
    Use stack-allocated mk_server_listen to start mk_epoll_loop().
    
    Signed-off-by: Sonny Karlsson <ksonny@lotrax.org>

commit 3c5827e9e7079f3988711af3d130491241d3edd5
Author: Sonny Karlsson <ksonny@lotrax.org>
Date:   Mon Aug 18 15:39:10 2014 +0200

    mk_scheduler: Removes mk_scheduler_add_client*() methods.
    
    mk_scheduler_add_client_reuseport() and mk_scheduler_add_client() are
    superseded by mk_server_listen_handler().
    
    Signed-off-by: Sonny Karlsson <ksonny@lotrax.org>

commit 9dc8c01eeb9899c4e500c1b2029360b1dcb82512
Author: Sonny Karlsson <ksonny@lotrax.org>
Date:   Mon Aug 18 15:34:17 2014 +0200

    mk_scheduler: Adds mk_sched_next_target().
    
    Used in mk_server to balance new connections.
    
    Signed-off-by: Sonny Karlsson <ksonny@lotrax.org>

commit 1a89da348e36997c0c3820c3248014b40554f031
Author: Sonny Karlsson <ksonny@lotrax.org>
Date:   Mon Aug 18 15:30:48 2014 +0200

    mk_epoll: Adds multisocket support to epoll loop.
    
    Changes arguments of mk_epoll_init() to accept a mk_server_listen
    struct instead of a filedescriptor.
    Adds code to register listening sockets from mk_server_listen to
    epoll().
    Adds call to mk_server_listen_handler() when a new connection arrives.
    Changes type of mk_api->epoll_init().
    
    Signed-off-by: Sonny Karlsson <ksonny@lotrax.org>

commit 7961903fadc6dd198d63865eee824c0bf0d77690
Author: Sonny Karlsson <ksonny@lotrax.org>
Date:   Mon Aug 18 15:21:11 2014 +0200

    mk_server: Adds multisocket support for server loop.
    
    Adds support for multiple listening sockets when SO_REUSEADRESS is
    unavailable. Uses poll() for event notification.
    
    Signed-off-by: Sonny Karlsson <ksonny@lotrax.org>

commit afb20cb1492328a8ebe30830d38327b11b4092c4
Author: Sonny Karlsson <ksonny@lotrax.org>
Date:   Sat Aug 16 17:23:20 2014 +0200

    monkey: Adopts port override for multiple listen sockets.
    
    Set port in first listen structure on configuration and removes other
    listen directives when port specified on commandline.
    
    Signed-off-by: Sonny Karlsson <ksonny@lotrax.org>

commit 8b40ef64ea68e237461d7758e4212e61bcdcadd3
Author: Sonny Karlsson <ksonny@lotrax.org>
Date:   Sat Aug 16 17:18:44 2014 +0200

    plugin: Changes port argument type on mk_socket_server().
    
    Signed-off-by: Sonny Karlsson <ksonny@lotrax.org>

commit 2c70a37dd00924095ceac6e30c675bdeef09edf5
Author: Sonny Karlsson <ksonny@lotrax.org>
Date:   Sat Aug 16 17:12:06 2014 +0200

    utils: Use first listen port on pid file name.
    
    Signed-off-by: Sonny Karlsson <ksonny@lotrax.org>

commit 9a76bc0ee8c7053bccb932728f35c91f5ce8428e
Author: Sonny Karlsson <ksonny@lotrax.org>
Date:   Mon Aug 18 16:26:35 2014 +0200

    en/mconf: Removes Port and changes Listen directives.
    
    Signed-off-by: Sonny Karlsson <ksonny@lotrax.org>

commit d9fc68fb50dbe9c340748a527d5b0ee887f04f8c
Author: Sonny Karlsson <ksonny@lotrax.org>
Date:   Sat Aug 16 16:58:18 2014 +0200

    mk_config: Parse multiple Listen configuration options.
    
    Signed-off-by: Sonny Karlsson <ksonny@lotrax.org>

commit e260a6ce1c1f404d195a44bfa4b35462804118f8
Author: Denis <denisnovikov@garant.ru>
Date:   Mon Aug 18 11:51:28 2014 +0400

    Plugin: add export to buffer_size function.
    
     This patch fixes a problem where `mk_plugin_load_symbol` returns 0
     for `_mkp_network_io_buffer_size` function.

commit 3c8cddcf996da4f3311c0e217148d611f8d11e7f
Merge: 55f2a7b 7cf0dab
Author: kaspersky <gg.kaspersky@gmail.com>
Date:   Sun Aug 17 17:56:12 2014 +0300

    Merge branch 'master' of https://github.com/monkey/monkey into ldpreload

commit 7cf0dabd31878b58bd190e85fc87e3901265ea0b
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Aug 16 20:30:02 2014 -0600

    Epoll: validate when registering connection with the Scheduler
    
    In the epoll event loop, when registering a new connection with
    the Scheduler, there were not check if this was successfull or not,
    a common example may be a security plugin dropping a connection
    at STAGE_10.
    
    This patch adds a validation on the return value when trying to register
    a connection with the Scheduler. If it fails, the socket will be closed
    right away.
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 869eb02be55dbe94729a2d76444122bbe62ed299
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Aug 16 20:16:40 2014 -0600

    Mandril: remove trace msg
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit d13e8d9d6a6764aad845f83dfb45ce4a274b9ac7
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Aug 16 17:34:15 2014 -0600

    Macros: document NET macros parameters
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 8424837a4840473a478df333949fae303df36248
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Aug 16 17:27:27 2014 -0600

    Mandril: fix network address reference
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit b2d0e6f92310bb14a15aa2f8e96e1fb5379776dd
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Aug 16 11:55:28 2014 -0600

    Request: new request session flag to mark those files opened by FDT
    
    This patch aims to fix a potential DDoS problem that can be caused
    in the server quering repetitive non-existent resources.
    
    When serving a static file, the core use Vhost FDT mechanism, but if
    it sends a static error page it does a direct open(2). When closing
    the resources for the same request it was just calling mk_vhost_close()
    which did not clear properly the file descriptor.
    
    This patch adds a new field on the struct session_request called 'fd_is_fdt',
    which contains MK_TRUE or MK_FALSE depending of how fd_file was opened.
    
    Thanks to Matthew Daley <mattd@bugfuzz.com> for report and troubleshoot this
    problem.
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit f9d0f8d4cbf7a799a9af2a1e70e6ed622a95b399
Author: Matthew Daley <mattd@bugfuzz.com>
Date:   Fri Aug 8 00:23:48 2014 +1200

    Utils: allocate enough space to include the null terminator when URL-decoding URLs
    
    Signed-off-by: Matthew Daley <mattd@bugfuzz.com>
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 1b5d6cc3fd03b513f6793bf56af0c8b02a3a69ff
Author: Matthew Daley <mattd@bugfuzz.com>
Date:   Fri Aug 8 00:20:52 2014 +1200

    Request: don't search off the end of the body buffer for query strings
    
    mk_string_char_search takes a length, not an end position.
    
    Signed-off-by: Matthew Daley <mattd@bugfuzz.com>
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit e2b2d78d62b524eb3c6245289ed9fc1362fdb054
Author: Matthew Daley <mattd@bugfuzz.com>
Date:   Fri Aug 8 00:11:02 2014 +1200

    Method: correctly extract content length value from body buffer when pre-parsing
    
    The buffer offset and the end position passed to mk_string_copy_substr
    is incorrect.
    
    Signed-off-by: Matthew Daley <mattd@bugfuzz.com>
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 9ba97fa0029ab332110cd45ac123f129646fe822
Author: Matthew Daley <mattd@bugfuzz.com>
Date:   Fri Aug 8 00:06:08 2014 +1200

    Mimetype: don't iterate off the start of the filename when looking for an extension
    
    Check the iterator position before checking for an extension.
    
    Signed-off-by: Matthew Daley <mattd@bugfuzz.com>
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 115c4edd02a8b5aaa2d5aecdf8d8cfa8aa168d53
Author: Matthew Daley <mattd@bugfuzz.com>
Date:   Fri Aug 8 00:05:38 2014 +1200

    Request: set correct path size when truncated
    
    If snprintf can't write the entire string out to the buffer, it will
    still null-terminate it. Hence, the length of the string is one less
    than the maximum passed in, not the maximum itself.
    
    Signed-off-by: Matthew Daley <mattd@bugfuzz.com>
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 3f7fa6f73de8dea848443690774792690e61d41b
Author: Matthew Daley <mattd@bugfuzz.com>
Date:   Sat Aug 16 07:38:14 2014 -0600

    Request: unlink request node from cs->request_lists
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 58473846c364a4d4f160bd4d7955d97937c55462
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Fri Aug 15 19:08:00 2014 -0600

    Scheduler: on timeout, validate incomplete linked list (#163)
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 55f2a7be51ab0f0cc269d3cfb553591dc34e4bf5
Merge: 9748d1e 295512e
Author: kaspersky <gg.kaspersky@gmail.com>
Date:   Fri Aug 15 23:19:00 2014 +0300

    Merge branch 'master' of https://github.com/monkey/monkey into ldpreload

commit 9748d1e181706647e09f4293d53e41be10109573
Author: kaspersky <gg.kaspersky@gmail.com>
Date:   Fri Aug 15 23:18:10 2014 +0300

    Libmonkey: Fix clock_gettime undefined
    
    Signed-off-by: kaspersky <gg.kaspersky@gmail.com>

commit 295512e5ad2e5f857777381be5179f72d7af7054
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Thu Aug 14 23:40:49 2014 -0600

    PolarSSL: new get_bytes_avail() call
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit c74f062cbfd25ca7c29dd35f5ffd56cca413ffda
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Thu Aug 14 23:38:20 2014 -0600

    PolarSSL: let io_read return more bytes than consumed
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 8c9c5d61fade510bb90107ec173cb42cdc06ed01
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Thu Aug 14 23:28:54 2014 -0600

    Request: initialize max_read
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 00954f84880d642f592886015a944e58066df6d1
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Thu Aug 14 23:12:35 2014 -0600

    Core: adaptive network buffer size (Fix #163)
    
    Monkey stack allows to a plugin to handle the network operations
    in a low level layer, at that area the plugins Liana and PolarSSL
    are the main ones in charge to add support for plain communication
    and further SSL.
    
    When working over plain sockets, the Networking plugin (liana) just
    perform direct read from the system call to the clien_session buffer,
    so it will read as of buffer capacity and then continue after each
    event triggered by the Kernel. In the opposite side, when the plugin
    requires some data processing after read(2) and before to return the
    control to Monkey core, we may face a double-buffering and that is
    the case of the PolarSSL plugin, where by obvious reasons it needs
    it own buffer.
    
    By RFC defition, SSL/TLS defines a maximum transaction of 2^14 bytes,
    which is 16KB, so if we get an Event notification from the Kernel and the
    plugin processed a number of bytes grater that the available on the caller
    buffer (client_session), we may ended up with some un-read bytes in the
    SSL layer.
    
    This patch implements a few mechanisms to avoid the situation described:
    
    1. The Plugin API at Networking level now implements a new callback
       called 'buffer_size', so from now all Networking plugins requires
       to implement it. Monkey core will call it with the purpose to ask if
       the plugin is implementing it own buffering and the size of it.
    
    2. When initializing plugins and check the Networking plugin buffer size,
       If it returns something >= MK_REQUEST_CHUNK, the Configuration will be
       set to that value. Note that from that moment every request will require
       two memory allocations (a workaround for custom systems will in the next
       patch).
    
    3. When invoking a Network read, now a plugin may be able to return a greater
       number of bytes requested by the caller. If this is faced, it means the
       Network plugin have some pending data to be read, so now the Request handler
       will consume that amount of data before to return to process other events.
    
    note: as said a new patch will come to fix the need of double-memory allocation
          per request.
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>
    
    Conflicts:
    	src/mk_http.c
    	src/mk_request.c

commit 05024797ba95ba737a8cd6b647f20d8ebe8493e2
Merge: fd2ac8f 1025daf
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Thu Aug 14 09:51:03 2014 -0600

    Merge branch 'master' of github.com:monkey/monkey

commit fd2ac8ffa428c54ef4b4909d8292174ee4f9c347
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Thu Aug 14 09:49:23 2014 -0600

    Core: new '-t' option to override TransportLayer from command line
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 3abb35c3d89b5dcaf66ec050781828532d403343
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Aug 12 19:22:38 2014 -0600

    Epoll: move READ message after signal condition
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 775ca46644ffbae7317f49e5e9eeff188d61caa3
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Fri Aug 8 20:00:03 2014 -0600

    Scheduler: on TRACE mode when closing connection, validate cs.
    
    When trace mode is enabled through --trace, when the Scheduler will
    close a connection, verify that no client_session associated exists
    to the Scheduler entry, this condition may happen on bad API usage
    by plugins.
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 2d43b5e8aa1d05755ac169b93fb075b448ef8514
Author: kaspersky <gg.kaspersky@gmail.com>
Date:   Wed Aug 13 19:29:54 2014 +0300

    Libmonkey: Add usage instructions for stats
    
    Signed-off-by: kaspersky <gg.kaspersky@gmail.com>

commit ee178e150ea80261f2538904fa1d76c476707b7a
Author: kaspersky <gg.kaspersky@gmail.com>
Date:   Wed Aug 13 19:29:31 2014 +0300

    Libmonkey: Improve documentation in python API.
    
    Signed-off-by: kaspersky <gg.kaspersky@gmail.com>

commit 4e96b2fd7c34987738d5dea1abddaaf6ee1a28a6
Author: kaspersky <gg.kaspersky@gmail.com>
Date:   Sun Aug 10 23:15:08 2014 +0300

    Libmonkey: Convert integer return value to boolean in monkey.configure()
    
    Signed-off-by: kaspersky <gg.kaspersky@gmail.com>

commit 7c55d140c3b0cb7b946110e671135575afecfe68
Merge: 36cac75 1025daf
Author: kaspersky <gg.kaspersky@gmail.com>
Date:   Sun Aug 10 22:21:29 2014 +0300

    Merge branch 'master' of https://github.com/monkey/monkey into ldpreload

commit 36cac7523d1a102fcdfd63181e832121dddefc2f
Author: kaspersky <gg.kaspersky@gmail.com>
Date:   Sun Aug 10 22:20:45 2014 +0300

    Libmonkey: Update manpages
    
    Signed-off-by: kaspersky <gg.kaspersky@gmail.com>

commit 1025daf4e36e29bd22a108fed08e7384569d863d
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Fri Aug 8 20:00:03 2014 -0600

    Scheduler: on TRACE mode when closing connection, validate cs.
    
    When trace mode is enabled through --trace, when the Scheduler will
    close a connection, verify that no client_session associated exists
    to the Scheduler entry, this condition may happen on bad API usage
    by plugins.
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 44beac406efaf89073fd10b25b140332a9691aa2
Author: kaspersky <gg.kaspersky@gmail.com>
Date:   Fri Aug 8 02:00:32 2014 +0300

    Libmonkey: Fix 'content_len' field in python examples
    
    Signed-off-by: kaspersky <gg.kaspersky@gmail.com>

commit 04516e3fc08e3cdc402aa20e7b7f807778e58a45
Author: kaspersky <gg.kaspersky@gmail.com>
Date:   Fri Aug 8 01:37:47 2014 +0300

    Libmonkey: Fix a bizarre segmentation fault at libstats unload
    
    Apparently, an application with multiple threads or child processes
    can cause a call to libstats destructor many times. Avoid closing
    multiple times the same library handler.
    
    Signed-off-by: kaspersky <gg.kaspersky@gmail.com>

commit 6324c2b06702c6c81b23ebfd1951d817bfbee0c1
Author: kaspersky <gg.kaspersky@gmail.com>
Date:   Fri Aug 8 00:53:35 2014 +0300

    Libmonkey: Move liana plugin to right location for running tests
    
    Signed-off-by: kaspersky <gg.kaspersky@gmail.com>

commit 0412b23ec12f7138f30992c98711120278c55df2
Author: kaspersky <gg.kaspersky@gmail.com>
Date:   Thu Aug 7 22:35:43 2014 +0300

    Libmonkey: Fix equality test to mk_stats variable
    
    Signed-off-by: kaspersky <gg.kaspersky@gmail.com>

commit 5a23be68e103e06526b248a8df89896e57a4d186
Author: kaspersky <gg.kaspersky@gmail.com>
Date:   Thu Aug 7 22:34:53 2014 +0300

    Libmonkey: Remove hardcoded value in run-tests.sh
    
    Signed-off-by: kaspersky <gg.kaspersky@gmail.com>

commit f412eb5d8e156b52dfe9d7aa96e583b3158ea401
Author: kaspersky <gg.kaspersky@gmail.com>
Date:   Thu Aug 7 22:34:30 2014 +0300

    Libmonkey: Add stop server message in python examples
    
    Signed-off-by: kaspersky <gg.kaspersky@gmail.com>

commit e3223cc6ea5147e6e872b04d29530cdd4e3c6426
Merge: 9d569f1 7fc6a5f
Author: kaspersky <gg.kaspersky@gmail.com>
Date:   Thu Aug 7 20:49:18 2014 +0300

    Merge branch 'master' of https://github.com/monkey/monkey into ldpreload

commit 9d569f1ec3a32bf1406f24109ca6704fd3d5aa2a
Author: kaspersky <gg.kaspersky@gmail.com>
Date:   Thu Aug 7 20:09:00 2014 +0300

    Libmonkey: Prettier print format for worker stats
    
    Signed-off-by: kaspersky <gg.kaspersky@gmail.com>

commit 212da6ae5ed413f5dcc2de023802bc3fbe6f5151
Author: kaspersky <gg.kaspersky@gmail.com>
Date:   Thu Aug 7 20:08:17 2014 +0300

    Libmonkey: Fix -DSTATS flag for stats Makefile
    
    Signed-off-by: kaspersky <gg.kaspersky@gmail.com>

commit ceeb8e7e2f826bc592da8c5a53c585b6a0beef97
Author: kaspersky <gg.kaspersky@gmail.com>
Date:   Thu Aug 7 19:22:32 2014 +0300

    Libmonkey: Add compile option for libstats in Makefile
    
    Signed-off-by: kaspersky <gg.kaspersky@gmail.com>

commit 3e91987a70c756a2ef7413427d8044097d61f3c6
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Thu Aug 7 09:55:32 2014 -0600

    WIP: status completed crash
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit c45d68f78371e00d115254e480909322e7fd490e
Author: kaspersky <gg.kaspersky@gmail.com>
Date:   Wed Aug 6 22:13:43 2014 +0300

    Libmonkey: Minor stats fix
    
    Signed-off-by: kaspersky <gg.kaspersky@gmail.com>

commit 07d213126c9f0fe1fc4d30108a49e5e59486f957
Author: kaspersky <gg.kaspersky@gmail.com>
Date:   Wed Aug 6 22:06:15 2014 +0300

    gitignore: more stuff to gitignore
    
    Signed-off-by: kaspersky <gg.kaspersky@gmail.com>

commit 7fc6a5fbcee8b148ad389cbef22461f56882b6e0
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Aug 4 21:50:01 2014 -0600

    Epoll: initialize unitilialized static epoll event
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 2b6326c97f3cb1a6117e738729820b6d0d27fade
Merge: 4b6145c 53e0ace
Author: Eduardo Silva <edsiper@gmail.com>
Date:   Sun Aug 3 14:25:00 2014 -0600

    Merge pull request #161 from txt-file/patch-1
    
    identi.ca

commit 53e0ace55e247cab7b4ebd99f63cb527a7d7f1fd
Author: txt.file <txt.file@txtfile.eu>
Date:   Sun Aug 3 21:51:55 2014 +0200

    README.md: removed identi.ca link
    
    The link gives only an error message.

commit 3c2c1fa4edf5860e03a5c606d4cce75319783e9f
Author: kaspersky <gg.kaspersky@gmail.com>
Date:   Sun Aug 3 22:32:13 2014 +0300

    Libmonkey: Move python extension module to appropriate location.
    
    Signed-off-by: kaspersky <gg.kaspersky@gmail.com>

commit 5f6f56d6cdc3993bedc0e426b71e83d292f90118
Author: kaspersky <gg.kaspersky@gmail.com>
Date:   Sun Aug 3 21:27:23 2014 +0300

    Libmonkey: Check for python dependencies when building the python extension
    
    Signed-off-by: kaspersky <gg.kaspersky@gmail.com>

commit a74b20803d8c5a8f780add67450b319ee832ca61
Author: kaspersky <gg.kaspersky@gmail.com>
Date:   Sun Aug 3 21:04:30 2014 +0300

    Libmonkey: Remove inappropriate test
    
    Currently, monkey doesn't support multiple contexts at once,
    so keeping a test which always fails isn't useful.
    
    Signed-off-by: kaspersky <gg.kaspersky@gmail.com>

commit 7a72619218e4b0debb04b97b89d46265ad1fa47f
Merge: 06d5ccc 4b6145c
Author: kaspersky <gg.kaspersky@gmail.com>
Date:   Sun Aug 3 20:56:17 2014 +0300

    Merge branch 'master' of https://github.com/monkey/monkey into ldpreload

commit 06d5cccc0129f01118cdffd4f1d9c0e7a0b84aef
Author: kaspersky <gg.kaspersky@gmail.com>
Date:   Sun Aug 3 20:55:05 2014 +0300

    Libmonkey: Add python docstrings to monkey module
    
    Signed-off-by: kaspersky <gg.kaspersky@gmail.com>

commit 4b6145cc9b68e0a210db88d79b5d01f1207060d3
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Fri Aug 1 20:14:14 2014 -0600

    String: performance improvement converting uint64_t to string (4x)
    
    Based on the trick given by A. Alexandrescu on Facebook Engineering
    blog, this patch replace the old mk_str_itop() with the faster
    algorithm proposed.
    
    More details about the implementation here:
    
     https://www.facebook.com/notes/facebook-engineering/three-optimization-tips-for-c/10151361643253920
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 8f86e733e09427fa52e9e8258dca32431a845ac6
Author: kaspersky <gg.kaspersky@gmail.com>
Date:   Fri Aug 1 20:36:26 2014 +0300

    Libmonkey: Fix configuration free crash in library after recent upstream changes
    
    Signed-off-by: kaspersky <gg.kaspersky@gmail.com>

commit 4197d76aeba2d33a89c7df229005c22d66c73cbf
Author: kaspersky <gg.kaspersky@gmail.com>
Date:   Fri Aug 1 20:34:05 2014 +0300

    Libmonkey: Fix libmonkey.h path in run-tests.sh
    
    Signed-off-by: kaspersky <gg.kaspersky@gmail.com>

commit 82c5b0d5144ab3acd522da5a01db0cb55e0098a6
Author: kaspersky <gg.kaspersky@gmail.com>
Date:   Fri Aug 1 17:14:34 2014 +0300

    Libmonkey: Update run-tests.sh script for new include location
    
    Signed-off-by: kaspersky <gg.kaspersky@gmail.com>

commit e5d0d3dcd8c010820bde691df1e9cee4307adf65
Author: kaspersky <gg.kaspersky@gmail.com>
Date:   Fri Aug 1 00:57:49 2014 +0300

    Libmonkey: Fix mk_info new include location
    
    Signed-off-by: kaspersky <gg.kaspersky@gmail.com>

commit ddbe93feb59beabfa418d2a7dcb3052747e09913
Author: kaspersky <gg.kaspersky@gmail.com>
Date:   Fri Aug 1 00:51:42 2014 +0300

    Libmonkey: Move mk_stats.h to right location
    
    Signed-off-by: kaspersky <gg.kaspersky@gmail.com>

commit d0b2ffe0219cd40ff26a93d0f48e8f47f4b71bc1
Merge: ca3dbc7 41d018e
Author: kaspersky <gg.kaspersky@gmail.com>
Date:   Fri Aug 1 00:47:05 2014 +0300

    Merge with upstream

commit ca3dbc7979ea62392a5a99d13a76ded49c9f8240
Author: kaspersky <gg.kaspersky@gmail.com>
Date:   Thu Jul 31 20:41:43 2014 +0300

    Libmonkey: Trigger python bindings generation from configure
    
    Signed-off-by: kaspersky <gg.kaspersky@gmail.com>

commit 41d018e45f10d12c708968e3f7038eb765ff46f1
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Thu Jul 31 10:59:05 2014 -0600

    Signal: if write fails, print error
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 793a38f16c9afd5c19ed6364dc77e9ac13a78a27
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Thu Jul 31 10:57:29 2014 -0600

    Request: fix debug messages when TRACE is enabled
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 80e722b242f8033a80310f5414a85fa7b2a5aec9
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Jul 30 21:58:09 2014 -0600

    Dirlisting: make bootstrap theme the default one
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 7abe5d435172343282154266a59fd81d161d5d83
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Jul 30 21:57:50 2014 -0600

    Dirlisting: new Bootstrap theme
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit c1e0a2b90f4ebe6d99a1ed7cff1562883714eab3
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed Jul 30 21:13:41 2014 -0600

    Core: new 'one-shot' option to serve a directory without setup.
    
    This patch implements a new optional argument when start Monkey to
    start serving a directory as a specific virtual host. This is only
    useful when doing fast things locally mostly for testing.
    
     $ monkey -o /var/www/
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 1e0d7224ac26b4b36bc4db127719887b8d096fa6
Author: kaspersky <gg.kaspersky@gmail.com>
Date:   Thu Jul 31 02:02:48 2014 +0300

    Libmonkey: Implement worker-info bindings and test
    
    Signed-off-by: kaspersky <gg.kaspersky@gmail.com>

commit 0f7bd7bd08b7f57482a2179594d34a7d4739df01
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Jul 29 09:06:00 2014 -0600

    Help: fix text formatting
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit f5b17aa60c57de1bc2fa75e614fe7e8ab521d79e
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Jul 28 23:13:06 2014 -0600

    Scheduler: optimization when timing out connections
    
    This patch adds a good improvement on performance when the event poll
    system start checking for candidates to timed out connections. It adds
    two main lists:
    
      - sched->status_queue: Open socket connections list that have not sent any data
      - cs_incomplete: Client requests list that still have some pending data
    
    When the timer triggers the timeout check, now the Scheduler will look
    over those two global lists at thread level, avoiding to check connections
    that are in a good state.
    
    This performance improvement is faced when having several active connections
    in the server.
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 3f8fa573563d3d15aad7fbc19224bb07087ed338
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Jul 28 20:44:41 2014 -0600

    Epoll: use TimerFD interface to perform scheduler timeouts checks
    
    This patchs makes the scheduler and it epoll event loop to check
    for timeout connections through the timerfd Linux interface.
    
    It improve performance of the polling event loop as the previous
    version did a check after every epoll_wait().
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 06ce79936423c34ef472e7d21bafaec99a7946b9
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Jul 28 15:30:55 2014 -0600

    Virtual Host: validate dummy files (Fix #155)
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 9a1b8c354b170bab41466f04b8e6e77b98438a67
Author: Vladimir Cernov <gg.kaspersky@gmail.com>
Date:   Mon Jul 28 01:18:43 2014 +0300

    Libmonkey: Port library test suite to python
    
    Signed-off-by: Vladimir Cernov <gg.kaspersky@gmail.com>

commit 806bd166ebeaf8488a98d995cb7b4f502d5a3c11
Author: Vladimir Cernov <gg.kaspersky@gmail.com>
Date:   Mon Jul 28 01:17:53 2014 +0300

    Libmonkey: Minor bugfixes to monkey.pyx
    
    Signed-off-by: Vladimir Cernov <gg.kaspersky@gmail.com>

commit c2268adfed6f781b389715bbb205dc23ad10ffaa
Author: Nithin Saji <nithin111@gmail.com>
Date:   Sun Jul 27 23:56:42 2014 +0530

    LTT: update new header path

commit e031e5d17851ba1f75be79b656066566d7596460
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Jul 26 20:52:44 2014 -0600

    Plugin: remove dummy trace msg
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit c67696609c3a73287a93f4a3480aae6eb4e6fc0a
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Jul 26 20:08:17 2014 -0600

    HTTP: Pipelining fix #145 and improvements.
    
    This patch fix a problem where Pipelining requests were not being
    processed correctly and also do some improvements about how they are
    handled internally.
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 2675f1a53299be72c03594cc498b295f14b69367
Author: Vladimir Cernov <gg.kaspersky@gmail.com>
Date:   Sun Jul 27 04:58:18 2014 +0300

    Libmonkey: Implement examples for python also
    
    Signed-off-by: Vladimir Cernov <gg.kaspersky@gmail.com>

commit 9f15f444f5ee25eeeffc34aa063ec0f2825f8fa9
Author: Vladimir Cernov <gg.kaspersky@gmail.com>
Date:   Sun Jul 27 04:55:24 2014 +0300

    Libmonkey: Fixed segmentation fault in python bindings
    
    Signed-off-by: Vladimir Cernov <gg.kaspersky@gmail.com>

commit 292c8f6dd3fb97ded34b1241ea97c2cd7b71c8aa
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Jul 22 11:36:22 2014 -0600

    Core: on exit, wait for threads.
    
    This path makes Monkey workers Joinable, upon exit it joins the
    threads before to exit. Safe exit.
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 644f1b48740dcb6db55cd79af1191643dbf197b6
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Jul 22 10:26:00 2014 -0600

    Core: zero leaks on exit without load
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 6296f0aadc172c67db7cdeb2be74ea1fb63ab96c
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Jul 22 08:44:25 2014 -0600

    Plugin: start releasing worker resources on exit
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 85265408ad5251b8a43052f6c9994f1570915dbf
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue Jul 22 08:25:56 2014 -0600

    Proxy Reverse: fix mk_ptr usage
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 31b82584f9adfa6173a70b9581448ee3c683d3a2
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Jul 21 23:20:52 2014 -0600

    Plugins: fix mk_ptr_XYZ() calls
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 11d9e17d707fcdf1a20fbb94edb0dcb127c53fbf
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Jul 21 23:13:45 2014 -0600

    Mimetype: remove old SAFE_FREE macro
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 6ddc5dbaac55a19469e2ab6ec78915e9f0fdcaf0
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Jul 21 23:11:44 2014 -0600

    Memory: rename mk_ptr_XYZ() functions
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 32877c2bfbf615e0d0d1486f47d017abbb450222
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Jul 21 23:08:03 2014 -0600

    Configure: cleanup
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 33ac7891f7e309c24f769d4e7bd0c22834fd92bb
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Jul 21 22:58:49 2014 -0600

    Mimetype: release default entry on exit
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 82fe17e1821f6931cb641ac6e65cdfc4284026c9
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Jul 21 22:27:22 2014 -0600

    Core: release resources on exit, the saga continue
    
    this patch makes to release many resources from the core subsystems
    such as epoll_states, vhost fdt, clock, buffers cache, etc.
    
    This is still work in process and the pending areas are:
    
     - Global scheduler
     - Plugins -> per worker exit
     - Plugin Events
     - Plugins shared libraries
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 0f38f5e3ac52e172a87822e9151933d6d6823474
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Jul 21 20:40:26 2014 -0600

    Core: minor memory releases on server exit
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit c48ca4eb6e6c535e2c0061fea0ef70135e03ed69
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Jul 21 20:32:02 2014 -0600

    Core: SAFE_FREE is now the default and not longer optional
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit bac02a04f8e84f2fd282b33be7ab996bfbf12d33
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Jul 21 19:36:43 2014 -0600

    Core: on SAFE_FREE, release list of mime types
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 56a67aa3cfe7e059c40a9a424ff3abbee111a016
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Jul 21 10:37:51 2014 -0600

    Debian: adjust rules for packaging
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 4c5037cc43f30bf9b6d8ab958043410b4d6a0773
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Jul 21 10:27:47 2014 -0600

    Configure: install headers to new path
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit e92f318066ad5e69834b0e4b241ac81f03b7a947
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Jul 20 23:32:55 2014 -0600

    Debian: prepare for v1.6.0
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit e10ca4560c07cc6f6efb1a919bcfbd0ed21f1c0f
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Fri Jul 18 15:35:58 2014 -0600

    Debian: bump to 1.5.2
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>
    
    Conflicts:
    	debian/changelog

commit 4d6bf1e10a5b65a73ec96fdf790c8d16d8ca7ff1
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Jul 20 23:01:59 2014 -0600

    README: tweaks
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 10465318965aab16527fae5933568f72887b2887
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Jul 20 22:58:05 2014 -0600

    README: move to Markdown mode
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 7de944bc3cb145200645fa73b0008b5bfdbcee24
Author: Vladimir Cernov <gg.kaspersky@gmail.com>
Date:   Mon Jul 21 07:46:48 2014 +0300

    Libmonkey: Implement library callbacks in cython
    
    Signed-off-by: Vladimir Cernov <gg.kaspersky@gmail.com>

commit b62a54a08376ebac22210c2a07f610913cf0d859
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Jul 20 21:42:26 2014 -0600

    Configure: adjust main Makefile
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 67b66c8a6aa388fa43e746a7fe4e282b670322ca
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Jul 20 21:22:48 2014 -0600

    Header: add missing monkey.h
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 72551048ceb109bcb3407864a5257736d19457f4
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Jul 20 21:21:55 2014 -0600

    Structure: add missing headers
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 8f41cb714ced0679f99b7b5d5e2ff8d2ffcb689a
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Jul 20 20:55:25 2014 -0600

    API: fix included headers
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 8da3e0570d07962952c4a63ad7ec352f8111e789
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Jul 20 20:48:08 2014 -0600

    Proxy Reverse: fix API header
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 075795ac0747ff2f97f4bb75bcbb35a4efb49460
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Jul 20 20:37:46 2014 -0600

    Configure: build path fixes
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 6a045c7eff74ef6b132fd51ad5f51afb95ae9c80
Merge: 3cb9c1c ec7f216
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Jul 20 15:49:01 2014 -0600

    Merge branch 'master' of github.com:monkey/monkey

commit 3cb9c1cf7da3f98423e9d568b738a2a49b16d087
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Jul 19 10:37:35 2014 -0600

    HTTP: on using API sendfile, check EAGAIN
    
    Some plugins may not be too efficient to buffer outgoing data
    and when implementing the sendfile callback on some cases it will
    need to re-call the routine until the Kernel enqueue the data.
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit f28b6255ab6410df02b8cde5c51de1e20c896bf6
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Fri Jul 18 16:46:55 2014 -0600

    HTTP: If-Modified-Since now allow clients from the future.
    
    Before this patch the server did not respect a conditional
    If-Modified-Since if the value was higher than the system server
    date. This patch makes this pass, not a bug but make it more
    friendly with Checker tools.
    
    This patch also fix a QA script involved.
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit db6949f5c43e420f5c38cad72fd6f8d42a8b483a
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Fri Jul 18 15:24:21 2014 -0600

    Signal: restore handler for SIGPIPE.
    
    This problem was introduced on commit 84fa79eb. Without the SIGPIPE handler
    the server will stop working when the Kernel trigger a SIGPIPE because of a
    remote socket disconnection.
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 460df48d8abbecf02c17f192f298ec8fd910db23
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Thu Jul 17 23:22:23 2014 -0600

    Core: change name in banner
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit f410faadae298fa53994d0e42cb19d4e9165c61e
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Jul 13 11:53:49 2014 -0600

    Mimetype: add SVG types (fix #153)
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 23dc017c67e8b09e2ca6a512e783f040bf118310
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Jul 20 15:48:02 2014 -0600

    Structure: adjust configure script and mklib
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit ec7f216dd2e03c974152f0e009b05b152c4f3bd2
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat Jul 19 10:37:35 2014 -0600

    HTTP: on using API sendfile, check EAGAIN
    
    Some plugins may not be too efficient to buffer outgoing data
    and when implementing the sendfile callback on some cases it will
    need to re-call the routine until the Kernel enqueue the data.
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit c24e8a7344dd63375f55be4902c61fd3879f614f
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Fri Jul 18 16:46:55 2014 -0600

    HTTP: If-Modified-Since now allow clients from the future.
    
    Before this patch the server did not respect a conditional
    If-Modified-Since if the value was higher than the system server
    date. This patch makes this pass, not a bug but make it more
    friendly with Checker tools.
    
    This patch also fix a QA script involved.
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 67fe5023e7364106258816987c918108b8bac979
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Fri Jul 18 15:24:21 2014 -0600

    Signal: restore handler for SIGPIPE.
    
    This problem was introduced on commit 84fa79eb. Without the SIGPIPE handler
    the server will stop working when the Kernel trigger a SIGPIPE because of a
    remote socket disconnection.
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit f23158d22398bffb0c7961312ca8225c84ee46d2
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Thu Jul 17 23:22:23 2014 -0600

    Core: change name in banner
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit e5d9a21c5460df45e6d22e6eb8084623602f9b8e
Author: Vladimir Cernov <gg.kaspersky@gmail.com>
Date:   Mon Jul 14 20:46:41 2014 +0300

    Libmonkey: Implement python bindings for configuration
    
    Signed-off-by: Vladimir Cernov <gg.kaspersky@gmail.com>

commit ed9f1f600702949bd68f992a2a658de82204da32
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Jul 13 11:53:49 2014 -0600

    Mimetype: add SVG types (fix #153)
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 9d1ed470588d1ace4098c8b68d8059feea39a594
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Jul 13 11:47:24 2014 -0600

    Structure: move headers to different location
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 0b80fd51f89ed7664297e6a45d9eafcf6280181d
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Jul 7 12:12:41 2014 -0600

    Configure: options to set PolarSSL specifics.
    
    This patch add 3 options to the configure script:
    
      --polarssl-headers       Path to PolarSSL headers
      --polarssl-library       Path to PolarSSL library
      --polarssl-debug-level   Set PolarSSL debug level (not implemented)
    
    the first two aims to make things easier when using a custom or
    compiled from scratch version of PolarSSL library.
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 0d22025603d23e15c9a6422d00b7b343bd2ddd90
Author: Vladimir Cernov <gg.kaspersky@gmail.com>
Date:   Mon Jul 7 01:03:08 2014 +0300

    Libmonkey: Implement start and stop server python bindings
    
    Signed-off-by: Vladimir Cernov <gg.kaspersky@gmail.com>

commit 5df26f337df3ad9f6378eb0a1c2188c05b1bb845
Author: Vladimir Cernov <gg.kaspersky@gmail.com>
Date:   Mon Jul 7 00:59:24 2014 +0300

    Libmonkey: Fix stats configure for ldpreload
    
    Signed-off-by: Vladimir Cernov <gg.kaspersky@gmail.com>

commit 53290a9464bcaebbbfcbf7426194d6ebef5e4d25
Author: Vladimir Cernov <gg.kaspersky@gmail.com>
Date:   Sun Jun 29 22:34:32 2014 +0300

    Libmonkey: Add selectively compiling support for stats
    
    Signed-off-by: Vladimir Cernov <gg.kaspersky@gmail.com>

commit ca5f6306807d7aabddd31576c9ec46e9beb15f20
Author: Vladimir Cernov <gg.kaspersky@gmail.com>
Date:   Sun Jun 29 20:49:17 2014 +0300

    Libmonkey: Remove commented lines in mk_lib.c
    
    Signed-off-by: Vladimir Cernov <gg.kaspersky@gmail.com>

commit b6a7ac0d254ef7be451dd037d47920a3585887f8
Author: Vladimir Cernov <gg.kaspersky@gmail.com>
Date:   Sun Jun 29 02:43:01 2014 +0300

    Libmonkey: rework stats using LD_PRELOAD mechanism
    
    Signed-off-by: Vladimir Cernov <gg.kaspersky@gmail.com>

commit e1b9177e1797a2de0185b125b28425869e10199b
Author: Vladimir Cernov <gg.kaspersky@gmail.com>
Date:   Wed Jun 25 20:41:19 2014 +0300

    Libmonkey: Reduce number of fields in stats data structure
    
    Signed-off-by: Vladimir Cernov <gg.kaspersky@gmail.com>

commit a3205fefcc59a3ec06217d81d50c1721bf769642
Author: Vladimir Cernov <gg.kaspersky@gmail.com>
Date:   Wed Jun 25 20:32:30 2014 +0300

    Libmonkey: enable kernel features in mklib_init
    
    Signed-off-by: Vladimir Cernov <gg.kaspersky@gmail.com>

commit b245a7b7bea66ce84204137f5fff3e74aa0b582a
Author: Vladimir Cernov <gg.kaspersky@gmail.com>
Date:   Sat Jun 21 16:19:57 2014 +0300

    Libmonkey: Add configure option for enabling worker statistics
    
    Use ./configure --stats
    
    Signed-off-by: Vladimir Cernov <gg.kaspersky@gmail.com>

commit 91566a7bb954ccbb384b2027e649cc86a41480d4
Author: Vladimir Cernov <gg.kaspersky@gmail.com>
Date:   Fri Jun 20 15:15:23 2014 +0300

    gitignore: Add more stuff to gitignore
    
    Signed-off-by: Vladimir Cernov <gg.kaspersky@gmail.com>

commit 6e6374f0eb8296ee42377c5c7358aa41d2521861
Author: Vladimir Cernov <gg.kaspersky@gmail.com>
Date:   Fri Jun 20 15:12:53 2014 +0300

    Libmonkey: Compile and run library test suite from a bin/ directory
    
    Signed-off-by: Vladimir Cernov <gg.kaspersky@gmail.com>

commit 989526d72e2044337935327c09bdb584f14502c8
Author: Vladimir Cernov <gg.kaspersky@gmail.com>
Date:   Fri Jun 20 14:57:34 2014 +0300

    Libmonkey: Add library configuration retrieving functionality
    
    Also write a test for it.
    
    Signed-off-by: Vladimir Cernov <gg.kaspersky@gmail.com>

commit 9c3b83de4c92e17f13c7fc51111748e6f6a63dfd
Author: Vladimir Cernov <gg.kaspersky@gmail.com>
Date:   Fri Jun 20 02:42:49 2014 +0300

    Libmonkey: Cosmetic fix to mimetype test
    
    Signed-off-by: Vladimir Cernov <gg.kaspersky@gmail.com>

commit afbf12c7f3d2ab02eda15d64506f619c80412395
Author: Vladimir Cernov <gg.kaspersky@gmail.com>
Date:   Mon Jun 16 00:04:29 2014 +0300

    Libmonkey: Trace mk_conn_read and mk_conn_write
    
    Signed-off-by: Vladimir Cernov <gg.kaspersky@gmail.com>

commit 7aa33a64faef50c2f34dff47377a5be868fd336b
Author: Vladimir Cernov <gg.kaspersky@gmail.com>
Date:   Sun Jun 15 20:32:10 2014 +0300

    Libmonkey: Add counters to more functions
    
    mk_http_init, mk_plugin_event_read,
    mk_plugin_event_write, mk_header_send
    
    Signed-off-by: Vladimir Cernov <gg.kaspersky@gmail.com>

commit 95f483a874a1746500faa16ffdbefd22f16bdc61
Author: Vladimir Cernov <gg.kaspersky@gmail.com>
Date:   Sun Jun 15 19:54:35 2014 +0300

    Libmonkey: Trace mk_plugin_stage_run, mk_http_range_parse and mk_sched_remove_client
    
    Signed-off-by: Vladimir Cernov <gg.kaspersky@gmail.com>

commit 8df48c3a3e90bd59f2b83d101c9156d265ba4bde
Author: Vladimir Cernov <gg.kaspersky@gmail.com>
Date:   Sun Jun 15 19:21:31 2014 +0300

    Libmonkey: Add routing for printing worker stats
    
    Signed-off-by: Vladimir Cernov <gg.kaspersky@gmail.com>

commit c4c70c1466a8bb4a272dc890a6f9f7d5e0036ab9
Author: Vladimir Cernov <gg.kaspersky@gmail.com>
Date:   Sun Jun 15 18:32:22 2014 +0300

    Libmonkey: Add STATS_COUNTER_INIT_NO_SCHED
    
    Avoid redundant calls to pthread_getspecific
    
    Signed-off-by: Vladimir Cernov <gg.kaspersky@gmail.com>

commit b383962ffc2d8905552657c1fd1856ee4d20da17
Author: Vladimir Cernov <gg.kaspersky@gmail.com>
Date:   Sun Jun 15 15:26:28 2014 +0300

    Libmonkey: Add mk_sched_get_connection to stats
    
    Signed-off-by: Vladimir Cernov <gg.kaspersky@gmail.com>

commit eb5235601a719ecccea9165780936259e1b25d27
Author: Vladimir Cernov <gg.kaspersky@gmail.com>
Date:   Sun Jun 8 18:13:26 2014 +0300

    Libmonkey: Implement simple stat counters
    
    Signed-off-by: Vladimir Cernov <gg.kaspersky@gmail.com>

commit 1a57d6a2d1dd8002acfe511f12deef97cdd6f897
Author: Vladimir Cernov <gg.kaspersky@gmail.com>
Date:   Sun Jun 8 00:00:38 2014 +0300

    Libmonkey: Add option to select tests to run-tests.sh
    
    Signed-off-by: Vladimir Cernov <gg.kaspersky@gmail.com>

commit 43da338886ccc8cbe2fbc7415de8b3a0f6493804
Author: Vladimir Cernov <gg.kaspersky@gmail.com>
Date:   Sat Jun 7 23:51:11 2014 +0300

    Libmonkey: Add new test for worker info
    
    Signed-off-by: Vladimir Cernov <gg.kaspersky@gmail.com>

commit 24b4c7eb8f30adcab0181787765caeffa30ad710
Author: Vladimir Cernov <gg.kaspersky@gmail.com>
Date:   Sat Jun 7 23:18:55 2014 +0300

    Libmonkey: Fix warning in md5_check.h
    
    Signed-off-by: Vladimir Cernov <gg.kaspersky@gmail.com>

commit 928cfc6e4c418528dcf0258a796eebe3ec2582d6
Author: Vladimir Cernov <gg.kaspersky@gmail.com>
Date:   Sat Jun 7 23:16:57 2014 +0300

    Libmonkey: Add accepted_connections to mklib_worker_info
    
    Signed-off-by: Vladimir Cernov <gg.kaspersky@gmail.com>

commit 8060135ec5507d1d2a2d998d301ce06c9333d0a3
Author: Vladimir Cernov <gg.kaspersky@gmail.com>
Date:   Sun Jun 1 20:45:17 2014 +0300

    Scheduler: Close connection after MK_PLUGIN_STAGE_10
    
    Signed-off-by: Vladimir Cernov <gg.kaspersky@gmail.com>

commit cf078f7ab53f0fdce55562b91f7f651df8301b8b
Author: Vladimir Cernov <gg.kaspersky@gmail.com>
Date:   Sat May 31 01:20:28 2014 +0300

    Libmonkey: fix run-tests.sh

commit 77c4b30bdb36550e7e7bf7d3eb9fe01f940e5f89
Author: Felipe Reyes <freyes@tty.cl>
Date:   Tue Jun 24 22:34:43 2014 +0200

    Update FSF address in a couple of headers
    
    The headers were using the old FSF address.

commit 53504ed659b58b20f97de5286f6627039452fc01
Merge: 57d2cda 4f3bd16
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Jun 22 23:45:18 2014 -0600

    Merge branch 'fixwarning' of https://github.com/kaspersky/monkey

commit 57d2cdad0b3acc9036dc39edad27a01bc10bcefd
Merge: 4df84b8 dbcaf87
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun Jun 22 23:44:59 2014 -0600

    Merge branch 'fixconfigure' of https://github.com/kaspersky/monkey

commit 4df84b84f6000b436df042c808b3530e260d2e21
Author: Felipe Reyes <freyes@tty.cl>
Date:   Sun Jun 22 23:32:14 2014 +0200

    Fix date in changelog of spec file
    
    The day of the week was Thursday when it should be Tuesday, also the
    email's domain of the author of that same changelog entry was fixed.

commit 4f3bd16e92916bfece41173d3efd8b00968398e2
Author: Vladimir Cernov <gg.kaspersky@gmail.com>
Date:   Sun Jun 22 23:38:29 2014 +0300

    Scheduler: Fix warning for implicit declaration
    
    Add declaration of mk_sched_check_capacity in mk_scheduler.h
    
    Signed-off-by: Vladimir Cernov <gg.kaspersky@gmail.com>

commit dbcaf87889c8941dfe4bb8caf5e20bb5eb849a3b
Author: Vladimir Cernov <gg.kaspersky@gmail.com>
Date:   Sun Jun 22 23:32:49 2014 +0300

    configure: Fix compilation (".lo" objects)
    
    Signed-off-by: Vladimir Cernov <gg.kaspersky@gmail.com>

commit 53af4faac9859a4c860b377ce1933c13fc7316a2
Merge: 33334a6 b3a41d6
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Fri Jun 20 11:04:30 2014 -0600

    Merge branch 'lineindentfix' of https://github.com/kaspersky/monkey

commit b3a41d60c7694c87586d75a3cbaf5ce9ab6d76c0
Author: Vladimir Cernov <gg.kaspersky@gmail.com>
Date:   Fri Jun 20 15:34:05 2014 +0300

    Plugins: fix indentation of 2 lines in mk_plugin.c
    
    Signed-off-by: Vladimir Cernov <gg.kaspersky@gmail.com>

commit 33334a6bdeed850ca412eb3f53bf80ddd80c5329
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Thu Jun 12 20:20:55 2014 -0600

    wip configure
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit c7646b792d270401b82eac67c6c46d456de8ec18
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Jun 9 23:26:22 2014 -0600

    WIP: overcapacity
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit acad4a9d60bb552b25be6d5b00e817795fbebd8b
Merge: 93368c4 46a2552
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Jun 9 21:56:52 2014 -0600

    Merge branch 'master' of github.com:monkey/monkey

commit 93368c4f6245eab247a8e7558ec9943772a15afe
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Jun 9 16:24:08 2014 -0600

    Core: fix user switch when running as root
    
    Previous this patch the core was using real user id as reference
    to perform user switch but when restoring back this is not allowed
    by the Kernel, the right way to do it is through the effective user ID.
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 7cf4d7f26ece9030179d3761931e625313e5f26a
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Jun 9 15:53:41 2014 -0600

    Core: switch user after Bind port.
    
    When running in newer systems with Kernel >= 3.9 and the SO_REUSEPORT
    option is used, the server was switching to the unpriviledge user before
    to bind the TCP port, this was generating problems when the port was <= 1024.
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 46a2552ddfaf9f7a4f77cc97e7df57cdf0b25abd
Merge: 06c02a4 dad05cd
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Jun 9 10:01:44 2014 -0600

    Merge branch 'master' of github.com:monkey/monkey

commit 06c02a4efd3f939008acbbdcfd91840851f85cf1
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon Jun 9 10:01:31 2014 -0600

    Configure: update banner
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit dad05cd82200d92e81c134c6e1ffd11e2eb75786
Author: Vladimir Cernov <gg.kaspersky@gmail.com>
Date:   Sat May 31 00:31:43 2014 +0300

    Libmonkey: fix mimes configuration file name

commit b30bfcb8ee0e151443d93483cfbcf3d70535077f
Merge: 6bde0ec 5014aae
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Thu May 29 09:10:57 2014 -0600

    Merge branch 'master' of github.com:monkey/monkey

commit 6bde0ec0f322614c685a66693e8a713a3d071126
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Thu May 29 09:03:26 2014 -0600

    Debian: bump version to 1.5.0-2
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 29e93616d8ad05121af843fbdba5fe699cd98426
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Thu May 29 08:54:01 2014 -0600

    Debian: fix PidFile path
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 5014aaebe48c4a1ca1151f22bbaae0e46126b9c5
Merge: b2e0eda 5e43e08
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed May 28 21:54:46 2014 -0600

    Merge branch 'master' of github.com:monkey/monkey

commit b2e0eda8459ae99a3f2409add2dd95fb1acd1659
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed May 28 21:54:37 2014 -0600

    Config: allow empty sections, just warn them
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 5e43e08fde033ca62d1a79d6261985e6c69801f5
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon May 26 15:52:18 2014 -0600

    Development of v1.6 begins :)
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit dd861f49dce2c78f13a45b82cb15f7ac5935a8cd
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun May 25 17:12:44 2014 -0600

    Update ChangeLog for v1.5.0
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 2b0f84634272a3b695587dfb9b21a2ba792b98eb
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun May 25 17:12:28 2014 -0600

    Debian: drop dependency of old packages
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 9bf5eaf420f80bd130bc47168926d5bb48f0acee
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sun May 25 15:31:32 2014 -0600

    Configure: new argument to set PidFile in default monkey.conf
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 1bd7c17e0ec88b9bd20c29f68759952f5cf02446
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat May 24 21:48:19 2014 -0600

    Configure: bypass OpenEmbedded/Yocto arguments
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit b3f21be68bca3f91857a49ceba4ed03245103462
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat May 24 21:09:52 2014 -0600

    HTML: set release date
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit a479b9cb852ee686d3ef2ecae8fe1d6d9a9f2fba
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat May 24 16:39:49 2014 -0600

    HTML: codename 'Emperor Tamarin'
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit c9314b429091cec6b25c726cb209b9554d02a8a3
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Sat May 24 15:58:38 2014 -0600

    Proxy Reverse: do not remove FD from event pool on hangup
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 5aed3d31417d5b0efdd190570720647a679fcd85
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Thu May 22 11:59:57 2014 -0600

    HTML: prepare home page for next version
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 5f2c9addc7a3e3e9bf40a78b6558eaf7ea950ce4
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Thu May 22 11:40:57 2014 -0600

    FastCGI: do not remove the FD event on hangup (Monkey already did)
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 96b03a487b6731331f0092a98704f2c686b02241
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Thu May 22 11:28:50 2014 -0600

    Connection: on close, remove FD from Scheduler first
    
    when a hangup or connection close event is raised, the core
    was invoking plugins callback directly and at the end the Scheduler
    for removal procedure.
    
    This behavior ended up in a problem as the core is not aware about
    what a plugin is doing after a callback, the plugin may "open" a
    new connection (new FD) and the Kernel "may" assign the previous FD
    closed number again, ending in a new close from the caller, e.g:
    
     - Plugin request to hangup a connection.
     - Core receive the event and invoke callbacks for closing stuff.
     - Plugin after cleanup decides to create a new FD.
     - The Kernel assign the same FD number than the recently closed.
     - Core retakes the control and let the Scheduler close everything
       related to the original FD.
     - The Core is closing "the NEW FD" messing up everything.
    
    After this patch the behavior is:
    
     - Plugin request to hangup a connection.
     - Core receive the close event, invoke the Scheduler.
     - The Scheduler cleanup all references for this FD, also it make
       sure to remove event notifications from the epoll(7) loop.
     - The Core invoke callbacks for closing stuff.
     - Everything gets clean properly.
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 5ab55cb77e27a0159a8323822897dc3910959cc8
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed May 21 21:59:11 2014 -0600

    Plugin: do not re-set event list
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 83bf013de38df051bbdf20de6cfc604cca20411d
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Wed May 21 21:15:54 2014 -0600

    Utils: fix return value check on libc_error() stuff
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 15f72c1ee5e0afad20232bdf0fcecab8d62a5d89
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue May 20 11:22:19 2014 -0600

    Mandril: check decoded URI (fix #92)
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit f929f3e6dca9a0ff2e08dcd286346ef7e436c139
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon May 19 11:00:16 2014 -0600

    Doc: update Contributing file (lines length)
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 1c9538ed901643a03af601115f88c37f98bbf066
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon May 19 10:55:50 2014 -0600

    Debian: structure changes
    
    From now all plugins that do not depends on external dependencies are
    distributed from the principal Monkey package. The only plugin that remains
    as a separate package is monkey-polarssl.
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 2635bbb3d2b3dfb36835aee01a0b04b1c686ecb3
Merge: 5f998e1 547b701
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue May 13 08:56:27 2014 -0600

    Merge branch 'master' of github.com:monkey/monkey

commit 5f998e189e293ab854e892012bd91b7710591734
Author: Savita TS <savita.seetaraman5@gmail.com>
Date:   Tue May 13 18:58:25 2014 +0530

    Signals: Removed unused variable 'old' in mk_signal_thread_sigpipe_safe()
    
    Removed the variable 'sigset_t old' in line 71 from function, 'void mk_signal_thread_sigpipe_safe()'. This patch removes the following warning caused during 'make':
    
    ------------------ WARNING ---------------------
    mk_signals.c: In function ‘mk_signal_thread_sigpipe_safe’:
    mk_signals.c:71:19: warning: unused variable ‘old’ [-Wunused-variable]
    ------------------ WARNING ---------------------
    
    Signed-off-by: Savita TS <savita.seetaraman5@gmail.com>

commit 58fe3faf2fb919a5a2ac7fd68b3770a3c781b149
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon May 12 00:17:43 2014 -0600

    Virtual Host: add Redirect support (Fix #132).
    
    This patch implements a basic HTTP redirect functionality at
    Virtual Host level, when the Redirect key is set on the Virtual
    Host configuration file, for every incoming request the server
    will perform a HTTP redirect. e.g:
    
    [SERVER]
        Redirect  http://monkey-project.com
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 547b701b2f69a6c6a89ff2887488dd8c6a73ee88
Merge: 868d751 38f823e
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Tue May 13 08:54:08 2014 -0600

    Merge branch 'master' of github.com:monkey/monkey

commit 868d751d2cdfa2a00ad386b0085efd69f498c87c
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon May 12 00:17:43 2014 -0600

    Virtual Host: add Redirect support (Fix #132).
    
    This patch implements a basic HTTP redirect functionality at
    Virtual Host level, when the Redirect key is set on the Virtual
    Host configuration file, for every incoming request the server
    will perform a HTTP redirect. e.g:
    
    [SERVER]
        Redirect  http://monkey-project.com
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 3df0f7ebc6fce3976edd7fc6fbabb8f7619748c7
Author: Savita TS <savita.seetaraman5@gmail.com>
Date:   Tue May 13 19:05:17 2014 +0530

    Socket: Added a variable to accept return value of read() in 'mk_socket_tcp_autocorking()'
    
    Added a variable to accept the return value of read() in line 266 in function 'mk_socket_tcp_autocorking()'. This patch removes the following warning that arises during 'make' :
    
    --------------- WARNING --------------------
    mk_socket.c: In function ‘mk_socket_tcp_autocorking’:
    mk_socket.c:265:9: warning: ignoring return value of ‘read’, declared with attribute warn_unused_result [-Wunused-result]
    --------------- WARNING --------------------
    
    Signed-off-by: Savita TS <savita.seetaraman5@gmail.com>

commit b08cdddb2e4383ac96689a4a3739713c570e3bb2
Author: Savita TS <savita.seetaraman5@gmail.com>
Date:   Tue May 13 18:58:25 2014 +0530

    Signals: Removed unused variable 'old' in mk_signal_thread_sigpipe_safe()
    
    Removed the variable 'sigset_t old' in line 71 from function, 'void mk_signal_thread_sigpipe_safe()'. This patch removes the following warning caused during 'make':
    
    ------------------ WARNING ---------------------
    mk_signals.c: In function ‘mk_signal_thread_sigpipe_safe’:
    mk_signals.c:71:19: warning: unused variable ‘old’ [-Wunused-variable]
    ------------------ WARNING ---------------------
    
    Signed-off-by: Savita TS <savita.seetaraman5@gmail.com>

commit 38f823e329a6a757a255f981a073edda7bad53c8
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Mon May 12 00:17:43 2014 -0600

    Virtual Host: add Redirect support (Fix #132).
    
    This patch implements a basic HTTP redirect functionality at
    Virtual Host level, when the Redirect key is set on the Virtual
    Host configuration file, for every incoming request the server
    will perform a HTTP redirect. e.g:
    
    [SERVER]
        Redirect  http://monkey-project.com
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 133c62d5635bd3c4181b3cf1fa8fc11640d3f684
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Fri May 9 14:50:54 2014 -0600

    Doc: update INSTALL
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 84fa79eb42617d57207bba784157f5b48ce6c25d
Author: Eduardo Silva <eduardo@monkey.io>
Date:   Fri May 9 10:40:49 2014 -0600

    License: core and plugins are now under the Apache License v2.0
    
    Signed-off-by: Eduardo Silva <eduardo@monkey.io>

commit 50d34fca7dc3ff6af4e2de492ab06c5e6d136b83
Author: Eduardo Silva <edsiper@gmail.com>
Date:   Sun May 4 19:58:35 2014 -0600

    CGI: make sure the Interpreter can be used, otherwise use status 500
    
    Signed-off-by: Eduardo Silva <edsiper@gmail.com>

commit d63286e36abce81f1e6aca261e1534d4e96edeb7
Author: Eduardo Silva <edsiper@gmail.com>
Date:   Sat May 3 17:18:33 2014 -0600

    CI: enable IRC notifications
    
    Signed-off-by: Eduardo Silva <edsiper@gmail.com>

commit 0698068328e660270fc3d419bb8fc0142f398893
Author: Eduardo Silva <edsiper@gmail.com>
Date:   Sat May 3 17:00:41 2014 -0600

    CI: disable PolarSSL due to test box problem
    
    Signed-off-by: Eduardo Silva <edsiper@gmail.com>

commit 7882a48badc0fd22fc425d84deb673cfcda5744a
Author: Eduardo Silva <edsiper@gmail.com>
Date:   Sat May 3 16:54:43 2014 -0600

    CI: add PolarSSL dependency and compile SSL Plugin
    
    Signed-off-by: Eduardo Silva <edsiper@gmail.com>

commit 60296a159ab9f805d25daf8736b880b790503428
Author: Eduardo Silva <edsiper@gmail.com>
Date:   Sat May 3 16:43:54 2014 -0600

    CI: add Travis integration
    
    Signed-off-by: Eduardo Silva <edsiper@gmail.com>

commit df6f67ceff090c5202107060aba87212ff99ce0e
Author: Eduardo Silva <edsiper@gmail.com>
Date:   Fri May 2 21:29:31 2014 -0600

    Auth: move mk_passwd code into tools/ for clean build
    
    Signed-off-by: Eduardo Silva <edsiper@gmail.com>

commit a4225df6ff7e065ce9ee1a76846fef939106eb8b
Author: Eduardo Silva <edsiper@gmail.com>
Date:   Fri May 2 14:33:17 2014 -0600

    Auth: make mk_passwd work without Monkey internals.
    
    This patch adds a few workarounds to make mk_passwd avoid Monkey
    internals about memory allocations and string lines dependencies.
    
    Signed-off-by: Eduardo Silva <edsiper@gmail.com>

commit 4a4ae564079574fcf7ed81ac07808d9025f33c7b
Author: Eduardo Silva <edsiper@gmail.com>
Date:   Wed Apr 30 22:18:59 2014 -0600

    Request: optimize initialization of session_request
    
    Signed-off-by: Eduardo Silva <edsiper@gmail.com>

commit 2371f385c9b89208a8724821d8988142599c1a79
Author: Eduardo Silva <edsiper@gmail.com>
Date:   Tue Apr 29 16:42:12 2014 -0600

    Lib: fix parameters for mk_socket_server() call
    
    Signed-off-by: Eduardo Silva <edsiper@gmail.com>

commit f1876018eb32cf3c1cf7cdf77e34fea203fdbad0
Author: Eduardo Silva <edsiper@gmail.com>
Date:   Tue Apr 29 16:35:30 2014 -0600

    Debian: minor updates
    
    Signed-off-by: Eduardo Silva <edsiper@gmail.com>

commit 409c5fb0e9636052acd4a41013694372739a1ba0
Author: Eduardo Silva <edsiper@gmail.com>
Date:   Mon Apr 28 21:12:28 2014 -0600

    Doc: CONTRIBUTING.md: specify number of chars per line
    
    Signed-off-by: Eduardo Silva <edsiper@gmail.com>

commit 8b97b01ef591186929b6d59dffef2988b4808526
Author: Vladimir Cernov <gg.kaspersky@gmail.com>
Date:   Tue Apr 29 00:00:36 2014 +0300

    Auth: Rewrite mk_passwd in C (close #131).
    
    This patch drops the mk_passwd python script from auth plugin, by adding an
    equivalent C implementation.
    
    The C implementation makes use of Monkey functions, whenever possible, so it
    links with Monkey objects.
    
    In order to make the linking possible, some minor modifications had to be made
    to the configure script, monkey.c and mk_config.c source files.
    
    Signed-off-by: Vladimir Cernov <gg.kaspersky@gmail.com>

commit 9e8444445daa2a2ad12d774250ec1bbe924e8362
Author: Eduardo Silva <edsiper@gmail.com>
Date:   Mon Apr 28 10:12:43 2014 -0600

    Socket: fix array index.
    
    Signed-off-by: Eduardo Silva <edsiper@gmail.com>

commit b4ef860e3f2edd1de6d0626c19a56730e7104428
Author: Eduardo Silva <edsiper@gmail.com>
Date:   Mon Apr 28 10:05:48 2014 -0600

    PolarSSL: Enable REUSEPORT feature
    
    Signed-off-by: Eduardo Silva <edsiper@gmail.com>

commit e2ede773d0341f65e7be99887c699f8af206d6ee
Author: Sonny Karlsson <ksonny@lotrax.org>
Date:   Fri Apr 25 04:29:44 2014 +0200

    PolarSSL: Enable session cache.
    
    Sets session cache on ssl context.
    Moves pk_context to local thread context to allow use of polarssl
    compiled without threading support.
    
    Signed-off-by: Sonny Karlsson <ksonny@lotrax.org>

commit c51124d1ab2e1900b4eee4a9ef8adab58c59295b
Author: Sonny Karlsson <ksonny@lotrax.org>
Date:   Fri Apr 25 04:28:26 2014 +0200

    PolarSSL: Fixes error where connection isn't terminated on error.
    
    Signed-off-by: Sonny Karlsson <ksonny@lotrax.org>

commit 3b22521b6fed4d1f13a62f898a8b379168bde97e
Author: Sonny Karlsson <ksonny@lotrax.org>
Date:   Fri Apr 25 04:00:40 2014 +0200

    PolarSSL: Drops polarssl v1.1 support.
    
    Signed-off-by: Sonny Karlsson <ksonny@lotrax.org>

commit c8dba9b191784af72c82e4884520e4919b706661
Author: Eduardo Silva <edsiper@gmail.com>
Date:   Sat Apr 26 23:21:52 2014 -0600

    Scheduler: enable TCP_DEFER_ACCEPT on REUSEPORT mode
    
    Signed-off-by: Eduardo Silva <edsiper@gmail.com>

commit 0da162a6cae7c7c5616afda06b18973c9fcb643d
Author: Eduardo Silva <edsiper@gmail.com>
Date:   Sat Apr 26 23:06:54 2014 -0600

    Cheetah: on status command, print new Kernel features
    
    Signed-off-by: Eduardo Silva <edsiper@gmail.com>

commit a94fa2e04f8b4508e62f4c92950c951986c1b430
Author: Eduardo Silva <edsiper@gmail.com>
Date:   Sat Apr 26 23:05:09 2014 -0600

    Plugin API: export mk_kernel_features_print
    
    Signed-off-by: Eduardo Silva <edsiper@gmail.com>

commit 9a6ad8a67a09e72d96ca7b2d740569f39a1494dd
Author: Eduardo Silva <edsiper@gmail.com>
Date:   Sat Apr 26 22:40:37 2014 -0600

    HTTP/Server: use new server_cork_flag() interface
    
    Signed-off-by: Eduardo Silva <edsiper@gmail.com>

commit 7aed9dd5f4685a5481209e898a905918e1fb7759
Author: Eduardo Silva <edsiper@gmail.com>
Date:   Sat Apr 26 22:36:11 2014 -0600

    Config: check kernel_features flag for REUSEPORT
    
    Signed-off-by: Eduardo Silva <edsiper@gmail.com>

commit de083846ecece14949b66575851b66b411efd54f
Author: Eduardo Silva <edsiper@gmail.com>
Date:   Sat Apr 26 22:31:49 2014 -0600

    Kernel: remove unused variable
    
    Signed-off-by: Eduardo Silva <edsiper@gmail.com>

commit 9d7a8cda6b967abd24e34b0369dfcae1ded7885a
Author: Eduardo Silva <edsiper@gmail.com>
Date:   Sat Apr 26 22:24:05 2014 -0600

    Kernel: new features interfaces and core flags
    
    Signed-off-by: Eduardo Silva <edsiper@gmail.com>

commit fcfba4903f61b33e01124bbc8a60ea47f4d94b0a
Author: Eduardo Silva <edsiper@gmail.com>
Date:   Sat Apr 26 10:19:11 2014 -0600

    Scheduler: Little improvements over REUSEPORT implementation.
    
    Signed-off-by: Eduardo Silva <edsiper@gmail.com>

commit d1da249a0b5e8f5765ea8031919fb32e93c57cb8
Author: Eduardo Silva <edsiper@gmail.com>
Date:   Thu Apr 24 22:57:43 2014 -0600

    Scheduler: new REUSEPORT balancing method/architecture.
    
    Starting from Linux Kernel 3.9, there is a new TCP/UDP socket option which allows
    to bind same port and address from multiples threads (or any instance under the
    same process context).
    
    This patch implements the SO_REUSEPORT TCP Flag if the running Kernel is >= 3.9,
    so on that mode each working thread create it own socket that bind the same address,
    with this implementation we reduce the number of system calls involved when a new
    connection arrives, avoid lookup the lowest loaded thread and also we allow the
    Kernel to perform a better Scheduling on SMP systems that requires to scale.
    
    If the detected Kernel is lower than 3.9, it will use the old Fair Balancing
    mechanism.
    
    Signed-off-by: Eduardo Silva <edsiper@gmail.com>

commit 27878547891bdac7456fbae2c60942434d40e065
Author: Eduardo Silva <edsiper@gmail.com>
Date:   Thu Apr 24 19:51:57 2014 -0600

    Config: fix typo in mk_kernel_runver
    
    Signed-off-by: Eduardo Silva <edsiper@gmail.com>

commit 17df1070b417cca6d13ee3e863c3680830d27960
Author: Eduardo Silva <edsiper@gmail.com>
Date:   Thu Apr 24 09:24:44 2014 -0600

    Socket: TCP Auto Corking only on Linux >= 3.14.0
    
    Signed-off-by: Eduardo Silva <edsiper@gmail.com>

commit 697341887751ac74f0e477754b18229e7c05d952
Author: Eduardo Silva <edsiper@gmail.com>
Date:   Wed Apr 23 23:51:30 2014 -0600

    Socket: enable TCP_FASTOPEN only on Kernel >= 3.7.0
    
    Signed-off-by: Eduardo Silva <edsiper@gmail.com>

commit 2c38ddb3178aefbe9122702309d2bfa183a11ac4
Author: Eduardo Silva <edsiper@gmail.com>
Date:   Wed Apr 23 23:36:22 2014 -0600

    Kernel: new interface to query Linux Kernel version.
    
    This patch implements two things:
    
      1. Macro MK_KERNEL_VERSION() to return an unique representative integer
         of the Linux Kernel version given the 3 common values.
      2. Function mk_kernel_version() that returns the Kernel version from
         the running system.
    
    Signed-off-by: Eduardo Silva <edsiper@gmail.com>

commit 9b6f016df7d68f7a8fbd67b7f0b1aaf4eb597248
Merge: ccd9d24 30c050b
Author: Eduardo Silva <edsiper@gmail.com>
Date:   Tue Apr 15 09:27:33 2014 -0600

    Merge pull request #128 from tssavita/patch1_epoll
    
    Epoll: Reporting when event EPOLLRDHUP occurs for an fd

commit 30c050b50f9940d9743c7b711fd10310764e3d04
Author: Savita TS <savita.seetaraman5@gmail.com>
Date:   Tue Apr 15 17:21:56 2014 +0530

    Reporting when event EPOLLRDHUP occurs in a file descriptor registered in an epoll instance

commit ccd9d24e94e8cc5a0ca4053c1e9983edfe27dbfa
Merge: 06fb6c9 d253f45
Author: Eduardo Silva <edsiper@gmail.com>
Date:   Tue Apr 8 10:42:57 2014 -0600

    Merge pull request #127 from tssavita/http-conditionals
    
    HTTP: Removing unnecessary conditionals from src/mk_http.c

commit d253f454ef2e0f313ebbcdd40bd45b36b6253516
Author: Savita TS <savita.seetaraman5@gmail.com>
Date:   Tue Apr 8 17:54:38 2014 +0530

    Removing unnecessary conditionals from src/mk_http.c

commit 06fb6c9f8968fbc358551f571febc20a57a4f336
Merge: ba0fb33 635c130
Author: Eduardo Silva <edsiper@gmail.com>
Date:   Sun Apr 6 08:05:48 2014 -0600

    Merge pull request #125 from TamerTas/master
    
    HTTP: Fix comments' grammar and punctuation in mk_http.c

commit 635c1304dd803e611e673521f6b3f389de6438e9
Author: TamerTas <tamertas@outlook.com>
Date:   Sun Apr 6 14:25:29 2014 +0300

    HTTP: Fix comments' grammar and punctuation in mk_http.c

commit ba0fb3326560c2d8ba0af7fabfe6bcdf4c0d60ca
Author: Eduardo Silva <edsiper@gmail.com>
Date:   Wed Apr 2 23:31:17 2014 -0600

    Socket: handle new Kernel 3.14 tcp_autocorking feature.
    
    the server use the TCP_CORK feature to instruct the Kernel to
    wait for some data before dispatch it on the socket buffer. This
    is a common approach when sending HTTP response headers and then
    a content body (file data).
    
    The Linux Kernel 3.14 introduce a new feature called 'tcp autocorking',
    it basically do TCP_CORK by default based on specific conditions of
    each socket status. This is a good approach to let the Kernel to decide
    when it can be used and also it avoid user space to invoke two system
    calls to enable/disable the TCP_CORK.
    
    This patch makes the Server to validate if the new feature exists on the
    running Kernel and if is enabled, it will disable all manual corking done,
    for more details about how it works at Kernel level refer to the following
    patch:
    
        http://goo.gl/AMFIuI
    
    Note: on an older Kernel it will continue working as usual.
    
    Signed-off-by: Eduardo Silva <edsiper@gmail.com>

commit 1b486a5d0930d13b042d2e4128455a3e8bd9f022
Merge: 698f2a5 3946861
Author: Eduardo Silva <edsiper@gmail.com>
Date:   Wed Apr 2 13:32:47 2014 -0600

    Merge pull request #115 from kaspersky/master
    
    Monkey configuration: add program options for configuration paths

commit 698f2a554845659645835f6b978004f98ec7c708
Merge: 1b16611 7ddf7f9
Author: Eduardo Silva <edsiper@gmail.com>
Date:   Wed Apr 2 13:32:10 2014 -0600

    Merge pull request #123 from kaspersky/systemd
    
    Systemd: add unit file monkey.service

commit 7ddf7f99126487a94064e559edfd570c7e92b745
Author: Vladimir Cernov <gg.kaspersky@gmail.com>
Date:   Mon Mar 31 23:40:46 2014 +0300

    Systemd: add unit file monkey.service
    
    This patch adds a unit file for systemd init system, as described in issue #39.
    The installation of the unit file is triggered by the "--systemddir" passed to configure script, in the following way:
    $ ./configure                           # no systemd unit file deployed
    $ ./configure --systemddir              # Unit file systemd.service is created with default installation path "/lib/systemd/system"
    $ ./configure --systemddir=CUSTOM_PATH  # Unit file systemd.service is created with installation path "CUSTOM_PATH"
    
    The unit file is deployed is deployed using "make install" command, so you should also specify "--prefix" option for configure.
    
    I tested the patch on archlinux and fedora (systemd init system) deploying the unit file in different system paths. The following commands were successful:
    $ service monkey start
    $ systemctl start monkey.service
    
    I also tested on ubuntu (upstart init system), ensuring nothing is broken.
    
    Signed-off-by: Vladimir Cernov <gg.kaspersky@gmail.com>

commit 1b16611c40d763160a41646cabd0173a08d5ca00
Merge: d289b9d e74ff9f
Author: Eduardo Silva <edsiper@gmail.com>
Date:   Tue Apr 1 10:41:45 2014 -0600

    Merge pull request #122 from tssavita/sched_plugin
    
    Scheduler-Plugin: Moving and renaming function mk_sched_worker_info()

commit e74ff9f8f96726a4ef4db63032680fb2ca3cbf90
Author: Savita TS <savita.seetaraman5@gmail.com>
Date:   Tue Apr 1 21:53:47 2014 +0530

    Scheduler: Moving and renaming function mk_sched_worker_info() to mk_plugin_sched_get_thread_conf

commit d289b9d1e307e7ec8b865cfd2cb8d2cb6fd4b520
Merge: adc4ccc c253b36
Author: Eduardo Silva <edsiper@gmail.com>
Date:   Mon Mar 31 11:03:14 2014 -0600

    Merge branch 'master' of github.com:monkey/monkey

commit adc4ccc42780ff96e03257cb625d7441f556d7b0
Author: Eduardo Silva <edsiper@gmail.com>
Date:   Mon Mar 31 11:00:58 2014 -0600

    Memory: upgrade Jemalloc to 3.6.0
    
    Signed-off-by: Eduardo Silva <edsiper@gmail.com>

commit c253b3675fe90361fef91139127db7c76f55f32d
Author: Eduardo Silva <edsiper@gmail.com>
Date:   Sat Mar 29 11:22:53 2014 -0600

    Epoll: when adding a new FD, return status value
    
    Signed-off-by: Eduardo Silva <edsiper@gmail.com>

commit 3400e110bc3c5f6e24fce0ef1f3c0e77cd9d745f
Author: Eduardo Silva <edsiper@gmail.com>
Date:   Thu Mar 27 22:28:36 2014 -0600

    Vhost: skip files ending in '~' (editor backups)
    
    Signed-off-by: Eduardo Silva <edsiper@gmail.com>

commit 11d7459f9c719433244d0a5d7fd2bd7b61c77b0d
Merge: f5ce9bf 0f51130
Author: Eduardo Silva <edsiper@gmail.com>
Date:   Thu Mar 27 21:14:20 2014 -0600

    Merge pull request #120 from tssavita/iov_patch2
    
    IOV: store buffer type from char changed to void in function 'void _mk_iov_set_free'

commit 0f511308bd443f72b5bc7b451870a4e363ac8029
Author: Savita TS <savita.seetaraman5@gmail.com>
Date:   Fri Mar 28 04:33:51 2014 +0530

    IOV: store buffer type changed to void in function '_mk_iov_set_free'

commit f5ce9bfcb83e53ee6d043b52c918bc33272d00b9
Author: Eduardo Silva <edsiper@gmail.com>
Date:   Mon Mar 24 22:38:35 2014 -0600

    IOV: store buffer using void data type instead of char
    
    Signed-off-by: Eduardo Silva <edsiper@gmail.com>

commit 3946861b5b5b4e0755b47c39d0f1fbcc87995542
Author: Vladimir Cernov <gg.kaspersky@gmail.com>
Date:   Wed Mar 19 23:50:27 2014 +0200

    Monkey configuration: add program options for configuration paths
    
    This patch solves the issue #36.
    
    4 additional program arguments were added for specifying different
    configuration files and directories:
    
    -m, --mimes-conf-file # path to monkey.mime
    -P, --plugins-conf-dir # path to plugins configuration directory
    -l, --plugin-load-conf-file # path to plugins.load file
    -S, --sites-conf-dir # path to sites directory
    
    Each option has a default value.
    
    Monkey will try to interpret the options by prepending their values
    to default configuration directory. If the obtained path does not
    exist, the options will be treated as absolute paths.
    
    I tested using ./configure --prefix=path --plugdir=--path2 and
    default build. I was able to load different configuration files
    from custom locations with custom names, overriding the default
    names which were hardcoded in Monkey.
    
    The patch also contains an unrelated fix to:
    
    bin/monkey --confdir # was not working, while provided by --help
    
    Signed-off-by: Vladimir Cernov <gg.kaspersky@gmail.com>

commit 2d5e48d7697dd6b1ea3aaed48406d74e5d3ab097
Author: Eduardo Silva <edsiper@gmail.com>
Date:   Mon Mar 17 23:13:14 2014 -0600

    Epoll: Fix not catched peer close after events modifications (EPOLLRDHUP)
    
    If a socket created on the event loop did some events modifications and
    the peer closed the connection, the core did not trap this event. This
    patch re-enable the EPOLLRDHUP flag.
    
    Signed-off-by: Eduardo Silva <edsiper@gmail.com>

commit 102b45e247b4b46d7499f34d8e160f2a22d33eee
Author: Eduardo Silva <edsiper@gmail.com>
Date:   Sat Mar 15 15:51:55 2014 -0600

    Configure: fix broken plugins path on previous contributor patch
    
    Signed-off-by: Eduardo Silva <edsiper@gmail.com>

commit 42a3a8e95d02c14e5f2396e0932ec6b51e634b05
Author: Eduardo Silva <edsiper@gmail.com>
Date:   Mon Mar 10 13:22:05 2014 -0600

    Doc: update CONTRIBUTING with 'Commit Changes' info
    
    Signed-off-by: Eduardo Silva <edsiper@gmail.com>

commit cffdbc9ed802025a4f2b7a0894388f5ccb517b36
Merge: f0e78d7 5458096
Author: Eduardo Silva <edsiper@gmail.com>
Date:   Mon Mar 10 13:00:20 2014 -0600

    Merge pull request #109 from kaspersky/master
    
    Libmonkey: fix build and add test for mimetype

commit 545809698864309c9c49dc4874f7cdae4596082a
Author: Vladimir Cernov <gg.kaspersky@gmail.com>
Date:   Mon Mar 10 20:08:50 2014 +0200

    Libmonkey: fix build and add test for mimetype

commit f0e78d7f1e8e482035ded9e3199f2d575791c2f3
Author: Eduardo Silva <edsiper@gmail.com>
Date:   Sun Mar 9 21:31:48 2014 -0600

    Doc: Add CONTRIBUTING.md file
    
    Signed-off-by: Eduardo Silva <edsiper@gmail.com>

commit c17f98155104412e01e455874f63c81b04269944
Merge: b11236b 2eb580c
Author: Eduardo Silva <edsiper@gmail.com>
Date:   Sat Mar 8 16:02:29 2014 -0600

    Merge pull request #103 from matematik7/master
    
    Linux Trace: fix compile issue

commit 2eb580ce3ba890540461d9afc25e28204e5588f2
Author: matematik7 <domen.ipavec@z-v.si>
Date:   Sat Mar 8 22:29:35 2014 +0100

    Linux Trace: Fix compile issue

commit b11236bedd56672b56fc3aa235428455e6041071
Author: Eduardo Silva <edsiper@gmail.com>
Date:   Wed Mar 5 13:34:59 2014 -0600

    Debian: bump to v1.5.o (development)
    
    Signed-off-by: Eduardo Silva <edsiper@gmail.com>

commit fab1e41130f6ca76add03df8ed3f51b1325fcd24
Author: Eduardo Silva <edsiper@gmail.com>
Date:   Wed Mar 5 11:46:26 2014 -0600

    Lib: upgrade test lib version
    
    Signed-off-by: Eduardo Silva <edsiper@gmail.com>

commit a3a99b141d0508ef33593e10e4df52a3abdcf04d
Author: Eduardo Silva <edsiper@gmail.com>
Date:   Sun Mar 2 23:22:07 2014 -0600

    Epoll: testing new MK_EPOLL_HANGUP mode
    
    Signed-off-by: Eduardo Silva <edsiper@gmail.com>

commit a123d949d03906cfc9f27a5489dc3baa96b5338d
Author: Eduardo Silva <edsiper@gmail.com>
Date:   Thu Feb 6 11:31:41 2014 -0600

    Plugins: use new mk_ptr_t data type
    
    Signed-off-by: Eduardo Silva <edsiper@gmail.com>

commit b79465eeaf8ed06727b01fc8359edd9850a5b115
Author: Eduardo Silva <edsiper@gmail.com>
Date:   Thu Feb 6 11:30:01 2014 -0600

    Core: use new mk_ptr_t data type
    
    Signed-off-by: Eduardo Silva <edsiper@gmail.com>

commit b353825456fb522bf335ac831570e543e9e2dcf6
Author: Eduardo Silva <edsiper@gmail.com>
Date:   Thu Feb 6 11:26:49 2014 -0600

    Memory: rename datatype mk_pointer to mk_ptr_t
    
    Signed-off-by: Eduardo Silva <edsiper@gmail.com>

commit d77504ab34a4e8633bf643497c75cab2ae7c5843
Author: Eduardo Silva <edsiper@gmail.com>
Date:   Thu Feb 6 11:24:20 2014 -0600

    Development of v1.5 begins :)
    
    Signed-off-by: Eduardo Silva <edsiper@gmail.com>

commit 726b3e8bcb7b14b2adc9ea6e3b2e67c7de25c032
Author: Eduardo Silva <edsiper@gmail.com>
Date:   Tue Feb 4 08:04:22 2014 -0600

    Update ChangeLog for v1.4.0
    
    Signed-off-by: Eduardo Silva <edsiper@gmail.com>

commit f3638d9d6b7f781d0ad5dd87e04ee03c84271d90
Author: Eduardo Silva <edsiper@gmail.com>
Date:   Tue Feb 4 08:04:22 2014 -0600

    Monkey v1.4.0
    
    Signed-off-by: Eduardo Silva <edsiper@gmail.com>

commit 90e358af00312cce155c0bd5039522fc9739a1e4
Author: Eduardo Silva <edsiper@gmail.com>
Date:   Tue Feb 4 08:04:16 2014 -0600

    HTML: update home page
    
    Signed-off-by: Eduardo Silva <edsiper@gmail.com>

commit f35e15c8b7e153fe71db51f29643a0016c427984
Author: Eduardo Silva <edsiper@gmail.com>
Date:   Tue Feb 4 08:02:04 2014 -0600

    Proxy Reverse: fix config file
    
    Signed-off-by: Eduardo Silva <edsiper@gmail.com>

commit 35b00ab23b081b363c840b4457b3eee3a34373e0
Author: Eduardo Silva <edsiper@gmail.com>
Date:   Mon Feb 3 22:51:57 2014 -0600

    Debian: update rules for v1.4.0
    
    Signed-off-by: Eduardo Silva <edsiper@gmail.com>

commit a8ac7e28cb2aaea6da2086632e383835777b80fb
Merge: a31d354 dc4bc59
Author: Eduardo Silva <edsiper@gmail.com>
Date:   Wed Jan 29 08:09:22 2014 -0600

    Merge branch 'master' of github.com:monkey/monkey

commit a31d354f0bc22f4801a7927953c393ae2eb93bf5
Author: Eduardo Silva <edsiper@gmail.com>
Date:   Wed Jan 29 08:03:12 2014 -0600

    Lib: fix missing vhost header and API usage (#99)
    
    Signed-off-by: Eduardo Silva <edsiper@gmail.com>

commit dc4bc593202d008ec6e7531005be167211fc8ff0
Author: Eduardo Silva <edsiper@gmail.com>
Date:   Wed Jan 29 01:18:51 2014 -0600

    Jemalloc: upgrade commit to fix compiler warnings
    
    Signed-off-by: Eduardo Silva <edsiper@gmail.com>

commit c28781f3874325a0d3d54f054461804ae81af46b
Merge: 9b43aa6 9304105
Author: Eduardo Silva <edsiper@gmail.com>
Date:   Tue Jan 28 10:49:47 2014 -0600

    Merge branch 'master' of ssh://git.monkey-project.com/srv/git/monkey

commit 9b43aa61e36a465409317f1759816695a00f019c
Author: Eduardo Silva <edsiper@gmail.com>
Date:   Tue Jan 28 10:49:22 2014 -0600

    HTML: update index page for v1.4, codename Spider Monkey
    
    Signed-off-by: Eduardo Silva <edsiper@gmail.com>

commit 930410506d352377017b3465a75af62e503ae382
Author: Eduardo Silva <edsiper@gmail.com>
Date:   Mon Jan 27 20:45:31 2014 -0600

    Macro: rename MAX_PATH to MK_MAX_PATH
    
    Signed-off-by: Eduardo Silva <edsiper@gmail.com>

commit 4c5ad82cd04cbc9bfdcdd97bbdc491ab1ca8a61c
Author: Eduardo Silva <edsiper@gmail.com>
Date:   Mon Jan 27 15:30:03 2014 -0600

    Doc: Update kernel requirements
    
    Signed-off-by: Eduardo Silva <edsiper@gmail.com>

commit 7268167c2a022495d0395108480802adb33ece74
Author: Eduardo Silva <edsiper@gmail.com>
Date:   Mon Jan 27 15:26:13 2014 -0600

    Configure: update copyright
    
    Signed-off-by: Eduardo Silva <edsiper@gmail.com>

commit 2522c5fd50f387ea83b79e0a35f69b74d9daf63a
Author: Eduardo Silva <edsiper@gmail.com>
Date:   Mon Jan 27 12:50:04 2014 -0600

    Conf: make FDT configurable
    
    Signed-off-by: Eduardo Silva <edsiper@gmail.com>

commit a365d457d3fe6026b25aeb0524d8a34852994bd0
Author: Eduardo Silva <edsiper@gmail.com>
Date:   Mon Jan 27 11:10:12 2014 -0600

    Jemalloc: back to original 3.5.0
    
    Signed-off-by: Eduardo Silva <edsiper@gmail.com>

commit 80942638c24e837c33e43dffde28364d910ed2f2
Author: Eduardo Silva <edsiper@gmail.com>
Date:   Fri Jan 24 10:10:30 2014 -0600

    Scheduler: optimize access to thread specific data with __thread
    
    Signed-off-by: Eduardo Silva <edsiper@gmail.com>

commit aeb004b31b5b710561acd5782372d805aeba84c0
Author: Eduardo Silva <edsiper@gmail.com>
Date:   Thu Jan 23 22:32:20 2014 -0600

    Virtual Host: reduce hashed string on FDT.
    
    Signed-off-by: Eduardo Silva <edsiper@gmail.com>

commit 4efbc11bafeb56fbe2b4f0f6925671630ce84125
Author: Eduardo Silva <edsiper@gmail.com>
Date:   Thu Jan 23 21:53:37 2014 -0600

    Virtual Host: File Descriptor Table (FDT).
    
    The File Descriptor Table (FDT) aims to provide a mechanism to share
    open file descriptors at Virtual Host level with the goal of to reduce the
